!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE bicgstabl(l,n,x,nonzero_x,b,matvec,l_precond,pcnd,toler,mxmatvec,info)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**************************** bicgstabl: (Preconditioned Real) Bi-Conjugate Gradient Stabilized solver ****************************!
!****************************  Iterative method for solving real non-symmetric linear system: A*x=b *******************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.3
!*** Released:  Jun 14, 2012


!******************************************************!
! Parameter list:
!******************************************************!
!
! l         == (input) INTEGER BiCGstab's dimension
! n         == (input) INTEGER size of the system to solve 
! x         == (input/output) DOUBLE PRECISION array dimension n, initial guess on input, solution on output
! nonzero_x == (input) LOGICAL, indicates whether the initial guess is zero vector
!              If nonzero_x == .false., one matrix-vector multiplication will be saved
! b         == (input) DOUBLE PRECISION array dimension n, right-hand side (rhs) vector
! matvec    == (input) EXTERNAL name of matrix-vector subroutine to deliver y:=A*x by CALL matvec(n,x,y)
! l_precond == (input) EXTERNAL name of subroutine to perform a left preconditioner by CALL l_precond(n,x)
!              This call delivers solution to M*y=x, M is the left preconditioning matrix
!              x is rhs on input, and solution y is written in x on output
! pcnd      == (input) LOGICAL, indicates whether the preconditioner exist
!              If pcnd == .true., there is a preconditioner otherwise pcnd is .false.
! toler     == (input) DOUBLE PRECISION tolerance for the relative residual norm stopping criterion: ||r_k|| <= toler*||r_0||
! mxmatvec  == (input/output) INTEGER.  On input: maximum number of matrix-vector multiplications allowed
!                                      On output: actual number of matrix-vector multiplications achieved
! work      == (workspace) DOUBLE PRECISION array dimension (n,3+2*(l+1))
! rwork     == (workspace) DOUBLE PRECISION array dimension (l+1,3+2*(l+1))
! iwork     == (workspace) INTEGER array dimension (l+1)
! info      == (output) INTEGER.  Info = 0 in case of normal computations
!              info = m < 0 - means paramater number m has an illegal value
!              info = 1 - means no convergence achieved (stopping criterion is not fulfilled)
!              info = 2 - means breakdown of the algorithm (try to enlarge parameter l to get rid of this)


!******************************************************!
! Original Fortran 77 routine name and parameters:
!******************************************************!
!
!      subroutine bistbl (l, n, x, b, mv, solve, tol, mxmv, work, ldw, rwork, ldrw, iwork, info)
!
! subroutine bistbl v1.0 1995 by D.R. Fokkema.
!
! Parameter list (by M.Botchev, October, 1997):
!
! l      == (input) INTEGER BiCGstab's dimension
! n      == (input) INTEGER size of the system to solve 
! x      == (input/output) DOUBLE PRECISION array dimension n
!           initial guess on input, solution on output
! b      == (input) DOUBLE PRECISION array dimension n
!           right-hand side (rhs) vector
! mv     == (input) EXTERNAL name of matrix vector subroutine
!           to deliver y:=A*x by CALL matvec(n,x,y)
! solve  == (input) EXTERNAL name of subroutine to perform
!           a left preconditioner solve by CALL solve(n,x). This call 
!           delivers solution to M*x=x, M is the left preconditioning 
!           matrix, x is rhs on input and solution on output.
! tol    == (input) DOUBLE PRECISION tolerance for the relative
!           residual norm stopping criterion: ||r_k|| <= toler*||r_0||
! mxmv   == (input/output) INTEGER.  On input: maximum number of matrix 
!           vector multiplications allowed to be done.  On input: 
!           actual number of matrix vector multiplications done
! work   == (workspace) DOUBLE PRECISION array dimension (n,3+2*(l+1))
! ldw    == (input) INTEGER leading dimension of work (??)
! rwork  == (workspace) DOUBLE PRECISION array dimension (l+1,3+2*(l+1))
! ldrw   == (input) INTEGER leading dimension of rwork (??)
! iwork  == (workspace) INTEGER array dimension (l+1)
! info   == (output) INTEGER.  Info = 0 in case of normal computations
!           and 
!           info = m < 0 - means paramater number m has an illegal value
!           info = 1 - means no convergence achieved (stopping criterion
!           is not fulfilled)
!           info = 2 - means breakdown of the algorithm (try to enlarge
!           parameter l to get rid of this)


USE KINDS

IMPLICIT NONE

! Parameters:
logical,          intent( in  ) :: nonzero_x,pcnd
integer(kind=k9), intent( in  ) :: l,n
integer(kind=k9), intent(inout) :: mxmatvec
integer(kind=k9), intent( out ) :: info
real   (kind=dp), intent(inout) :: x(n)
real   (kind=dp), intent( in  ) :: b(n)
real   (kind=dp), intent(inout) :: toler

!----------------------------------------------------------------------------------------------------------------------------------!
INTERFACE
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
  SUBROUTINE matvec(m,x,y)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!******************************************** Compute the Matrix vector product: y=A*x ********************************************!
!**********************************************************************************************************************************!

   USE KINDS

   IMPLICIT NONE
   
    integer(kind=k9), intent(in ) :: m    ! m == Dimension of vectors "x" and "y"
    real   (kind=dp), intent(in ) :: x(m)
    real   (kind=dp), intent(out) :: y(m) ! y = A*x

!----------------------------------------------------------------------------------------------------------------------------------!    
  END SUBROUTINE matvec
!----------------------------------------------------------------------------------------------------------------------------------!  


!----------------------------------------------------------------------------------------------------------------------------------!
  SUBROUTINE l_precond(m,x)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!************************************************** Apply a left preconditioner ***************************************************!
!************************************************** i.e. solve the system: M*y=x **************************************************!
!**********************************************************************************************************************************!

! Note: M is a left preconditioner
! Note: The solution y is written in x on output

   USE KINDS

   IMPLICIT NONE
   
    integer(kind=k9), intent(in ) :: m ! m == Dimension of the vector "x"
    real   (kind=dp), intent(inout) :: x(m)

!----------------------------------------------------------------------------------------------------------------------------------!    
  END SUBROUTINE l_precond
!----------------------------------------------------------------------------------------------------------------------------------!  


!----------------------------------------------------------------------------------------------------------------------------------!
END INTERFACE
!----------------------------------------------------------------------------------------------------------------------------------!

! Local variables:
logical          :: rcmp, xpdt
integer(kind=k9) :: i, j, k, nmatvec,wsz,lp1,lm1,alloc_st
integer(kind=k9), pointer :: iwork(:) ! iwork(l+1)
real   (kind=dp) :: rnrm0, rnrm
real   (kind=dp) :: mxnrmx, mxnrmr
real   (kind=dp) :: kappa0, kappal
real   (kind=dp), pointer :: work(:,:), rwork(:,:) ! work(n,3+2*(l+1)), rwork(l+1,3+2*(l+1))
real   (kind=dp) :: alpha, beta, omega, rho0, rho1, sigma
real   (kind=dp) :: varrho, hatgamma

! Aliases for the parts of the work array:
integer(kind=k9) :: r, u, xp, bp, zz, y0, yl, y

! Constants:
real(kind=dp),    parameter :: zero = 0.0_dp, one = 1.0_dp, delta = 1.0E-2_dp


!---------------------------------------!
!     .. BLAS and LAPACK ..
!---------------------------------------!
!     subroutine daxpy
!     subroutine dcopy
!     subroutine dgemv
!     subroutine dgetrf
!     subroutine dgetrs
!     subroutine dlacpy
!     subroutine dlaset
!     subroutine dsymv
!     function ddot
!     function dnrm2
!
real(kind=dp),    external :: dnrm2, ddot
!
!     .. Intrinsic ..
!
!      intrinsic dabs, max, sign, dsqrt


!     ===========================
!     .. Executable Statements ..
!     ===========================

      info = 0; lp1 = l+1;
      wsz = 3+2*lp1; 

      if (l < 1) info = -1
      if (n < 1) info = -2
      if (toler <= zero) info = -7
      if (mxmatvec < 0) info = -8

      r = 2; u = 2+lp1 ! r = 2; u = r+lp1
      xp = u+lp1
      bp = xp+1

      zz = 1+lp1
      y0 = zz+lp1
      yl = y0+1
      y = yl+1

      if (info /= 0) return


!     --- Initialize first residual
    lm1 = l-1
    allocate(work(n,wsz),STAT=alloc_st) 
    if ( alloc_st /= 0 ) then  ! If work is not successfully allocated
       write(*,*)'bicgstabl: Allocate array "work" failed with Status=',alloc_st
       stop
    endif
    allocate(rwork(lp1,wsz),STAT=alloc_st) 
    if ( alloc_st /= 0 ) then  ! If rwork is not successfully allocated
       write(*,*)'bicgstabl: Allocate array "rwork" failed with Status=',alloc_st
       stop
    endif
    allocate(iwork(lp1),STAT=alloc_st) 
    if ( alloc_st /= 0 ) then  ! If iwork is not successfully allocated
       write(*,*)'bicgstabl: Allocate array "iwork" failed with Status=',alloc_st
       stop
    endif

    if (nonzero_x) then
      call matvec(n, x, work(1:n,r))
      do i=1,n
         work(i,r) = b(i) - work(i,r) ! work(:,r) = b - work(:,r)
      end do
      nmatvec = 1
    else
      do i=1,n
         work(i,r) = b(i) ! work(:,r) = b
      end do
      nmatvec = 0
    end if

    if (pcnd) then
     call l_precond(n, work(1:n,r))
    endif 


!     --- Initialize iteration loop
      call dcopy(n, work(1,r), 1, work(1,1), 1) ! work(:,1) = work(:,r)
      call dcopy(n, work(1,r), 1, work(1,bp), 1) ! work(:,bp) = work(:,r)
      call dcopy(n, x, 1, work(1,xp), 1)  ! work(:,xp) = x
      call dlaset('n', n, 1, zero, zero, x, 1) ! x = 0.0
      rnrm0 = dnrm2(n, work(1,r), 1) ! rnrm0 = sqrt(dot_product(work(:,r),work(:,r)))
      rnrm = rnrm0

      mxnrmx = rnrm0; mxnrmr = rnrm0
      rcmp = .false.; xpdt = .false.
      alpha = zero; omega = one; sigma = one; rho0 = one


!     --- Iterate
      do while (rnrm>toler*rnrm0 .and. nmatvec<mxmatvec)

!     =====================
!     --- The BiCG part ---
!     =====================

	 rho0 = -omega*rho0
	 do k=1,l
	    rho1 = ddot(n, work(1,1), 1, work(1,r+k-1), 1) ! rho1 = dot_product(work(1:n,1), work(1:n,r+k-1))
	    if (rho0 == zero) then
	       info = 2
	       return
	    endif
	    beta = alpha*(rho1/rho0)
	    rho0 = rho1
	    do j=0,k-1
	       do i=1,n
		  work(i,u+j) = work(i,r+j) - beta*work(i,u+j)
	       enddo
	    enddo
	    call matvec(n, work(1:n,u+k-1), work(1:n,u+k))
	    if (pcnd) call l_precond(n, work(1:n,u+k))
	    nmatvec = nmatvec+1

	    sigma = ddot(n, work(1,1), 1, work(1,u+k), 1) ! sigma = dot_product(work(1:n,1), work(1:n,u+k))
	    if (sigma == zero) then
	       info = 2
	       return
	    endif
	    alpha = rho1/sigma
	    call daxpy(n, alpha, work(1,u), 1, x, 1) ! x = alpha*work(1:n,u) + x
	    do j=0,k-1
	       call daxpy(n,(-alpha),work(1,u+j+1),1,work(1,r+j),1) ! work(1:n,r+j) = -alpha*work(1:n,u+j+1) + work(1:n,r+j)
	    enddo
	    call matvec(n, work(1:n,r+k-1), work(1:n,r+k))
	    if (pcnd) call l_precond(n, work(1:n,r+k))
	    nmatvec = nmatvec+1

	    rnrm = dnrm2(n, work(1,r), 1) ! rnrm = sqrt(dot_product(work(1:n,r),work(1:n,r)))
	    mxnrmx = max(mxnrmx, rnrm); mxnrmr = max(mxnrmr, rnrm)
	 enddo


!     ==================================
!     --- The convex polynomial part ---
!     ==================================

!        --- Z = R'R

	 do i=1,lp1
	    call dgemv('t',n,lp1-(i-1),one,work(1,r+i-1),n,work(1,r+i-1),1,zero,rwork(i,i),1) ! The lower triangular part of Z is computed
	    ! rwork(i:l+1,i) = matmul(transpose(work(1:n,r+i-1:r+l)),work(1:n,r+i-1))
	    
	    call dcopy(l-(i-1),rwork(i+1,i),1,rwork(i,1+i),lp1) ! Compute the strictly upper triangular part of Z knowing that Z^T=Z
	    ! rwork(i,1+i:l+1) = rwork(i+1:l+1,i)
	 enddo

	 call dlacpy('n',lp1,lp1,rwork(1,1),lp1,rwork(1,zz),lp1) ! rwork(1:l+1,zz:zz+l) = rwork(1:l+1,1:l+1) <==> duplicate
	 call dgetrf(lm1,lm1,rwork(2,zz+1),lp1,iwork,info) ! LU factorization


!        --- tilde r0 and tilde rl (small vectors)
	 rwork(1,y0) = -one
	 call dcopy(lm1,rwork(2,1),1,rwork(2,y0),1) ! rwork(2:l,y0) = rwork(2:l,1)
	 call dgetrs('n',lm1,1,rwork(2,zz+1),lp1,iwork,rwork(2,y0),lp1,info)
	 rwork(lp1,y0) = zero

	 rwork(1,yl) = zero
	 call dcopy(lm1,rwork(2,lp1),1,rwork(2,yl),1) ! rwork(2:l,yl) = rwork(2:l,1+l)
	 call dgetrs('n',lm1,1,rwork(2,zz+1),lp1,iwork,rwork(2,yl),lp1,info)
	 rwork(lp1,yl) = -one


!        --- Convex combination
	 call dsymv('u',lp1,one,rwork(1,1),lp1,rwork(1,y0),1,zero,rwork(1,y),1) ! rwork(1:l+1,y) = matmul(rwork(1:l+1,1:l+1),rwork(1:l+1,y0))
	 kappa0 = dsqrt(ddot(lp1,rwork(1,y0),1,rwork(1,y),1)) ! kappa0 = sqrt(dot_product(rwork(1:l+1,y0),rwork(1:l+1,y)))

	 call dsymv('u',lp1,one,rwork(1,1),lp1,rwork(1,yl),1,zero,rwork(1,y),1) ! rwork(1:l+1,y) = matmul(rwork(1:l+1,1:l+1),rwork(1:l+1,yl))
	 kappal = dsqrt(ddot(lp1,rwork(1,yl),1,rwork(1,y),1)) ! kappal = sqrt(dot_product(rwork(1:l+1,yl),rwork(1:l+1,y)))

	 call dsymv('u',lp1,one,rwork(1,1),lp1,rwork(1,y0),1,zero,rwork(1,y),1) ! rwork(1:l+1,y) = matmul(rwork(1:l+1,1:l+1),rwork(1:l+1,y0))
	 varrho = ddot(lp1,rwork(1,yl),1,rwork(1,y),1)/(kappa0*kappal)

	 hatgamma = sign(1.0_dp,varrho)*max(dabs(varrho),0.7_dp)*(kappa0/kappal)
	 call daxpy(lp1,(-hatgamma),rwork(1,yl),1,rwork(1,y0),1) ! rwork(1:l+1,y0) = rwork(1:l+1,y0) - hatgamma*rwork(1:l+1,yl)


!        --- Update
	 omega = rwork(lp1,y0)
	 call dgemv('n',n,l,(-one),work(1,u+1),n,rwork(2,y0),1,one,work(1,u),1) ! work(1:n,u) = work(1:n,u) - matmul(work(1:n,u+1:u+l),rwork(2:l+1,y0))
	 call dgemv('n',n,l,one,work(1,r),n,rwork(2,y0),1,one,x,1) ! x = x + matmul(work(1:n,r:r+l-1),rwork(2:l+1,y0))
	 call dgemv('n',n,l,(-one),work(1,r+1),n,rwork(2,y0),1,one,work(1,r),1) ! work(1:n,r) = work(1:n,r) - matmul(work(1:n,r+1:r+l),rwork(2:l+1,y0))

!** y0 has changed; compute y=Z*y0 once more
	 call dsymv('u',lp1,one,rwork(1,1),lp1,rwork(1,y0),1,zero,rwork(1,y),1) ! rwork(1:l+1,y) = matmul(rwork(1:l+1,1:l+1),rwork(1:l+1,y0))
	 rnrm = dsqrt(ddot(lp1,rwork(1,y0),1,rwork(1,y),1)) ! rnrm = sqrt(dot_product(rwork(1:l+1,y0),rwork(1:l+1,y)))


!     ================================
!     --- The reliable update part ---
!     ================================
!
	 mxnrmx = max(mxnrmx, rnrm); mxnrmr = max(mxnrmr, rnrm)
	 xpdt = (rnrm<delta*rnrm0 .and. rnrm0<mxnrmx)
	 rcmp = ((rnrm<delta*mxnrmr .and. rnrm0<mxnrmr) .or. xpdt)
	 if (rcmp) then
	    call matvec(n, x, work(1:n,r))
	    if (pcnd) call l_precond(n, work(1:n,r))
            nmatvec = nmatvec + 1

	    do i=1,n
	       work(i,r) =  work(i,bp) - work(i,r) ! work(1:n,r) =  work(1:n,bp) - work(1:n,r)
	    enddo
	    mxnrmr = rnrm
	    if (xpdt) then
	       call daxpy(n, one, x, 1, work(1,xp), 1) ! work(1:n,xp) = x + work(1:n,xp)
	       call dlaset('n', n, 1, zero, zero, x, 1) ! x = 0.0
	       call dcopy(n, work(1,r), 1, work(1,bp), 1) ! work(1:n,bp) = work(1:n,r)
	       mxnrmx = rnrm
	    endif
	 endif
      enddo

      deallocate(rwork,iwork)
!     =========================
!     --- End of iterations ---
!     =========================

      call daxpy(n, one, work(1,xp), 1, x, 1) ! x = work(1:n,xp) + x
      if (rnrm>toler*rnrm0) info = 1


!** compute the true residual:
! --------------------- One matvec can be saved by commenting out this:
!     --- Check stopping criterion
      call matvec(n, x, work(1:n,r))
      do i=1,n
	 work(i,r) = b(i) - work(i,r) ! work(1:n,r) = b - work(1:n,r)   
      enddo
      if (pcnd) call l_precond (n, work(1:n,r))
      rnrm = dnrm2(n, work(1,r), 1) ! rnrm = sqrt(dot_product(work(1:n,r),work(1:n,r)))
      nmatvec = nmatvec+1
! --------------------- One matvec can be saved by commenting out this:
      toler = rnrm/rnrm0; mxmatvec = nmatvec
      
      deallocate(work)

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE bicgstabl
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_lap_iex_int_e(elP,elQ)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!*******************************  EXact Inner integral with linear distribution on a flat triangle  *******************************!
!**************************************************  Edge-adjacent integration  ***************************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


USE KINDS
USE PARAMS,   ONLY: pi           ! pi = 3.1415926535897932
USE SRF_GEOM, ONLY: mx_nd_elt    ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: belt         ! belt(:,i) == Global indices of boundary nodes on the i-th element
USE SRF_GEOM, ONLY: bnd          ! bnd(:,i) == Cartesian coordinates of the i-th boundary node
USE SRF_GEOM, ONLY: xeP,xeQ      ! xeP(:,k) == Cartesian coordinates of the k-th node of element P
			         ! xeQ(:,k) == Cartesian coordinates of the k-th node of element Q
USE SRF_GEOM, ONLY: PQmLocId     ! PQmLocId(1) == Local index of the edge of element P that is adjacent to element Q
			         ! PQmLocId(2) == Local index of the edge of element Q that is adjacent to element P
USE SRF_GEOM, ONLY: LocCBasisElt ! LocCBasisElt(1:9,k) == Local Companion Basis associated with the k-th boundary element
USE SRF_GEOM, ONLY: thetaElt     ! thetaElt(i,k) == Angle at the i-th vertex of the k-th boundary element
USE SRF_GEOM, ONLY: pp,qq        ! pp(k) == Global index of the k-th node of the boundary element P
				 ! qq(k) == Global index of the k-th node of the boundary element Q
USE DISCR_BIE,ONLY: int_p,int_f  ! int_p == Local contribution for potential influence matrix
				 ! int_f == Local contribution for flux influence matrix
USE DISCR_BIE,ONLY: int_r        ! int_r == Local contribution for potential/flux influence matrix
USE DISCR_BIE,ONLY: h,g          ! h == Potential influence matrix, g == Flux influence matrix


IMPLICIT NONE

 integer(kind=k9), intent(in) :: elP ! elP == Global index of the outer boundary element P
 integer(kind=k9), intent(in) :: elQ ! elQ == Global index of the inner boundary element Q

 integer(kind=k9) :: k,i,row,col
 integer(kind=k9) :: PcoincidentSide,QcoincidentSide
 real   (kind=dp) :: e1P(3),e2P(3),e3P(3) ! Orthonormal companion basis associated with element P
 real   (kind=dp) :: e1Q(3),e2Q(3),e3Q(3) ! Orthonormal companion basis associated with element Q
 real   (kind=dp) :: e1(3),e2(3) ! Orthonormal local basis
 real   (kind=dp) :: aP,cP ! Geometric parameters of element P: bP = base, aP = height, 
 			   ! cP = relative position of the 3rd vertex of element P in the local basis {e1P,e2P,e3P}
 real   (kind=dp) :: aQ,bQ,cQ ! Geometric parameters of element Q: bQ = bP = length of the coincident edge, aQ = height,
 			      ! cQ = relative position of the 3rd vertex of element Q in the local basis {e1Q,e2Q,e3Q}
 real   (kind=dp) :: QPTransitionMtrx(2,2)
 real   (kind=dp) :: vij(3,2),theta(3),alpha(3),alphaEltP(3),calpk,salpk,x



    PcoincidentSide = PQmLocId(1); QcoincidentSide = PQmLocId(2) ! Side "PcoincidentSide" of element P coincides
    								 ! with Side "QcoincidentSide" of element Q


!*** Geometry of the inner element Q
    loop0a: do k=1,mx_nd_elt ! Loop over the nodes of element Q
       qq(k) = belt(k,elQ) ! qq(k) == Global index of the k-th node of the inner boundary element Q
       loop0b: do i=1,3 ! Loop over all components
          xeQ(i,k) = bnd(i,qq(k)) ! xeQ(:,k) == Cartesian coordinates of the k-th node of element Q
       enddo loop0b
    enddo loop0a

     e1(1) = LocCBasisElt(1,elQ);  e1(2) = LocCBasisElt(2,elQ);  e1(3) = LocCBasisElt(3,elQ)
     e2(1) = LocCBasisElt(4,elQ);  e2(2) = LocCBasisElt(5,elQ);  e2(3) = LocCBasisElt(6,elQ)
    e3Q(1) = LocCBasisElt(7,elQ); e3Q(2) = LocCBasisElt(8,elQ); e3Q(3) = LocCBasisElt(9,elQ)
    
    theta(1) = thetaElt(1,elQ); theta(2) = thetaElt(2,elQ); theta(3) = thetaElt(3,elQ)

    alpha(1) = 0.0_dp; alpha(2) = pi-theta(2); alpha(3) = pi+theta(1)

!*** Reorder the node numbers of element Q so that the edge of element Q specified by the nodes with local
!*** indices 1 and 2 respectively coincides with the edge of element Q that is adjacent to element P, i.e.,
!*** consider the permutation of node numbers of the inner element Q
     if (QcoincidentSide == 1) then ! (/1,2,3/) ==> (/1,2,3/)

	  loop1: do k=1,3 ! Loop over all components
	     e1Q(k) = e1(k); e2Q(k) = e2(k)
	  enddo loop1

     elseif(QcoincidentSide == 2) then ! (/1,2,3/) ==> (/2,3,1/)

	  loop2: do k=1,3 ! Loop over all components
	     x = xeQ(k,1)
	     xeQ(k,1) = xeQ(k,2)
	     xeQ(k,2) = xeQ(k,3)
	     xeQ(k,3) = x
	  enddo loop2
	  k = qq(1);     x = theta(1)
	  qq(1) = qq(2); theta(1) = theta(2)
	  qq(2) = qq(3); theta(2) = theta(3)
	  qq(3) = k;     theta(3) = x

	calpk = dcos(alpha(2)); salpk = dsin(alpha(2))

        loop3: do k=1,3 ! loop over all components
           e1Q(k) = calpk*e1(k) + salpk*e2(k)
           e2Q(k) = calpk*e2(k) - salpk*e1(k)
        enddo loop3
	
     else ! QcoincidentSide == 3: (/1,2,3/) ==> (/3,1,2/)

	  loop4: do k=1,3 ! Loop over all components
	     x = xeQ(k,1)
	     xeQ(k,1) = xeQ(k,3)
	     xeQ(k,3) = xeQ(k,2)
	     xeQ(k,2) = x
	  enddo loop4
	  k = qq(1);     x = theta(1)
	  qq(1) = qq(3); theta(1) = theta(3)
	  qq(3) = qq(2); theta(3) = theta(2)
	  qq(2) = k;     theta(2) = x

	calpk = dcos(alpha(3)); salpk = dsin(alpha(3))

        loop5: do k=1,3 ! loop over all components
           e1Q(k) = calpk*e1(k) + salpk*e2(k)
           e2Q(k) = calpk*e2(k) - salpk*e1(k)
        enddo loop5

     endif

    loop6: do k=1,3 ! Loop over all components
       vij(k,1) = xeQ(k,2) - xeQ(k,1) ! y2-y1 <== Side 1 of element Q
       vij(k,2) = xeQ(k,3) - xeQ(k,1) ! y3-y1 <== Side 3 of element Q
    enddo loop6

    bQ = vij(1,1)*e1Q(1) + vij(2,1)*e1Q(2) + vij(3,1)*e1Q(3) ! bQ>0.0_dp always
    aQ = vij(1,2)*e2Q(1) + vij(2,2)*e2Q(2) + vij(3,2)*e2Q(3) ! aQ>0.0_dp always
    cQ = vij(1,2)*e1Q(1) + vij(2,2)*e1Q(2) + vij(3,2)*e1Q(3)    


!*** Geometry of the outer element P
    loop7a: do k=1,mx_nd_elt ! Loop over the nodes of element P
       pp(k) = belt(k,elP) ! pp(k) == Global index of the k-th node of the outer boundary element P
       loop7b: do i=1,3 ! Loop over all components
	  xeP(i,k) = bnd(i,pp(k)) ! xeP(:,k) == Cartesian coordinates of the k-th node of element P
       enddo loop7b   
    enddo loop7a

     e1(1) = LocCBasisElt(1,elP);  e1(2) = LocCBasisElt(2,elP);  e1(3) = LocCBasisElt(3,elP)
     e2(1) = LocCBasisElt(4,elP);  e2(2) = LocCBasisElt(5,elP);  e2(3) = LocCBasisElt(6,elP)
    e3P(1) = LocCBasisElt(7,elP); e3P(2) = LocCBasisElt(8,elP); e3P(3) = LocCBasisElt(9,elP)

    alphaEltP(1) = 0.0_dp; alphaEltP(2) = pi-thetaElt(2,elP); alphaEltP(3) = pi+thetaElt(1,elP)

!*** Reorder the node numbers of element P so that the edge of element P specified by the nodes with local
!*** indices 1 and 2 respectively coincides with the edge of element P that is adjacent to element Q, i.e.,
!*** consider the permutation of node numbers of the outer element P
     if (PcoincidentSide == 1) then ! (/1,2,3/) ==> (/1,2,3/)

	  loop8: do k=1,3 ! Loop over all components
	     e1P(k) = e1(k); e2P(k) = e2(k)
	  enddo loop8

     elseif(PcoincidentSide == 2) then ! (/1,2,3/) ==> (/2,3,1/)

	  loop9: do k=1,3 ! Loop over all components
	     x = xeP(k,1)
	     xeP(k,1) = xeP(k,2)
	     xeP(k,2) = xeP(k,3)
	     xeP(k,3) = x
	  enddo loop9
	  k = pp(1)
	  pp(1) = pp(2)
	  pp(2) = pp(3)
	  pp(3) = k

        calpk = dcos(alphaEltP(2)); salpk = dsin(alphaEltP(2))

        loop10: do k=1,3 ! loop over all components
           e1P(k) = calpk*e1(k) + salpk*e2(k)
           e2P(k) = calpk*e2(k) - salpk*e1(k)
        enddo loop10

     else ! PcoincidentSide == 3: (/1,2,3/) ==> (/3,1,2/)

	  loop11: do k=1,3 ! Loop over all components
	     x = xeP(k,1)
	     xeP(k,1) = xeP(k,3)
	     xeP(k,3) = xeP(k,2)
	     xeP(k,2) = x
	  enddo loop11
	  k = pp(1)
	  pp(1) = pp(3)
	  pp(3) = pp(2)
	  pp(2) = k

        calpk = dcos(alphaEltP(3)); salpk = dsin(alphaEltP(3))

        loop12: do k=1,3 ! loop over all components
           e1P(k) = calpk*e1(k) + salpk*e2(k)
           e2P(k) = calpk*e2(k) - salpk*e1(k)
        enddo loop12

     endif

    loop13: do k=1,3 ! Loop over all components
       vij(k,2) = xeP(k,3) - xeP(k,2) ! x3-x2 <== Side 2 of element P
    enddo loop13
    
    cP = vij(1,2)*e1P(1) + vij(2,2)*e1P(2) + vij(3,2)*e1P(3)
    aP = vij(1,2)*e2P(1) + vij(2,2)*e2P(2) + vij(3,2)*e2P(3)


!*** C_ij == Transition matrix from {e1Q,e2Q,e3Q} to {e1P,e2P,e3P}
!*** Projection (Transformation) of e2P to coordinate system {e1Q,e2Q,e3Q} local to element Q
          QPTransitionMtrx(1,1) = e2P(1)*e2Q(1) + e2P(2)*e2Q(2) + e2P(3)*e2Q(3) ! C_22
	  QPTransitionMtrx(2,1) = e2P(1)*e3Q(1) + e2P(2)*e3Q(2) + e2P(3)*e3Q(3) ! C_32

!*** Projection (Transformation) of e3P to coordinate system {e1Q,e2Q,e3Q} local to element Q
          QPTransitionMtrx(1,2) = e3P(1)*e2Q(1) + e3P(2)*e2Q(2) + e3P(3)*e2Q(3) ! C_23
	  QPTransitionMtrx(2,2) = e3P(1)*e3Q(1) + e3P(2)*e3Q(2) + e3P(3)*e3Q(3) ! C_33

     call sing_edg(aP,cP,aQ,bQ,cQ,theta,QPTransitionMtrx,int_p,int_f,int_r) ! Integration for edge-adjacent elements

     loop15a: do col=1,mx_nd_elt ! Loop over the nodes of element Q
        loop15b: do row=1,mx_nd_elt ! Loop over the nodes of element P
           h(pp(row),qq(col)) = h(pp(row),qq(col)) + int_p(row,col)
	   g(pp(row),qq(col)) = g(pp(row),qq(col)) + int_f(row,col)

!*** Reverse Kernel
           h(qq(col),pp(row)) = h(qq(col),pp(row)) + int_r(row,col)
	   g(qq(col),pp(row)) = g(qq(col),pp(row)) + int_f(row,col)
        enddo loop15b
     enddo loop15a
		 
!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_lap_iex_int_e
!----------------------------------------------------------------------------------------------------------------------------------!


!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE sing_edg(a,c,aQ,b,cQ,theta,QPTM,int_p,int_f,int_r)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!*******************************  EXact Inner integral with linear distribution on a flat triangle  *******************************!
!***************************************  Singular integration for edge-adjacent elements  ****************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


USE KINDS
USE PARAMS,   ONLY: pi,gm_eps   ! pi = 3.1415926535897932, gm_eps == Tolerance on the geometry
USE SRF_GEOM, ONLY: mx_nd_elt   ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: shfe1,shfe2 ! shfe1(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for edge-adjacent case: E'
				! shfe2(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for edge-adjacent case: E"
USE GAUSS1D,  ONLY: ng1,xi1     ! ng1 == Number of Gauss-Legendre points over a segment [0,1] for Singular integrations 
			        ! xi1 == Gauss-Legendre points over a segment [0,1] for Singular integrations
USE GAUSS1D,  ONLY: wwg1        ! wwg1(k,i) = wg1(i)*wg1(k), where wg1(k) is the k-th Gauss-Legendre weight factor corresponding to xi1(k)


IMPLICIT NONE

 real   (kind=dp), intent(in ) :: a,b,c ! Geometric parameters of element P: b = length of the coincident edge for elements P and Q,
 			                ! a = height, c = relative position of the 3rd vertex of element P
 real   (kind=dp), intent(in ) :: aQ,cQ ! Geometric parameters of element Q: b = length of the coincident edge for elements P and Q,
 			                ! aQ = height, cQ = relative position of the 3rd vertex of element Q
 real   (kind=dp), intent(in ) :: theta(3)  ! theta(i) == Angle at the i-th vertex of element Q
 real   (kind=dp), intent(in ) :: QPTM(2,2) ! Transition matrix from element Q to element P
 real   (kind=dp), intent(out) :: int_p(mx_nd_elt,mx_nd_elt) ! int_p == Singular contribution to potential influence matrix H
 real   (kind=dp), intent(out) :: int_f(mx_nd_elt,mx_nd_elt) ! int_f == Singular contribution to flux influence matrix G
 real   (kind=dp), intent(out) :: int_r(mx_nd_elt,mx_nd_elt) ! int_r == Singular contribution to potential influence matrix H: Reverse kernel

 integer(kind=k9) :: k,i,ii,kk,th_id
 real   (kind=dp) :: dlt,a_rh2p2,a_rh3p2,a_rh2p2x3,a_rh3p2x3,c_rh2p2,bpc_rh3p2
 real   (kind=dp) :: ap2,ap3,ap4,bp2,bp3,bp4,cp2,cp3,cp4,rh2,rh3,rh2p2,rh2p3,rh2p4,rh2p6,rh3p2,rh3p3,rh3p4,rh3p6,cQmb
 real   (kind=dp) :: ln1,ln2,ln3,bc,bpc,bmc,bpcp2,bc_rh2,bc_rh2s,bbpc_rh3,bbpc_rh3s,bmrh2,bmrh3,ln2_rh2,ln3_rh3
 real   (kind=dp) :: kP2,kP3 ! kP2 == Slope of Edge2 of element P, kP3 == Slope of Edge3 of element P
 real   (kind=dp) :: kQ2,kQ3 ! kQ2 == Slope of Edge2 of element Q, kQ3 == Slope of Edge3 of element Q
 real   (kind=dp) :: c22,c32,c23,c33,c22p2,c32p2,c22c32x2,c22c32s,c22kQ2,c22kQ3,c22_aQ,p12rh2,p11rh1,dltHlf
 real   (kind=dp) :: Ichixx,Ichizz,Ichixz,Ichix,Ichiz,Ichi,Irhoz,Irhoxz,Irhozz,Ichixxz,Ichixzz,Ichizzz,chicR
 real   (kind=dp) :: x,y,xi,zt,p11,p12,p11s,p12s,et,xh,zh,eth,q1h,xhs,rho1h,rho1hs,rh1s,rho2h,rho2hs,q3hethx2,omega
 real   (kind=dp) :: ThetGam,etThetGam,cpbhlf,bhlf,cr11,cr12,xhrh1h,xhrh2h,xww,wpc,theta0,hh1,hh2,hh3,etx2,p31rh1,p33rh3
 real   (kind=dp) :: alpha2,alpha3,p22,p23,p31,p33,x3,z3,rh2s,rh3s,p31h,p31hs,q3h,q3hs,p22h,p22hs,q2h,q2hs,p22hrho2h,q2hethx2
 real   (kind=dp) :: d2h,d3h,zhs,eths,ets,zts,cr22,cr23,cr31,cr33,p33s,p31hrh1h,p22rh2,p23rh3,zn1,zd1,zn2,zd2,zn3,zd3
 real   (kind=dp) :: q(3),qs(2:3),d(2:3),rho(3),rhowv(2:3),chi(2:3),gamma(3),dchi(2:3),qchi(2:3),etchi(2:3),qrhowv(2:3),GN2cf(2:3)
 real   (kind=dp) :: vecA(3),vecB(3),sncf(2:3),cscf(2:3),ah(3,3),bh(3,3),qetx2(3),intclNbh(mx_nd_elt,2:3),intAh(mx_nd_elt,2:3)
 real   (kind=dp) :: psi(mx_nd_elt),shc(mx_nd_elt),xwp(mx_nd_elt),intGamwv(mx_nd_elt),intGamwvh(mx_nd_elt)
 real   (kind=dp) :: intclN(mx_nd_elt,3),intclM(mx_nd_elt,3),intclNh(mx_nd_elt,2:3),intclMh(mx_nd_elt,2:3)
 real   (kind=dp) :: intR(mx_nd_elt,2:3),intclA(mx_nd_elt,2:3),intRhoh(mx_nd_elt,2:3),intGN3tmp(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intGam(mx_nd_elt,mx_nd_elt),intGamh(mx_nd_elt,mx_nd_elt),intKh(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intOme(mx_nd_elt,mx_nd_elt),intOmeh(mx_nd_elt,mx_nd_elt),intGK2Rchk(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intGK2(mx_nd_elt,mx_nd_elt),intGN2(mx_nd_elt,mx_nd_elt),intGK2Rh(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intGK3(mx_nd_elt,mx_nd_elt),intGN3(mx_nd_elt,mx_nd_elt),intGK3h(mx_nd_elt,mx_nd_elt)

 real(kind=dp), external :: pt_tria_tst,gammai ! External functions (see gbem_util.f90)



     c22 = QPTM(1,1); c32 = QPTM(2,1)
     c23 = QPTM(1,2); c33 = QPTM(2,2)
     
     if ( (dabs(c23) < gm_eps) .or. (dabs(c32) < gm_eps)) then
          call seesp(a,c,aQ,b,cQ,theta,c22,int_p,int_f,int_r) ! Integration for edge-adjacent elements on the same plane
	  return
     endif


    dlt = a*b

    ap2 = a*a;   bp2 = b*b;   cp2 = c*c
    ap3 = ap2*a; bp3 = bp2*b; cp3 = cp2*c
    ap4 = ap3*a; bp4 = bp3*b; cp4 = cp3*c
    
    bc = b*c; bpc = b+c; bmc = b-c
    bpcp2 = bpc*bpc

    rh2 = dsqrt(ap2+cp2); rh3 = dsqrt(ap2+bpcp2)
    rh2p2 = rh2*rh2;   rh3p2 = rh3*rh3
    rh2p3 = rh2p2*rh2; rh3p3 = rh3p2*rh3
    rh2p4 = rh2p3*rh2; rh3p4 = rh3p3*rh3
    rh2p6 = rh2p4*rh2p2; rh3p6 = rh3p4*rh3p2

    bc_rh2 = bc/rh2; bbpc_rh3 = (bp2+bc)/rh3
    bc_rh2s = bc_rh2/rh2; bbpc_rh3s = bbpc_rh3/rh3
    
    ln1 = dlog( (rh2+c)/(rh3+bpc) )
    ln2 = dlog( (b + bc_rh2)/(rh2 + rh3 + bc_rh2) )
    ln3 = dlog( (b - bbpc_rh3)/(rh2 + rh3 - bbpc_rh3) )
    
    a_rh2p2 = ap2/rh2p2; a_rh3p2 = ap2/rh3p2
    a_rh2p2x3 = 3.0_dp*a_rh2p2; a_rh3p2x3 = 3.0_dp*a_rh3p2
    bmrh2 = b-rh2; bmrh3 = b-rh3
    ln2_rh2 = ln2/rh2; ln3_rh3 = ln3/rh3
    c_rh2p2 = cp2/rh2p2; bpc_rh3p2 = bpcp2/rh3p2



     Irhoz = ap2*b*( bp3*( (bpcp2*bpcp2-ap2*(ap2+rh3p2))/rh3p6 + (ap2*(ap2+rh2p2)-cp4)/rh2p6 ) + &
             rh2*(2.0_dp+b*(b*(a_rh3p2x3-2.0_dp)-c)/rh3p2) - rh3*(2.0_dp+b*(b*a_rh2p2x3-bmc)/rh2p2) - &
             bp2*( a_rh2p2x3*bc_rh2s*ln2_rh2 + a_rh3p2x3*bbpc_rh3s*ln3_rh3 ) )/24.0_dp

     Irhoxz = ap2*b*( bp4*((5.0_dp*a_rh2p2*(a_rh2p2x3-4.0_dp)+3.0_dp)/rh2p2 +(5.0_dp*a_rh3p2*(a_rh3p2x3-1.0_dp)-2.0_dp)/rh3p2)-&
              rh2*(4.0_dp*b-6.0_dp*c+b*( 5.0_dp*ap2*b*( b*(a_rh3p2x3-2.0_dp)-c )/rh3p2-2.0_dp*(ap2+bc+bp2+bp2) )/rh3p2)-&
              rh3*(6.0_dp*c+b*( 5.0_dp*ap2*b*( c+b*(a_rh2p2x3-4.0_dp) )/rh2p2-ap2-ap2+3.0_dp*b*bmc )/rh2p2) + &
              15.0_dp*ap2*bp4*(cp3*ln2_rh2/rh2p6 + ap2*bpc*ln3_rh3/rh3p6) )/120.0_dp

     Irhozz = ap3*b*( bp4*bpc*(bpcp2+bpcp2-13.0_dp*ap2)/rh3p6 + bp4*c*(cp2+cp2-13.0_dp*ap2)/rh2p6 + &
              rh2*(6.0_dp+b*( b*( ap2*(15.0_dp*bbpc_rh3s+5.0_dp)-2.0_dp*(bp2+bc) )/rh3p2 -2.0_dp*(b+b+c))/rh3p2) - &
              rh3*(6.0_dp-b*( b*( ap2*(15.0_dp*bc_rh2s-5.0_dp)-bc-bc )/rh2p2 +bmc+bmc )/rh2p2) - &
              bp4*(a_rh2p2x3*(5.0_dp*a_rh2p2-4.0_dp)*ln2_rh2/rh2p2 - a_rh3p2x3*(5.0_dp*a_rh3p2-4.0_dp)*ln3_rh3/rh3p2) )/120.0_dp

     Ichixxz = ap2*b*( bp4*((a_rh2p2*(15.0_dp*a_rh2p2-32.0_dp)+19.0_dp)/rh2p2+(a_rh3p2*(15.0_dp*a_rh3p2-2.0_dp)-1.0_dp)/rh3p2)-&
               b*rh2*(2.0_dp+( a_rh3p2*(bp2*(15.0_dp*a_rh3p2-7.0_dp)-5.0_dp*bc)-ap2-ap2-4.0_dp*bp2-3.0_dp*bc )/rh3p2) - &
               b*rh3*(2.0_dp+( a_rh2p2*(bp2*(15.0_dp*a_rh2p2-32.0_dp)+5.0_dp*bc)-ap2-ap2+19.0_dp*bp2-7.0_dp*bc )/rh2p2) + &
               2.0_dp*(bmc*bmc+cp2+cp2)*ln1 + bp4*( 3.0_dp*cp3*(5.0_dp*a_rh2p2-4.0_dp)*ln2_rh2/rh2p4 + &
               bpc*(a_rh3p2*(15.0_dp*a_rh3p2+3.0_dp)+2.0_dp)*ln3_rh3/rh3p2 ) )/120.0_dp

     Ichixzz = ap3*b*( bp4*( c*(14.0_dp-15.0_dp*a_rh2p2)/rh2p4 - bpc*(1.0_dp+15.0_dp*a_rh3p2)/rh3p4 ) + &
               b*rh2*( b*(b*bpc*(15.0_dp*a_rh3p2+1.0_dp)+5.0_dp*ap2)/rh3p2-3.0_dp*b-c-c)/rh3p2 + &
               b*rh3*( b*( bc*(15.0_dp*a_rh2p2-14.0_dp)-5.0_dp*ap2)/rh2p2+6.0_dp*b-c-c )/rh2p2 - (2.0_dp*b-6.0_dp*c)*ln1 - &
               bp4*( (a_rh2p2*(15.0_dp*a_rh2p2-24.0_dp)+8.0_dp)*ln2_rh2/rh2p2 - &
               (a_rh3p2*(15.0_dp*a_rh3p2-9.0_dp)-2.0_dp)*ln3_rh3/rh3p2) )/120.0_dp

     Ichizzz = ap4*b*( bp4*( (11.0_dp-15.0_dp*a_rh3p2 - bpc*(15.0_dp*a_rh3p2-6.0_dp)*ln3_rh3)/rh3p4 + &
               (11.0_dp-15.0_dp*a_rh2p2 + c*(15.0_dp*a_rh2p2-6.0_dp)*ln2_rh2)/rh2p4  ) + 6.0_dp*ln1 + &
               b*rh2*( ( bp2*(15.0_dp*a_rh3p2-16.0_dp)-5.0_dp*bc )/rh3p2 - 2.0_dp )/rh3p2 + &
               b*rh3*( ( bp2*(15.0_dp*a_rh2p2-11.0_dp)+5.0_dp*bc )/rh2p2 - 2.0_dp )/rh2p2 )/120.0_dp

!Ichizz/b
     Ichizz = a*( bp2*( a_rh3p2x3*bbpc_rh3s - a_rh2p2x3*bc_rh2s ) - b*( a_rh3p2*(rh2+3.0_dp*rh2*bbpc_rh3s) + &
              a_rh2p2*(rh3-3.0_dp*rh3*bc_rh2s) ) + 2.0_dp*ap2*ln1 - bp3*( a_rh2p2*(a_rh2p2-2.0_dp*c_rh2p2)*ln2_rh2 + &
              a_rh3p2*(a_rh3p2-2.0_dp*bpc_rh3p2)*ln3_rh3 ) )/24.0_dp

!Ichixz/b
     Ichixz = ( b*(rh3*a_rh2p2*(4.0_dp*b-c-b*a_rh2p2x3)-rh2*a_rh3p2*(bpc-b*a_rh3p2x3)) - &
               bp3*(a_rh2p2*(1.0_dp+3.0_dp*c_rh2p2) + a_rh3p2x3*a_rh3p2) - ap2*(b-c-c)*ln1 + &
               bp2*(bc_rh2*a_rh2p2x3*ln2*c_rh2p2 - bbpc_rh3*a_rh3p2*(1.0_dp+a_rh3p2x3)*ln3) )/24.0_dp

!Ichixx/(b*b)
     Ichixx = a*( -b*( bc_rh2*(2.0_dp+3.0_dp*c_rh2p2)/rh2 + bbpc_rh3*(3.0_dp+a_rh3p2x3)/rh3 ) + &
             rh2*(a_rh3p2x3*bbpc_rh3 + bpc*(b+b-c)/rh3)/rh3 - rh3*(a_rh2p2x3*bc_rh2 - (5.0_dp*bc-cp2)/rh2)/rh2 + &
             2.0_dp*(b-c+cp2/b)*ln1 + bp2*( (6.0_dp+a_rh2p2*(a_rh2p2x3-7.0_dp))*ln2_rh2 + &
             (2.0_dp+a_rh3p2*(a_rh3p2x3+1.0_dp))*ln3_rh3 ) )/24.0_dp

!Ichiz/b
     Ichiz = ( b*( a_rh2p2*( bmrh3 - bc_rh2*ln2 ) + a_rh3p2*( bmrh2 + bbpc_rh3*ln3 ) ) + ap2*ln1 )/6.0_dp

!Ichix/b
     Ichix = a*(bc_rh2*bmrh3/rh2 + bbpc_rh3*bmrh2/rh3-(b-c)*ln1-bp2*((1.0_dp+c_rh2p2)*ln2_rh2+(1.0_dp+a_rh3p2)*ln3_rh3))/6.0_dp

     Ichi = 0.5_dp*dlt*( ln1 + b*(ln2_rh2 + ln3_rh3) )


     cQmb = cQ-b
     kQ2 = cQmb/aQ; kQ3 = cQ/aQ
     kP2 = c/a; kP3 = bpc/a

     c22p2 = c22*c22; c32p2 = c32*c32; c22c32x2 = 2.0_dp*c22*c32
     c22c32s = c22p2*c32p2; c22kQ2 = c22*kQ2; c22kQ3 = c22*kQ3; c22_aQ = c22/aQ
    
     intKh(1,1) = (kP2*c22kQ2*Ichizzz - Ichixxz + (kP2-c22kQ2)*Ichixzz)/bp2 - Ichixz + kP2*Ichizz
     intKh(2,1) = (Ichixxz - kP3*c22kQ2*Ichizzz - (kP3-c22kQ2)*Ichixzz)/bp2 + 2.0_dp*Ichixz - (kP3-c22kQ2)*Ichizz + b*Ichiz
     intKh(3,1) = (c22kQ2*Ichizzz + Ichixzz)/dlt + b*Ichizz/a
     intKh(1,2) = (Ichixxz - (kP2-c22kQ3)*Ichixzz - kP2*c22kQ3*Ichizzz)/bp2
     intKh(2,2) = (kP3*c22kQ3*Ichizzz - Ichixxz  + (kP3-c22kQ3)*Ichixzz)/bp2 - Ichixz - c22kQ3*Ichizz
     intKh(3,2) = -(c22kQ3*Ichizzz + Ichixzz)/dlt
     intKh(1,3) = c22_aQ*(kP2*Ichizzz - Ichixzz)/b
     intKh(2,3) = c22_aQ*( b*Ichizz + (Ichixzz - kP3*Ichizzz)/b )
     intKh(3,3) = c22_aQ*Ichizzz/a

     intclN(1,1) = -c22*(kP2*Irhozz - Irhoxz)/b
     intclN(2,1) = -c22*((Irhoxz - kP3*Irhozz)/b + Irhoz)
     intclN(3,1) = -c22*Irhozz/a

     intclM(1,1) = (kP2*Ichizzz - Ichixzz)/b
     intclM(2,1) = (Ichixzz - kP3*Ichizzz)/b + b*Ichizz
     intclM(3,1) = Ichizzz/a

    intGK2(1,1) =  Ichixx - c22kQ2*kP2*Ichizz/b - (kP2-c22kQ2)*Ichixz/b + Ichix - kP2*Ichiz
    intGK2(2,1) = -Ichixx + c22kQ2*kP3*Ichizz/b + (kP3-c22kQ2)*Ichixz/b - 2.0_dp*Ichix + (kP3-c22kQ2)*Ichiz - Ichi
    intGK2(3,1) = -( c22kQ2*Ichizz + Ichixz + b*Ichiz )/a
    intGK2(1,2) = -Ichixx + c22kQ3*kP2*Ichizz/b + (kP2-c22kQ3)*Ichixz/b
    intGK2(2,2) =  Ichixx - c22kQ3*kP3*Ichizz/b - (kP3-c22kQ3)*Ichixz/b + Ichix + c22kQ3*Ichiz
    intGK2(3,2) =  ( c22kQ3*Ichizz + Ichixz )/a
    intGK2(1,3) =  c22_aQ*(Ichixz - kP2*Ichizz)
    intGK2(2,3) =  c22_aQ*(kP3*Ichizz - Ichixz - b*Ichiz)
    intGK2(3,3) = -c22_aQ*b*Ichizz/a

    intGN3tmp(1,1) = -c32*(kP2*Ichizz-Ichixz); intGN3tmp(2,1) = -c32*(Ichixz-kP3*Ichizz+b*Ichiz); intGN3tmp(3,1) = -c32*b*Ichizz/a

      if (dabs(c22) < gm_eps ) c22 = 0.0_dp
      if (dabs(c32) < gm_eps ) c32 = 0.0_dp

     loop0a: do i=1,mx_nd_elt
        intGN2(i,1) = 0.0_dp; intGamwv(i) = 0.0_dp; intGamwvh(i) = 0.0_dp
        loop0b: do k=1,mx_nd_elt
              intGamh(k,i) = 0.0_dp;   intGam(k,i) = 0.0_dp; intGK3(k,i) = 0.0_dp; intGK3h(k,i) = 0.0_dp
	       intOme(k,i) = 0.0_dp;  intOmeh(k,i) = 0.0_dp
	   intGK2Rchk(k,i) = 0.0_dp; intGK2Rh(k,i) = 0.0_dp
        enddo loop0b
     enddo loop0a

     loop1a: do i=2,3
        loop1b: do k=1,mx_nd_elt
	    intclN(k,i) = 0.0_dp;  intclM(k,i) = 0.0_dp
	   intclNh(k,i) = 0.0_dp; intclMh(k,i) = 0.0_dp; intGN3tmp(k,i) = 0.0_dp; intclNbh(k,i) = 0.0_dp
	      intR(k,i) = 0.0_dp; intRhoh(k,i) = 0.0_dp;    intclA(k,i) = 0.0_dp;    intAh(k,i) = 0.0_dp
        enddo loop1b
     enddo loop1a

     bhlf = 0.5_dp*b
     cpbhlf = c+bhlf; alpha2 = pi-theta(2); alpha3 = pi+theta(1) ! alpha1 = 0.0_dp
     
     cscf(2) = dcos(alpha2); sncf(2) = dsin(alpha2)
     cscf(3) = dcos(alpha3); sncf(3) = dsin(alpha3)

     vecA(1) = -1.0_dp/b; vecA(2) =  1.0_dp/b; vecA(3) = 0.0_dp
     vecB(1) =  kQ2/b   ; vecB(2) = -kQ3/b   ; vecB(3) = 1.0_dp/aQ
     
     ah(1,1) = vecA(1); ah(2,1) = (kQ2*sncf(2) - cscf(2))/b; ah(3,1) = (kQ2*sncf(3) - cscf(3))/b
     ah(1,2) = vecA(2); ah(2,2) = (cscf(2) - kQ3*sncf(2))/b; ah(3,2) = (cscf(3) - kQ3*sncf(3))/b
     ah(1,3) =  0.0_dp; ah(2,3) = sncf(2)/aQ               ; ah(3,3) = sncf(3)/aQ
     
     bh(1,1) = -vecB(1); bh(2,1) = -(sncf(2) + kQ2*cscf(2))/b; bh(3,1) = -(sncf(3) + kQ2*cscf(3))/b
     bh(1,2) = -vecB(2); bh(2,2) =  (sncf(2) + kQ3*cscf(2))/b; bh(3,2) =  (sncf(3) + kQ3*cscf(3))/b
     bh(1,3) = -vecB(3); bh(2,3) = -cscf(2)/aQ               ; bh(3,3) = -cscf(3)/aQ


     loop2a: do i=1,ng1 ! Loop over y  :: E'
        y = xi1(i)
	xh = c-cpbhlf*y; zh = a*(1.0_dp-y)
        eth = -c32*zh; q1h = -c22*zh
	p31h = xh*cscf(3) + q1h*sncf(3); q3h = q1h*cscf(3) - xh*sncf(3)
	xhs = xh*xh; zhs = zh*zh

        rho1hs = xhs + zhs
        rho1h = dsqrt(rho1hs)

	if (dabs(q3h) < gm_eps) q3h = 0.0_dp
	
	eths = eth*eth; p31hs = p31h*p31h; q3hs = q3h*q3h
	d3h = q3hs + eths
        
	xhrh1h = xh*rho1h; p31hrh1h = p31h*rho1h; q3hethx2 = 2.0_dp*q3h*eth
	cr11 = c22p2*rho1hs - c32p2*xhs; hh1 = 4.0_dp*c22c32s*xhrh1h
	cr31 = q3hs*rho1hs - p31hs*eths; hh3 = 4.0_dp*p31hrh1h*q3hs*eths
	
        loop2b: do k=1,ng1 ! Loop over x  :: E'
           x = xi1(k)
           xww = x*wwg1(k,i) ! xww = x*wg1(i)*wg1(k)
           xi = x*xh; zt = x*zh; q(1) = x*q1h; et = x*eth; p31 = x*p31h; q(3) = x*q3h ! p11 = xi
	   p12 = b+xi; x3 = cQ+xi; z3 = aQ+q(1)
	   p22 = p12*cscf(2) + q(1)*sncf(2); q(2) = q(1)*cscf(2) - p12*sncf(2)
	   p23 = x3*cscf(2) + z3*sncf(2); p33 = x3*cscf(3) + z3*sncf(3)
	   ets = et*et; p12s = p12*p12; zts = zt*zt; p33s = p33*p33; qs(2) = q(2)*q(2)

	   rh1s = xi*xi + zts; rh2s = p12s + zts; rh3s = p33s + q(3)*q(3) + ets
	   rho(1) = dsqrt(rh1s); rho(2) = dsqrt(rh2s); rho(3) = dsqrt(rh3s)

	   psi(1) = shfe1(1,k,i); psi(2) = shfe1(2,k,i); psi(3) = shfe1(3,k,i) ! psi(1) = 0.5_dp*x*y; psi(3) = x*(1.0_dp-y)
									       ! psi(2) = 1.0_dp + x*(0.5_dp*y-1.0_dp)

           shc(2) = -(xi+c22kQ3*zt)/b; shc(3) = c22_aQ*zt
	   shc(1) = 1.0_dp - (shc(2)+shc(3)) ! shc(1) = 1.0_dp + (xi+c22kQ2*zt)/b

	   if ( dabs(shc(1)) < gm_eps ) then
	      shc(1) = 0.0_dp; q(2) = 0.0_dp
	   endif
	   
	   if ( dabs(shc(2)) < gm_eps ) then
	      shc(2) = 0.0_dp
	   elseif ( dabs(shc(2)-1.0_dp) < gm_eps ) then
	      shc(2) = 1.0_dp
	   endif
	   
	   if ( dabs(shc(3)) < gm_eps ) then
	      shc(3) = 0.0_dp
	   elseif ( dabs(shc(3)-1.0_dp) < gm_eps ) then
	      shc(3) = 1.0_dp
	   endif

	    theta0 = pt_tria_tst(shc(1),shc(2),shc(3),theta,th_id) ! Point in triangle test

	   rhowv(2) = rho(2)-rho(3); rhowv(3) = rho(3)-rho(1)
	   chi(2) = dlog( (p22+rho(2))/(p23+rho(3)) ); chi(3) = -dlog( (p31+rho(1))/(p33+rho(3)) )

	   d(2) = qs(2) + ets; d(3) = x*x*d3h; etx2 = 2.0_dp*et
	   
	   qetx2(1) = q(1)*etx2; qetx2(2) = q(2)*etx2
	   
	   cr12 = c22p2*rh2s - c32p2*p12s; p12rh2 = p12*rho(2)
	   zn1 = c22c32x2*(p12rh2*cr11 - xhrh1h*cr12); zd1 = cr11*cr12 + p12rh2*hh1

	   cr22 = qs(2)*rh2s - p22*p22*ets; cr23 = qs(2)*rh3s - p23*p23*ets; p22rh2 = p22*rho(2); p23rh3 = p23*rho(3)
	   zn2 = qetx2(2)*(p23rh3*cr22 - p22rh2*cr23); zd2 = cr22*cr23 + qetx2(2)*qetx2(2)*p22rh2*p23rh3
	   
	   cr33 = q3hs*rh3s - p33s*eths; p33rh3 = p33*rho(3)
	   zn3 = q3hethx2*(p31hrh1h*cr33 - p33rh3*cr31); zd3 = cr31*cr33 + p33rh3*hh3

	   gamma(1) = gammai(xi ,p12,qetx2(1),cr11,cr12,zn1,zd1)
	   gamma(2) = gammai(p22,p23,qetx2(2),cr22,cr23,zn2,zd2)
	   gamma(3) = gammai(p33,p31,q3hethx2,cr33,cr31,zn3,zd3)

	   if ( et > 0.0_dp ) then
	      ThetGam = 0.5_dp*(gamma(1)+gamma(2)+gamma(3)) + theta0
	   else
	      ThetGam = 0.5_dp*(gamma(1)+gamma(2)+gamma(3)) - theta0
	   endif

	   etThetGam = et*ThetGam

           xwp(1) = xww*psi(1)
	   loop3: do ii=2,3
              xwp(ii) = xww*psi(ii); dchi(ii) = d(ii)*chi(ii); qrhowv(ii) = q(ii)*rhowv(ii); qchi(ii) = q(ii)*chi(ii)
	      etchi(ii) = et*chi(ii)
           enddo loop3
	   
	   omega = qchi(2) + qchi(3)
	   chicR = cscf(2)*chi(2) + cscf(3)*chi(3)
           
           loop4a: do ii=1,mx_nd_elt
	      intGamwvh(ii) = intGamwvh(ii) + xwp(ii)*etThetGam
	      loop4b: do kk=1,mx_nd_elt
                 wpc = xwp(kk)*shc(ii)
                  intGamh(kk,ii) =  intGamh(kk,ii) + wpc*etThetGam
		  intGK3h(kk,ii) =  intGK3h(kk,ii) + wpc*ThetGam
		  intOmeh(kk,ii) =  intOmeh(kk,ii) + wpc*omega
		 intGK2Rh(kk,ii) = intGK2Rh(kk,ii) + wpc*chicR
              enddo loop4b
           enddo loop4a

           loop5a: do ii=2,3
              loop5b: do kk=1,mx_nd_elt
                  intclNh(kk,ii) =  intclNh(kk,ii) + xwp(kk)*qrhowv(ii)
		  intclMh(kk,ii) =  intclMh(kk,ii) + xwp(kk)*dchi(ii)
		 intclNbh(kk,ii) = intclNbh(kk,ii) + xwp(kk)*etchi(ii)
		  intRhoh(kk,ii) =  intRhoh(kk,ii) + xwp(kk)*rhowv(ii)
		    intAh(kk,ii) =    intAh(kk,ii) + xwp(kk)*qchi(ii)
              enddo loop5b
           enddo loop5a

        enddo loop2b ! End Loop over x  :: E'
     enddo loop2a ! End Loop over y  :: E'


     loop6a: do i=1,ng1 ! Loop over y  :: E"
        y = xi1(i)
        xh = bhlf+cpbhlf*y; zh = a*y
	eth = -c32*zh; q1h = -c22*zh
	p22h = xh*cscf(2) + q1h*sncf(2); q2h = q1h*cscf(2) - xh*sncf(2)
	xhs = xh*xh; zhs = zh*zh

        rho2hs = xhs + zhs
        rho2h = dsqrt(rho2hs)

	if (dabs(q2h) < gm_eps) q2h = 0.0_dp

	eths = eth*eth; p22hs = p22h*p22h; q2hs = q2h*q2h
	d2h = q2hs + eths

	xhrh2h = xh*rho2h; p22hrho2h = p22h*rho2h; q2hethx2 = 2.0_dp*q2h*eth
	cr12 = c22p2*rho2hs - c32p2*xhs; hh1 = 4.0_dp*c22c32s*xhrh2h
	cr22 = q2hs*rho2hs - p22hs*eths; hh2 = 4.0_dp*p22hrho2h*q2hs*eths
	
        loop6b: do k=1,ng1 ! Loop over x  :: E"
           x = xi1(k)
           xww = x*wwg1(k,i) ! xww = x*wg1(i)*wg1(k)
           xi = x*xh; zt = x*zh; q(1) = x*q1h; et = x*eth; p22 = x*p22h; q(2) = x*q2h ! p12 = xi
	   p11 = xi-b; x3 = cQmb+xi; z3 = aQ+q(1)
	   p23 = x3*cscf(2) + z3*sncf(2); p33 = x3*cscf(3) + z3*sncf(3)
	   p31 = p11*cscf(3) + q(1)*sncf(3); q(3) = q(1)*cscf(3) - p11*sncf(3)
	   ets = et*et; p11s = p11*p11; zts = zt*zt; p33s = p33*p33; qs(3) = q(3)*q(3)

	   rh1s = p11s + zts; rh2s = xi*xi + zts; rh3s = p33s + qs(3) + ets
	   rho(1) = dsqrt(rh1s); rho(2) = dsqrt(rh2s); rho(3) = dsqrt(rh3s)

	   psi(1) = shfe2(1,k,i); psi(2) = shfe2(2,k,i); psi(3) = shfe2(3,k,i) ! psi(1) = 1.0_dp-0.5_dp*x*(1.0_dp+y); psi(3) = x*y
									       ! psi(2) = 0.5_dp*x*(1.0_dp-y)

           shc(1) = (xi+c22kQ2*zt)/b; shc(3) = c22_aQ*zt
	   shc(2) = 1.0_dp -(shc(1)+shc(3)) ! shc(2) = 1.0_dp - (xi+c22kQ3*zt)/b

	   if ( dabs(shc(2)) < gm_eps ) then
	      shc(2) = 0.0_dp; q(3) = 0.0_dp
	   endif
	   
	   if ( dabs(shc(3)) < gm_eps ) then
	      shc(3) = 0.0_dp
	   elseif ( dabs(shc(3)-1.0_dp) < gm_eps ) then
	      shc(3) = 1.0_dp
	   endif
	   
	   if ( dabs(shc(1)) < gm_eps ) then
	      shc(1) = 0.0_dp
	   elseif ( dabs(shc(1)-1.0_dp) < gm_eps ) then
	      shc(1) = 1.0_dp
	   endif

	    theta0 = pt_tria_tst(shc(2),shc(3),shc(1),theta,th_id) ! Point in triangle test

	   rhowv(2) = rho(2)-rho(3); rhowv(3) = rho(3)-rho(1)
	   chi(2) = dlog( (p22+rho(2))/(p23+rho(3)) ); chi(3) = -dlog( (p31+rho(1))/(p33+rho(3)) )
	   
	   d(2) = x*x*d2h; d(3) = qs(3) + ets; etx2 = 2.0_dp*et
	   
	   qetx2(1) = q(1)*etx2; qetx2(3) = q(3)*etx2
	   
	   cr11 = c22p2*rh1s - c32p2*p11s; p11rh1 = p11*rho(1)
	   zn1 = c22c32x2*(xhrh2h*cr11 - p11rh1*cr12); zd1 = cr11*cr12 + p11rh1*hh1
	   
	   cr23 = q2hs*rh3s - p23*p23*eths; p23rh3 = p23*rho(3)
	   zn2 = q2hethx2*(p23rh3*cr22 - p22hrho2h*cr23); zd2 = cr22*cr23 + p23rh3*hh2
	   
	   cr33 = qs(3)*rh3s - p33s*ets; cr31 = qs(3)*rh1s - p31*p31*ets; p31rh1 = p31*rho(1); p33rh3 = p33*rho(3)
	   zn3 = qetx2(3)*(p31rh1*cr33 - p33rh3*cr31); zd3 = cr31*cr33 + qetx2(3)*qetx2(3)*p31rh1*p33rh3

	   gamma(1) = gammai(p11,xi ,qetx2(1),cr11,cr12,zn1,zd1)
	   gamma(2) = gammai(p22,p23,q2hethx2,cr22,cr23,zn2,zd2)
	   gamma(3) = gammai(p33,p31,qetx2(3),cr33,cr31,zn3,zd3)

	   if ( et > 0.0_dp ) then
	      ThetGam = 0.5_dp*(gamma(1)+gamma(2)+gamma(3)) + theta0
	   else
	      ThetGam = 0.5_dp*(gamma(1)+gamma(2)+gamma(3)) - theta0
	   endif

	   etThetGam = et*ThetGam

           xwp(1) = xww*psi(1)
	   loop7: do ii=2,3
              xwp(ii) = xww*psi(ii); dchi(ii) = d(ii)*chi(ii); qrhowv(ii) = q(ii)*rhowv(ii); qchi(ii) = q(ii)*chi(ii)
	      etchi(ii) = et*chi(ii)
           enddo loop7
	   
	   omega = qchi(2) + qchi(3)
	   chicR = cscf(2)*chi(2) + cscf(3)*chi(3)
	   
           loop8a: do ii=1,mx_nd_elt
	      intGamwv(ii) = intGamwv(ii) + xwp(ii)*etThetGam
	      loop8b: do kk=1,mx_nd_elt
                 wpc = xwp(kk)*shc(ii)
                     intGam(kk,ii) =     intGam(kk,ii) + wpc*etThetGam
		     intGK3(kk,ii) =     intGK3(kk,ii) + wpc*ThetGam
		     intOme(kk,ii) =     intOme(kk,ii) + wpc*omega
		 intGK2Rchk(kk,ii) = intGK2Rchk(kk,ii) + wpc*chicR
              enddo loop8b
           enddo loop8a
           
           loop9a: do ii=2,3
              loop9b: do kk=1,mx_nd_elt
                    intclN(kk,ii) =    intclN(kk,ii) + xwp(kk)*qrhowv(ii)
		    intclM(kk,ii) =    intclM(kk,ii) + xwp(kk)*dchi(ii)
		 intGN3tmp(kk,ii) = intGN3tmp(kk,ii) + xwp(kk)*etchi(ii)

		      intR(kk,ii) =      intR(kk,ii) + xwp(kk)*rhowv(ii)
		    intclA(kk,ii) =    intclA(kk,ii) + xwp(kk)*qchi(ii)
              enddo loop9b
           enddo loop9a
           
        enddo loop6b ! End Loop over x :: E"
     enddo loop6a ! End Loop over y  :: E"


     dltHlf = 0.5_dp*dlt
     GN2cf(2) = sncf(2)*dltHlf; GN2cf(3) = sncf(3)*dltHlf

    intGamwv(1) = dltHlf*(intGamwv(1) + intGamwvh(1))
    
    loop10a: do k=2,3
       intGamwv(k) = dltHlf*(intGamwv(k) + intGamwvh(k))
       loop10b: do i=1,mx_nd_elt
             intclN(i,k) = dltHlf*(   intclN(i,k) +  intclNh(i,k))
	     intclM(i,k) = dltHlf*(   intclM(i,k) +  intclMh(i,k))
	  intGN3tmp(i,k) = dltHlf*(intGN3tmp(i,k) + intclNbh(i,k))
	  
	    intR(i,k) = GN2cf(k)*(  intR(i,k) + intRhoh(i,k))
	  intclA(i,k) = GN2cf(k)*(intclA(i,k) +   intAh(i,k))
       enddo loop10b
    enddo loop10a

     call dgemm('N','N',mx_nd_elt,3,mx_nd_elt,1.0_dp,intGN3tmp,mx_nd_elt,bh,3,0.0_dp,intGN3,mx_nd_elt) ! intGN3 = matmul(intGN3tmp,bh)

!*** int_f = matmul(intclN,ah) - matmul(intclM,bh)
     call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intclM,mx_nd_elt,bh,3, 0.0_dp,int_f,mx_nd_elt) ! int_f = matmul(intclM,bh)
     call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intclN,mx_nd_elt,ah,3,-1.0_dp,int_f,mx_nd_elt) ! int_f = matmul(intclN,ah) - int_f

    intGN2(1,1) = intR(1,2)*bh(2,1) + intR(1,3)*bh(3,1) + intclA(1,2)*ah(2,1) + intclA(1,3)*ah(3,1)
    intGN2(2,1) = intR(2,2)*bh(2,1) + intR(2,3)*bh(3,1) + intclA(2,2)*ah(2,1) + intclA(2,3)*ah(3,1)
    intGN2(3,1) = intR(3,2)*bh(2,1) + intR(3,3)*bh(3,1) + intclA(3,2)*ah(2,1) + intclA(3,3)*ah(3,1)
    
    intGN2(1,2) = intR(1,2)*bh(2,2) + intR(1,3)*bh(3,2) + intclA(1,2)*ah(2,2) + intclA(1,3)*ah(3,2)
    intGN2(2,2) = intR(2,2)*bh(2,2) + intR(2,3)*bh(3,2) + intclA(2,2)*ah(2,2) + intclA(2,3)*ah(3,2)
    intGN2(3,2) = intR(3,2)*bh(2,2) + intR(3,3)*bh(3,2) + intclA(3,2)*ah(2,2) + intclA(3,3)*ah(3,2)
    
    intGN2(1,3) = intR(1,2)*bh(2,3) + intR(1,3)*bh(3,3) + intclA(1,2)*ah(2,3) + intclA(1,3)*ah(3,3)
    intGN2(2,3) = intR(2,2)*bh(2,3) + intR(2,3)*bh(3,3) + intclA(2,2)*ah(2,3) + intclA(2,3)*ah(3,3)
    intGN2(3,3) = intR(3,2)*bh(2,3) + intR(3,3)*bh(3,3) + intclA(3,2)*ah(2,3) + intclA(3,3)*ah(3,3)

    loop11a: do k=1,mx_nd_elt
       loop11b: do i=1,mx_nd_elt
	  intGam(i,k) = dltHlf*(intGam(i,k) + intGamh(i,k))
	  intGK3(i,k) = dltHlf*(intGK3(i,k) + intGK3h(i,k))
	  intOme(i,k) = dltHlf*(intOme(i,k) + intOmeh(i,k)) - c22*intKh(i,k)
	  
	  intGK2(i,k) = intGK2(i,k) - dltHlf*(intGK2Rh(i,k) + intGK2Rchk(i,k))
	  intGN2(i,k) = intGN2(i,k) - intGamwv(i)*vecB(k)
       enddo loop11b
    enddo loop11a

    loop12a: do k=1,mx_nd_elt
       loop12b: do i=1,mx_nd_elt
	  int_f(i,k) = 0.5_dp*int_f(i,k) + intOme(i,k) - intGam(i,k)    ! Weakly-singular kernel ==> G
	  int_p(i,k) = -(intGN3(i,k) + intGK3(i,k))                     ! Singular kernel ==> H
	  int_r(i,k) = c23*(intGN2(i,k) + intGK2(i,k)) - c33*int_p(i,k) ! Reverse kernel ==> H
       enddo loop12b
    enddo loop12a

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE sing_edg
!----------------------------------------------------------------------------------------------------------------------------------!


!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE seesp(a,c,aQ,b,cQ,theta,c22,int_p,int_f,int_r)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!*******************************  EXact Inner integral with linear distribution on a flat triangle  *******************************!
!******************************  Singular integration for edge-adjacent elements on the same plane  *******************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


USE KINDS
USE PARAMS,   ONLY: pi,f_eps    ! pi = 3.1415926535897932, f_eps == Tolerance on the argument of a function
USE SRF_GEOM, ONLY: mx_nd_elt   ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: shfe1,shfe2 ! shfe1(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for edge-adjacent case: E'
				! shfe2(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for edge-adjacent case: E"
USE GAUSS1D,  ONLY: ng1,xi1     ! ng1 == Number of Gauss-Legendre points over a segment [0,1] for Singular integrations
			        ! xi1 == Gauss-Legendre points over a segment [0,1] for Singular integrations
USE GAUSS1D,  ONLY: wwg1        ! wwg1(k,i) = wg1(i)*wg1(k), where wg1(k) is the k-th Gauss-Legendre weight factor corresponding to xi1(k)


IMPLICIT NONE

 real   (kind=dp), intent(in ) :: a,b,c ! Geometric parameters of element P: b = length of the coincident edge for elements P and Q,
 			                ! a = height, c = relative position of the 3rd vertex of element P
 real   (kind=dp), intent(in ) :: aQ,cQ ! Geometric parameters of element Q: b = length of the coincident edge for elements P and Q,
 			                ! aQ = height, cQ = relative position of the 3rd vertex of element Q
 real   (kind=dp), intent(in ) :: theta(3) ! theta(i) == Angle at the i-th vertex of element Q
 real   (kind=dp), intent(in ) :: c22 ! Diagonal component of the Transition matrix from element Q to element P
 real   (kind=dp), intent(out) :: int_p(mx_nd_elt,mx_nd_elt) ! int_p == Singular contribution to potential influence matrix H
 real   (kind=dp), intent(out) :: int_f(mx_nd_elt,mx_nd_elt) ! int_f == Singular contribution to flux influence matrix G
 real   (kind=dp), intent(out) :: int_r(mx_nd_elt,mx_nd_elt) ! int_r == Singular contribution to potential influence matrix H: Reverse kernel

 integer(kind=k9) :: k,i,ii,kk
 real   (kind=dp) :: dlt,a_rh2p2,a_rh3p2,a_rh2p2x3,a_rh3p2x3,c_rh2p2,bpc_rh3p2
 real   (kind=dp) :: ap2,ap3,ap4,bp2,bp3,bp4,cp2,cp3,cp4,rh2,rh3,rh2p2,rh2p3,rh2p4,rh2p6,rh3p2,rh3p3,rh3p4,rh3p6,cQmb
 real   (kind=dp) :: ln1,ln2,ln3,bc,bpc,bmc,bpcp2,bc_rh2,bc_rh2s,bbpc_rh3,bbpc_rh3s,bmrh2,bmrh3,ln2_rh2,ln3_rh3
 real   (kind=dp) :: kP2,kP3 ! kP2 == Slope of Edge2 of element P, kP3 == Slope of Edge3 of element P
 real   (kind=dp) :: kQ2,kQ3 ! kQ2 == Slope of Edge2 of element Q, kQ3 == Slope of Edge3 of element Q
 real   (kind=dp) :: c22kQ2,c22kQ3,c22_aQ,dltHlf,x,y,xi,zt,xh,zh,q1h,cpbhlf,bhlf,qs(2:3)
 real   (kind=dp) :: Ichizz,Ichixz,Ichiz,Irhoz,Irhoxz,Irhozz,Ichixxz,Ichixzz,Ichizzz,xww,d2h,d3h,zts,omega
 real   (kind=dp) :: alpha2,alpha3,p11,p12,p22,p23,p31,p33,x3,z3,p31h,q3h,p22h,q2h,ch33,ch31,z1,z1s,z2,z2s,q(3)
 real   (kind=dp) :: vecA(3),vecB(3),sncf(2:3),cscf(2:3),ah(3,3),bh(3,3),rho(3),rhowv(2:3),chi(2:3),dchi(2:3),qrhowv(2:3)
 real   (kind=dp) :: psi(mx_nd_elt),shc(mx_nd_elt),xwp(mx_nd_elt),intKh(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intOme(mx_nd_elt,mx_nd_elt),intOmeh(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intclN(mx_nd_elt,3),intclNh(mx_nd_elt,2:3),intclM(mx_nd_elt,3),intclMh(mx_nd_elt,2:3)



    dlt = a*b

    ap2 = a*a;   bp2 = b*b;   cp2 = c*c
    ap3 = ap2*a; bp3 = bp2*b; cp3 = cp2*c
    ap4 = ap3*a; bp4 = bp3*b; cp4 = cp3*c
    
    bc = b*c; bpc = b+c; bmc = b-c
    bpcp2 = bpc*bpc

    rh2 = dsqrt(ap2+cp2); rh3 = dsqrt(ap2+bpcp2)
    rh2p2 = rh2*rh2;   rh3p2 = rh3*rh3
    rh2p3 = rh2p2*rh2; rh3p3 = rh3p2*rh3
    rh2p4 = rh2p3*rh2; rh3p4 = rh3p3*rh3
    rh2p6 = rh2p4*rh2p2; rh3p6 = rh3p4*rh3p2

    bc_rh2 = bc/rh2; bbpc_rh3 = (bp2+bc)/rh3
    bc_rh2s = bc_rh2/rh2; bbpc_rh3s = bbpc_rh3/rh3
    
    ln1 = dlog( (rh2+c)/(rh3+bpc) )
    ln2 = dlog( (b + bc_rh2)/(rh2 + rh3 + bc_rh2) )
    ln3 = dlog( (b - bbpc_rh3)/(rh2 + rh3 - bbpc_rh3) )
    
    a_rh2p2 = ap2/rh2p2; a_rh3p2 = ap2/rh3p2
    a_rh2p2x3 = 3.0_dp*a_rh2p2; a_rh3p2x3 = 3.0_dp*a_rh3p2
    bmrh2 = b-rh2; bmrh3 = b-rh3
    ln2_rh2 = ln2/rh2; ln3_rh3 = ln3/rh3
    c_rh2p2 = cp2/rh2p2; bpc_rh3p2 = bpcp2/rh3p2



     Irhoz = ap2*b*( bp3*( (bpcp2*bpcp2-ap2*(ap2+rh3p2))/rh3p6 + (ap2*(ap2+rh2p2)-cp4)/rh2p6 ) + &
             rh2*(2.0_dp+b*(b*(a_rh3p2x3-2.0_dp)-c)/rh3p2) - rh3*(2.0_dp+b*(b*a_rh2p2x3-bmc)/rh2p2) - &
             bp2*( a_rh2p2x3*bc_rh2s*ln2_rh2 + a_rh3p2x3*bbpc_rh3s*ln3_rh3 ) )/24.0_dp

     Irhoxz = ap2*b*( bp4*((5.0_dp*a_rh2p2*(a_rh2p2x3-4.0_dp)+3.0_dp)/rh2p2 +(5.0_dp*a_rh3p2*(a_rh3p2x3-1.0_dp)-2.0_dp)/rh3p2)-&
              rh2*(4.0_dp*b-6.0_dp*c+b*( 5.0_dp*ap2*b*( b*(a_rh3p2x3-2.0_dp)-c )/rh3p2-2.0_dp*(ap2+bc+bp2+bp2) )/rh3p2)-&
              rh3*(6.0_dp*c+b*( 5.0_dp*ap2*b*( c+b*(a_rh2p2x3-4.0_dp) )/rh2p2-ap2-ap2+3.0_dp*b*bmc )/rh2p2) + &
              15.0_dp*ap2*bp4*(cp3*ln2_rh2/rh2p6 + ap2*bpc*ln3_rh3/rh3p6) )/120.0_dp

     Irhozz = ap3*b*( bp4*bpc*(bpcp2+bpcp2-13.0_dp*ap2)/rh3p6 + bp4*c*(cp2+cp2-13.0_dp*ap2)/rh2p6 + &
              rh2*(6.0_dp+b*( b*( ap2*(15.0_dp*bbpc_rh3s+5.0_dp)-2.0_dp*(bp2+bc) )/rh3p2 -2.0_dp*(b+b+c))/rh3p2) - &
              rh3*(6.0_dp-b*( b*( ap2*(15.0_dp*bc_rh2s-5.0_dp)-bc-bc )/rh2p2 +bmc+bmc )/rh2p2) - &
              bp4*(a_rh2p2x3*(5.0_dp*a_rh2p2-4.0_dp)*ln2_rh2/rh2p2 - a_rh3p2x3*(5.0_dp*a_rh3p2-4.0_dp)*ln3_rh3/rh3p2) )/120.0_dp

     Ichixxz = ap2*b*( bp4*((a_rh2p2*(15.0_dp*a_rh2p2-32.0_dp)+19.0_dp)/rh2p2+(a_rh3p2*(15.0_dp*a_rh3p2-2.0_dp)-1.0_dp)/rh3p2)-&
               b*rh2*(2.0_dp+( a_rh3p2*(bp2*(15.0_dp*a_rh3p2-7.0_dp)-5.0_dp*bc)-ap2-ap2-4.0_dp*bp2-3.0_dp*bc )/rh3p2) - &
               b*rh3*(2.0_dp+( a_rh2p2*(bp2*(15.0_dp*a_rh2p2-32.0_dp)+5.0_dp*bc)-ap2-ap2+19.0_dp*bp2-7.0_dp*bc )/rh2p2) + &
               2.0_dp*(bmc*bmc+cp2+cp2)*ln1 + bp4*( 3.0_dp*cp3*(5.0_dp*a_rh2p2-4.0_dp)*ln2_rh2/rh2p4 + &
               bpc*(a_rh3p2*(15.0_dp*a_rh3p2+3.0_dp)+2.0_dp)*ln3_rh3/rh3p2 ) )/120.0_dp

     Ichixzz = ap3*b*( bp4*( c*(14.0_dp-15.0_dp*a_rh2p2)/rh2p4 - bpc*(1.0_dp+15.0_dp*a_rh3p2)/rh3p4 ) + &
               b*rh2*( b*(b*bpc*(15.0_dp*a_rh3p2+1.0_dp)+5.0_dp*ap2)/rh3p2-3.0_dp*b-c-c)/rh3p2 + &
               b*rh3*( b*( bc*(15.0_dp*a_rh2p2-14.0_dp)-5.0_dp*ap2)/rh2p2+6.0_dp*b-c-c )/rh2p2 - (2.0_dp*b-6.0_dp*c)*ln1 - &
               bp4*( (a_rh2p2*(15.0_dp*a_rh2p2-24.0_dp)+8.0_dp)*ln2_rh2/rh2p2 - &
               (a_rh3p2*(15.0_dp*a_rh3p2-9.0_dp)-2.0_dp)*ln3_rh3/rh3p2) )/120.0_dp

     Ichizzz = ap4*b*( bp4*( (11.0_dp-15.0_dp*a_rh3p2 - bpc*(15.0_dp*a_rh3p2-6.0_dp)*ln3_rh3)/rh3p4 + &
               (11.0_dp-15.0_dp*a_rh2p2 + c*(15.0_dp*a_rh2p2-6.0_dp)*ln2_rh2)/rh2p4  ) + 6.0_dp*ln1 + &
               b*rh2*( ( bp2*(15.0_dp*a_rh3p2-16.0_dp)-5.0_dp*bc )/rh3p2 - 2.0_dp )/rh3p2 + &
               b*rh3*( ( bp2*(15.0_dp*a_rh2p2-11.0_dp)+5.0_dp*bc )/rh2p2 - 2.0_dp )/rh2p2 )/120.0_dp

!Ichizz/b
     Ichizz = a*( bp2*( a_rh3p2x3*bbpc_rh3s - a_rh2p2x3*bc_rh2s ) - b*( a_rh3p2*(rh2+3.0_dp*rh2*bbpc_rh3s) + &
              a_rh2p2*(rh3-3.0_dp*rh3*bc_rh2s) ) + 2.0_dp*ap2*ln1 - bp3*( a_rh2p2*(a_rh2p2-2.0_dp*c_rh2p2)*ln2_rh2 + &
              a_rh3p2*(a_rh3p2-2.0_dp*bpc_rh3p2)*ln3_rh3 ) )/24.0_dp

!Ichixz/b
     Ichixz = ( b*(rh3*a_rh2p2*(4.0_dp*b-c-b*a_rh2p2x3)-rh2*a_rh3p2*(bpc-b*a_rh3p2x3)) - &
               bp3*(a_rh2p2*(1.0_dp+3.0_dp*c_rh2p2) + a_rh3p2x3*a_rh3p2) - ap2*(b-c-c)*ln1 + &
               bp2*(bc_rh2*a_rh2p2x3*ln2*c_rh2p2 - bbpc_rh3*a_rh3p2*(1.0_dp+a_rh3p2x3)*ln3) )/24.0_dp

!Ichiz/b
     Ichiz = ( b*( a_rh2p2*( bmrh3 - bc_rh2*ln2 ) + a_rh3p2*( bmrh2 + bbpc_rh3*ln3 ) ) + ap2*ln1 )/6.0_dp

     cQmb = cQ-b
     kQ2 = cQmb/aQ; kQ3 = cQ/aQ
     kP2 = c/a; kP3 = bpc/a
     
     c22kQ2 = c22*kQ2; c22kQ3 = c22*kQ3; c22_aQ = c22/aQ
    
     intKh(1,1) = (kP2*c22kQ2*Ichizzz - Ichixxz + (kP2-c22kQ2)*Ichixzz)/bp2 - Ichixz + kP2*Ichizz
     intKh(2,1) = (Ichixxz - kP3*c22kQ2*Ichizzz - (kP3-c22kQ2)*Ichixzz)/bp2 + 2.0_dp*Ichixz - (kP3-c22kQ2)*Ichizz + b*Ichiz
     intKh(3,1) = (c22kQ2*Ichizzz + Ichixzz)/dlt + b*Ichizz/a
     
     intKh(1,2) = (Ichixxz - (kP2-c22kQ3)*Ichixzz - kP2*c22kQ3*Ichizzz)/bp2
     intKh(2,2) = (kP3*c22kQ3*Ichizzz - Ichixxz  + (kP3-c22kQ3)*Ichixzz)/bp2 - Ichixz - c22kQ3*Ichizz
     intKh(3,2) = -(c22kQ3*Ichizzz + Ichixzz)/dlt
     
     intKh(1,3) = c22_aQ*(kP2*Ichizzz - Ichixzz)/b
     intKh(2,3) = c22_aQ*( b*Ichizz + (Ichixzz - kP3*Ichizzz)/b )
     intKh(3,3) = c22_aQ*Ichizzz/a


     intclN(1,1) = -c22*(kP2*Irhozz - Irhoxz)/b
     intclN(2,1) = -c22*((Irhoxz - kP3*Irhozz)/b + Irhoz)
     intclN(3,1) = -c22*Irhozz/a

     intclM(1,1) = (kP2*Ichizzz - Ichixzz)/b
     intclM(2,1) = (Ichixzz - kP3*Ichizzz)/b + b*Ichizz
     intclM(3,1) = Ichizzz/a


     loop0a: do i=1,mx_nd_elt
        loop0b: do k=1,mx_nd_elt
	   intOme(k,i) = 0.0_dp; intOmeh(k,i) = 0.0_dp
        enddo loop0b
     enddo loop0a

     loop1a: do i=2,3
        loop1b: do k=1,mx_nd_elt
	   intclN(k,i) = 0.0_dp; intclM(k,i) = 0.0_dp; intclNh(k,i) = 0.0_dp; intclMh(k,i) = 0.0_dp
        enddo loop1b
     enddo loop1a

     bhlf = 0.5_dp*b
     cpbhlf = c+bhlf; alpha2 = pi-theta(2); alpha3 = pi+theta(1) ! alpha1 = 0.0_dp
     
     cscf(2) = dcos(alpha2); sncf(2) = dsin(alpha2)
     cscf(3) = dcos(alpha3); sncf(3) = dsin(alpha3)

     vecA(1) = -1.0_dp/b; vecA(2) =  1.0_dp/b; vecA(3) = 0.0_dp
     vecB(1) =  kQ2/b   ; vecB(2) = -kQ3/b   ; vecB(3) = 1.0_dp/aQ
     
     ah(1,1) = vecA(1); ah(2,1) = (kQ2*sncf(2) - cscf(2))/b; ah(3,1) = (kQ2*sncf(3) - cscf(3))/b
     ah(1,2) = vecA(2); ah(2,2) = (cscf(2) - kQ3*sncf(2))/b; ah(3,2) = (cscf(3) - kQ3*sncf(3))/b
     ah(1,3) =  0.0_dp; ah(2,3) = sncf(2)/aQ               ; ah(3,3) = sncf(3)/aQ

     bh(1,1) = -vecB(1); bh(2,1) = -(sncf(2) + kQ2*cscf(2))/b; bh(3,1) = -(sncf(3) + kQ2*cscf(3))/b
     bh(1,2) = -vecB(2); bh(2,2) =  (sncf(2) + kQ3*cscf(2))/b; bh(3,2) =  (sncf(3) + kQ3*cscf(3))/b
     bh(1,3) = -vecB(3); bh(2,3) = -cscf(2)/aQ               ; bh(3,3) = -cscf(3)/aQ

     loop2a: do i=1,ng1 ! Loop over y  :: E'
        y = xi1(i)
	xh = c-cpbhlf*y; zh = a*(1.0_dp-y)
        q1h = -c22*zh
	p31h = xh*cscf(3) + q1h*sncf(3); q3h = q1h*cscf(3) - xh*sncf(3)
        d3h = q3h*q3h
	
        loop2b: do k=1,ng1 ! Loop over x  :: E'
           x = xi1(k)
           xww = x*wwg1(k,i) ! xww = x*wg1(i)*wg1(k)
           xi = x*xh; zt = x*zh; q(1) = x*q1h; p31 = x*p31h; q(3) = x*q3h ! p11 = xi
	   p12 = b+xi; x3 = cQ+xi; z3 = aQ+q(1)
	   p22 = p12*cscf(2) + q(1)*sncf(2); q(2) = q(1)*cscf(2) - p12*sncf(2)
	   p23 = x3*cscf(2) + z3*sncf(2); p33 = x3*cscf(3) + z3*sncf(3)
	   zts = zt*zt; qs(2) = q(2)*q(2); qs(3) = x*x*d3h

	   rho(1) = dsqrt(xi*xi + zts); rho(2) = dsqrt(p12*p12 + zts); rho(3) = dsqrt(p33*p33 + q(3)*q(3))

	   psi(1) = shfe1(1,k,i); psi(2) = shfe1(2,k,i); psi(3) = shfe1(3,k,i) ! psi(1) = 0.5_dp*x*y; psi(3) = x*(1.0_dp-y)
									       ! psi(2) = 1.0_dp + x*(0.5_dp*y-1.0_dp)

           shc(2) = -(xi+c22kQ3*zt)/b; shc(3) = c22_aQ*zt
	   shc(1) = 1.0_dp - (shc(2)+shc(3)) ! shc(1) = 1.0_dp + (xi+c22kQ2*zt)/b

	   rhowv(2) = rho(2)-rho(3); rhowv(3) = rho(3)-rho(1)

	   chi(2) = dlog( (p22+rho(2))/(p23+rho(3)) )
	   ch31 = p31+rho(1); ch33 = p33+rho(3)
	   if ( (ch31 >= f_eps) .and. (ch33 >= f_eps) ) then
		chi(3) = -dlog(ch31/ch33)
	   else
		z1 = q3h/p31h; z2 = q(3)/p33
		z1s = z1*z1; z2s = z2*z2
		chi(3) = -dlog( (p33/p31)*( (1.0_dp-0.25_dp*z1s*(1.0_dp-0.5_dp*z1s))/(1.0_dp-0.25_dp*z2s*(1.0_dp-0.5_dp*z2s)) ) )
	   endif
	   
           xwp(1) = xww*psi(1)
	   loop3: do ii=2,3
              xwp(ii) = xww*psi(ii); dchi(ii) = qs(ii)*chi(ii); qrhowv(ii) = q(ii)*rhowv(ii)
           enddo loop3
	   
	   omega = q(2)*chi(2) + q(3)*chi(3)
           
           loop4a: do ii=1,mx_nd_elt
	      loop4b: do kk=1,mx_nd_elt
		 intOmeh(kk,ii) = intOmeh(kk,ii) + xwp(kk)*shc(ii)*omega
              enddo loop4b
           enddo loop4a
           

           loop5a: do ii=2,3
              loop5b: do kk=1,mx_nd_elt
                 intclNh(kk,ii) = intclNh(kk,ii) + xwp(kk)*qrhowv(ii)
		 intclMh(kk,ii) = intclMh(kk,ii) + xwp(kk)*dchi(ii)
              enddo loop5b
           enddo loop5a

         enddo loop2b ! End Loop over x  :: E'
     enddo loop2a ! End Loop over y  :: E'


     loop6a: do i=1,ng1 ! Loop over y  :: E"
        y = xi1(i)
        xh = bhlf+cpbhlf*y; zh = a*y
	q1h = -c22*zh
	p22h = xh*cscf(2) + q1h*sncf(2); q2h = q1h*cscf(2) - xh*sncf(2)
        d2h = q2h*q2h

        loop6b: do k=1,ng1 ! Loop over x  :: E"
           x = xi1(k)
           xww = x*wwg1(k,i) ! xww = x*wg1(i)*wg1(k)
           xi = x*xh; zt = x*zh; q(1) = x*q1h; p22 = x*p22h; q(2) = x*q2h ! p12 = xi
	   p11 = xi-b; x3 = cQmb+xi; z3 = aQ+q(1)
	   p23 = x3*cscf(2) + z3*sncf(2); p33 = x3*cscf(3) + z3*sncf(3)
	   p31 = p11*cscf(3) + q(1)*sncf(3); q(3) = q(1)*cscf(3) - p11*sncf(3)
	   zts = zt*zt; qs(2) = x*x*d2h; qs(3) = q(3)*q(3)

	   rho(1) = dsqrt(p11*p11 + zts); rho(2) = dsqrt(xi*xi + zts); rho(3) = dsqrt(p33*p33 + qs(3))

	   psi(1) = shfe2(1,k,i); psi(2) = shfe2(2,k,i); psi(3) = shfe2(3,k,i) ! psi(1) = 1.0_dp-0.5_dp*x*(1.0_dp+y); psi(3) = x*y
									       ! psi(2) = 0.5_dp*x*(1.0_dp-y)

           shc(1) = (xi+c22kQ2*zt)/b; shc(3) = c22_aQ*zt
	   shc(2) = 1.0_dp -(shc(1)+shc(3)) ! shc(2) = 1.0_dp - (xi+c22kQ3*zt)/b

	   rhowv(2) = rho(2)-rho(3); rhowv(3) = rho(3)-rho(1)

	   chi(2) = dlog( (p22+rho(2))/(p23+rho(3)) )
	   ch31 = p31+rho(1); ch33 = p33+rho(3)
	   if ( (ch31 >= f_eps) .and. (ch33 >= f_eps) ) then
		chi(3) = -dlog(ch31/ch33)
	   else
		z1 = q(3)/p31; z2 = q(3)/p33
		z1s = z1*z1; z2s = z2*z2
		chi(3) = -dlog( (p33/p31)*( (1.0_dp-0.25_dp*z1s*(1.0_dp-0.5_dp*z1s))/(1.0_dp-0.25_dp*z2s*(1.0_dp-0.5_dp*z2s)) ) )
	   endif

           xwp(1) = xww*psi(1)
	   loop7: do ii=2,3
              xwp(ii) = xww*psi(ii); dchi(ii) = qs(ii)*chi(ii); qrhowv(ii) = q(ii)*rhowv(ii)
           enddo loop7
	   
	   omega = q(2)*chi(2) + q(3)*chi(3)
           
           loop8a: do ii=1,mx_nd_elt
	      loop8b: do kk=1,mx_nd_elt
		 intOme(kk,ii) = intOme(kk,ii) + xwp(kk)*shc(ii)*omega
              enddo loop8b
           enddo loop8a
           
           loop9a: do ii=2,3
              loop9b: do kk=1,mx_nd_elt
                 intclN(kk,ii) = intclN(kk,ii) + xwp(kk)*qrhowv(ii)
		 intclM(kk,ii) = intclM(kk,ii) + xwp(kk)*dchi(ii)
              enddo loop9b
           enddo loop9a
           
         enddo loop6b ! End Loop over x :: E"
     enddo loop6a ! End Loop over y  :: E"

    dltHlf = 0.5_dp*dlt

    loop10a: do k=2,3
       loop10b: do i=1,mx_nd_elt    ! Loop over all nodes
          intclN(i,k) = dltHlf*(intclN(i,k) +  intclNh(i,k))
	  intclM(i,k) = dltHlf*(intclM(i,k) +  intclMh(i,k))
       enddo loop10b
    enddo loop10a

!*** int_f = matmul(intclN,ah) - matmul(intclM,bh)
     call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intclM,mx_nd_elt,bh,3, 0.0_dp,int_f,mx_nd_elt) ! int_f = matmul(intclM,bh)
     call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intclN,mx_nd_elt,ah,3,-1.0_dp,int_f,mx_nd_elt) ! int_f = matmul(intclN,ah) - int_f

    loop11a: do k=1,mx_nd_elt
       loop11b: do i=1,mx_nd_elt
	  intOme(i,k) = dltHlf*(intOme(i,k) + intOmeh(i,k)) - c22*intKh(i,k)
       enddo loop11b
    enddo loop11a

    loop12a: do k=1,mx_nd_elt
       loop12b: do i=1,mx_nd_elt
	  int_f(i,k) = 0.5_dp*int_f(i,k) + intOme(i,k) ! Weakly-singular kernel ==> G
	  int_p(i,k) = 0.0_dp                          ! Singular kernel ==> H
	  int_r(i,k) = 0.0_dp                          ! Reverse kernel ==> H
       enddo loop12b
    enddo loop12a

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE seesp
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_lap_fld_eval(nip,ipts,fldvl)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!*********************************************  GALERKIN BEM for 3D LAPLACE EQUATION  *********************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!***************************************  3-NODED TRIANGULAR ELEMENT: ANALYTIC INTEGRATION  ***************************************!
!********************************  Exact integration with Linear distribution on a flat triangle  *********************************!
!***********************************  Given an array of field points ipts(:,i), i=1,2,...,nip  ************************************!
!***********  Determine the potential at all field points ipts(:,i) due to boundary distribution of potential and flux  ***********!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


!*** Typical triangular element with vertices {y1,y2,y3}

!           y3
!	    *
!	   / \
!	  /   \
!	 /     \
!       /       \
!      /	 \
!     /		  \
!    *-------------*
!  y1               y2

! Oriented edge L1 = [y1,y2] <== Edge1
! Oriented edge L2 = [y2,y3] <== Edge2
! Oriented edge L3 = [y3,y1] <== Edge3

 
USE KINDS
USE PARAMS,   ONLY: pi,fac       ! pi = 3.1415926535897932, fac == Factor of the Green's function: fac = 1/(4*pi)
USE PARAMS,   ONLY: gm_eps,f_eps ! gm_eps == Tolerance on the geometry, f_eps == Tolerance on the argument of a function
USE SRF_GEOM, ONLY: mx_nd_elt    ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: nbnd,nbelt   ! nbnd == Total number of boundary nodes, nbelt == Total number of boundary elements
USE SRF_GEOM, ONLY: belt         ! belt(:,i) == Global indices of boundary nodes on the i-th element
USE SRF_GEOM, ONLY: bnd          ! bnd(:,i) == Cartesian coordinates of the i-th boundary node
USE SRF_GEOM, ONLY: LocCBasisElt ! LocCBasisElt(1:9,k) == Local Companion Basis associated with the k-th boundary element
USE SRF_GEOM, ONLY: xvElt,zvElt  ! xvElt(1,k) == Base of the k-th boundary element
				 ! xvElt(2,k) == Geometric parameter associated with the k-th boundary element
				 ! zvElt(k) == Height of the k-th boundary element
USE SRF_GEOM, ONLY: thetaElt     ! thetaElt(i,k) == Angle at the i-th vertex of the k-th boundary element
USE POTFLUX,  ONLY: phi,flx      ! phi == Vector containing boundary potentials, flx == Vector containing boundary fluxes


IMPLICIT NONE


 integer(kind=k9), intent(in ) :: nip ! nip == Number of interior points
 real   (kind=dp), intent(in ) :: ipts(3,nip) ! ipts(:,i) == Cartesian coordinates of the i-th interior (or field) point
 real   (kind=dp), intent(out) :: fldvl(nip)  ! fldvl(i) == Potential at the i-th interior point

 integer(kind=k9) :: i,k,j,th_id,alloc_st,elQ ! elQ == Global index of the boundary element Q
 integer(kind=k9) :: qq(mx_nd_elt)
 real   (kind=dp) :: e1(3),e2(3),e3(3) ! Orthonormal local basis associated with element Q
 real   (kind=dp) :: aQ,bQ,cQ ! Geometric parameters of element Q: bQ = base, aQ = height,
 			      ! cQ = relative position of the 3rd node of element Q in the local basis {e1,e2,e3}
 real   (kind=dp) :: r1(3),xi,zt,eth,et,ets,q(3),qs(3),d(3),rho(3),rhowv(3),chi(3),dchi(3),gamma(3),gam
 real   (kind=dp) :: theta(3),alpha2,alpha3,Rh(3),Rhs(3),ch11,ch12,ch22,ch23,ch31,ch33
 real   (kind=dp) :: kQ2,kQ3 ! kQ2 == Slope of Edge2 of element Q, kQ3 == Slope of Edge3 of element Q
 real   (kind=dp) :: vecA(3),vecB(3),sncf(2:3),cscf(2:3),ah(3,3),bh(3,3),qetx2(3),etchi(3),qrhowv(3)
 real   (kind=dp) :: p11,p12,p22,p23,p33,p31,x3,z3,rh1s,rh2s,rh3s,p11s,p12s,p33s,p11rh1,p31rh1,omega
 real   (kind=dp) :: cr11,cr12,zn1,zd1,cr22,cr23,zn2,zd2,cr31,cr33,zn3,zd3,p12rh2,p22rh2,p23rh3,p33rh3,theta0,ThetGam
 real   (kind=dp) :: shc(mx_nd_elt),int_p(mx_nd_elt),int_f(mx_nd_elt)
 real(kind=dp), pointer :: int_G(:) ! int_G == Flux influence vector necessary to evaluate the potential at field points
 real(kind=dp), pointer :: int_H(:) ! int_H == Potential influence vector necessary to evaluate the potential at field points
!*** Note: Below, the Projection of the collocation point ipts(:,i) means the Projection of the collocation point ipts(:,i) on
!*** Note: the plane of element Q in the direction e3. e3 is the unit normal to element Q

 real(kind=dp), external :: pt_tria_tst,gammai,asym_chi ! External functions (see gbem_util.f90)



    loop0: do k=1,nip    ! Loop over all interior points
       fldvl(k) = 0.0_dp ! Initialize the potential fldvl(k) at all interior points
    enddo loop0

    allocate(int_G(nbnd),int_H(nbnd),STAT=alloc_st)
    if ( alloc_st /= 0 ) then  ! If int_G, int_H are not successfully allocated 
       write(*,*)'gbem_lap_fld_eval: Allocate arrays "int_G, int_H" failed with Status=',alloc_st
       stop
    endif
    
    loop1: do j=1,nip ! Loop over all interior points

       loop2: do k=1,nbnd ! Loop over all boundary nodes
          int_G(k) = 0.0_dp; int_H(k) = 0.0_dp
       enddo loop2

       loop3: do elQ=1,nbelt ! Loop over all boundary elements

          loop4: do k=1,mx_nd_elt ! Loop over the nodes of element Q
             qq(k) = belt(k,elQ) ! qq(k) == Global index of the k-th node of the boundary element Q
          enddo loop4

          e1(1) = LocCBasisElt(1,elQ); e1(2) = LocCBasisElt(2,elQ); e1(3) = LocCBasisElt(3,elQ)
          e2(1) = LocCBasisElt(4,elQ); e2(2) = LocCBasisElt(5,elQ); e2(3) = LocCBasisElt(6,elQ)
          e3(1) = LocCBasisElt(7,elQ); e3(2) = LocCBasisElt(8,elQ); e3(3) = LocCBasisElt(9,elQ)

          theta(1) = thetaElt(1,elQ); theta(2) = thetaElt(2,elQ); theta(3) = thetaElt(3,elQ)

           alpha2 = pi-theta(2); alpha3 = pi+theta(1) ! alpha1 = 0.0_dp

           aQ = zvElt(elQ)   ! aQ>0.0_dp always
           bQ = xvElt(1,elQ) ! bQ >0.0_dp always
           cQ = xvElt(2,elQ)

           kQ2 = (cQ-bQ)/aQ; kQ3 = cQ/aQ ! kQ2 == Slope of Side 2 of element Q, kQ3 == Slope of Side 3 of element Q

           cscf(2) = dcos(alpha2); sncf(2) = dsin(alpha2); cscf(3) = dcos(alpha3); sncf(3) = dsin(alpha3)
 
           vecA(1) = -1.0_dp/bQ; vecA(2) =  1.0_dp/bQ; vecA(3) = 0.0_dp
           vecB(1) =  kQ2/bQ   ; vecB(2) = -kQ3/bQ   ; vecB(3) = 1.0_dp/aQ
 
           ah(1,1) = vecA(1); ah(2,1) = (kQ2*sncf(2) - cscf(2))/bQ; ah(3,1) = (kQ2*sncf(3) - cscf(3))/bQ
           ah(1,2) = vecA(2); ah(2,2) = (cscf(2) - kQ3*sncf(2))/bQ; ah(3,2) = (cscf(3) - kQ3*sncf(3))/bQ
           ah(1,3) =  0.0_dp; ah(2,3) = sncf(2)/aQ		  ; ah(3,3) = sncf(3)/aQ
 
           bh(1,1) = -vecB(1); bh(2,1) = -(sncf(2) + kQ2*cscf(2))/bQ; bh(3,1) = -(sncf(3) + kQ2*cscf(3))/bQ
           bh(1,2) = -vecB(2); bh(2,2) =  (sncf(2) + kQ3*cscf(2))/bQ; bh(3,2) =  (sncf(3) + kQ3*cscf(3))/bQ
           bh(1,3) = -vecB(3); bh(2,3) = -cscf(2)/aQ		    ; bh(3,3) = -cscf(3)/aQ
 
            loop6: do k=1,3 ! Loop over all components
               r1(k) = ipts(k,j) - bnd(k,qq(1)) ! r1 = ipts(:,i)-y1
            enddo loop6

              xi = r1(1)*e1(1) + r1(2)*e1(2) + r1(3)*e1(3)
              zt = r1(1)*e2(1) + r1(2)*e2(2) + r1(3)*e2(3)
             eth = r1(1)*e3(1) + r1(2)*e3(2) + r1(3)*e3(3)

              p11 = -xi; p12 = bQ-xi; q(1) = -zt; et = -eth

              if (dabs(et) < gm_eps) et = 0.0_dp

              x3 = cQ+p11; z3 = aQ+q(1)
              p22 = p12*cscf(2) + q(1)*sncf(2); p23 = x3*cscf(2) + z3*sncf(2); q(2) = q(1)*cscf(2) - p12*sncf(2)
              p31 = p11*cscf(3) + q(1)*sncf(3); p33 = x3*cscf(3) + z3*sncf(3); q(3) = q(1)*cscf(3) - p11*sncf(3)

              ets = et*et; p11s = p11*p11; p12s = p12*p12; p33s = p33*p33; qs(1) = q(1)*q(1); qs(2) = q(2)*q(2); qs(3) = q(3)*q(3)

              Rhs(1) = p11s + qs(1); Rhs(2) = p12s + qs(1); Rhs(3) = p33s + qs(3) ! Rhs(3) = x3*x3 + z3*z3
              Rh(1) = dsqrt(Rhs(1)); Rh(2) = dsqrt(Rhs(2)); Rh(3) = dsqrt(Rhs(3))
              rh1s = Rhs(1) + ets; rh2s = Rhs(2) + ets; rh3s = Rhs(3) + ets
              rho(1) = dsqrt(rh1s); rho(2) = dsqrt(rh2s); rho(3) = dsqrt(rh3s)

              shc(3) = -q(1)/aQ; shc(2) = (kQ3*q(1) - p11)/bQ
              shc(1) = 1.0_dp - (shc(2)+shc(3)) ! shc(1) = 1.0_dp + (p11 - kQ2*q(1))/bQ

              if ( dabs(shc(1)) < gm_eps ) then
        	 shc(1) = 0.0_dp; q(2) = 0.0_dp
              endif
 
              if ( dabs(shc(2)) < gm_eps ) then
        	 shc(2) = 0.0_dp; q(3) = 0.0_dp
              elseif ( dabs(shc(2)-1.0_dp) < gm_eps ) then
        	 shc(2) = 1.0_dp
              endif
 
              if ( dabs(shc(3)) < gm_eps ) then
        	 shc(3) = 0.0_dp; q(1) = 0.0_dp
              elseif ( dabs(shc(3)-1.0_dp) < gm_eps ) then
        	 shc(3) = 1.0_dp
              endif


              theta0 = pt_tria_tst(shc(1),shc(2),shc(3),theta,th_id) ! Point in triangle test

              if ( th_id == 4 ) then ! if the Projection of the collocation point ipts(:,i) is at vertex y1
        	 Rh(1) = 0.0_dp
        	 if (et == 0.0_dp) rho(1) = 0.0_dp ! ipts(:,i) = y1
              elseif ( th_id == 5 ) then ! if the Projection of the collocation point ipts(:,i) is at vertex y2
        	 Rh(2) = 0.0_dp
        	 if (et == 0.0_dp) rho(2) = 0.0_dp ! ipts(:,i) = y2
              elseif ( th_id == 6 ) then ! if the Projection of the collocation point ipts(:,i) is at vertex y3
        	 Rh(3) = 0.0_dp
        	 if (et == 0.0_dp) rho(3) = 0.0_dp ! ipts(:,i) = y3
              endif

              qetx2(1) = 2.0_dp*q(1)*et; qetx2(2) = 2.0_dp*q(2)*et; qetx2(3) = 2.0_dp*q(3)*et

              p11rh1 = p11*rho(1); p12rh2 = p12*rho(2)
              p22rh2 = p22*rho(2); p23rh3 = p23*rho(3)
              p33rh3 = p33*rho(3); p31rh1 = p31*rho(1)

             if ( rho(1) == 0.0_dp ) then ! if the collocation point ipts(:,i) is at vertex y1, i.e., ipts(:,i) = y1
               int_p(1) = theta0; int_p(2) = 0.0_dp; int_p(3) = 0.0_dp ! gam = 0.0_dp
               rhowv(2) = rho(2)-rho(3); chi(2) = dlog( (p22+rho(2))/(p23+rho(3)) )
               qrhowv(2) = q(2)*rhowv(2); dchi(2) = qs(2)*chi(2)
               int_f(1) = 0.5_dp*(qrhowv(2)*ah(2,1) - dchi(2)*bh(2,1)) + q(2)*chi(2)
               int_f(2) = 0.5_dp*(qrhowv(2)*ah(2,2) - dchi(2)*bh(2,2))
               int_f(3) = 0.5_dp*(qrhowv(2)*ah(2,3) - dchi(2)*bh(2,3))

             elseif ( rho(2) == 0.0_dp ) then ! if the collocation point ipts(:,i) is at vertex y2, i.e., ipts(:,i) = y2
               int_p(1) = 0.0_dp; int_p(2) = theta0; int_p(3) = 0.0_dp ! gam = 0.0_dp
               rhowv(3) = rho(3)-rho(1); chi(3) = dlog( (p33+rho(3))/(p31+rho(1)) )
               qrhowv(3) = q(3)*rhowv(3); dchi(3) = qs(3)*chi(3)
               int_f(1) = 0.5_dp*(qrhowv(3)*ah(3,1) - dchi(3)*bh(3,1))
               int_f(2) = 0.5_dp*(qrhowv(3)*ah(3,2) - dchi(3)*bh(3,2)) + q(3)*chi(3)
               int_f(3) = 0.5_dp*(qrhowv(3)*ah(3,3) - dchi(3)*bh(3,3))

             elseif ( rho(3) == 0.0_dp ) then ! if the collocation point ipts(:,i) is at vertex y3, i.e., ipts(:,i) = y3
               int_p(1) = 0.0_dp; int_p(2) = 0.0_dp; int_p(3) = theta0 ! gam = 0.0_dp
               rhowv(1) = rho(1)-rho(2); chi(1) = dlog( (p11+rho(1))/(p12+rho(2)) )
               qrhowv(1) = q(1)*rhowv(1); dchi(1) = qs(1)*chi(1)
               int_f(1) = 0.5_dp*(qrhowv(1)*ah(1,1) - dchi(1)*bh(1,1))
               int_f(2) = 0.5_dp*(qrhowv(1)*ah(1,2) - dchi(1)*bh(1,2))
               int_f(3) = 0.5_dp*(qrhowv(1)*ah(1,3) - dchi(1)*bh(1,3)) + q(1)*chi(1)

             else
 		    if ( Rh(1) == 0.0_dp ) then ! if the Projection of the collocation point ipts(:,i) is at vertex y1
 		    	  cr22 = qs(2)*rh2s-p22*p22*ets; cr23 = qs(2)*rh3s-p23*p23*ets
 		    	  zn2 = qetx2(2)*(p23rh3*cr22 - p22rh2*cr23); zd2 = cr22*cr23 + qetx2(2)*qetx2(2)*p22rh2*p23rh3
 		    	  gam = gammai(p22,p23,qetx2(2),cr22,cr23,zn2,zd2) ! gam = gamma(2); gamma(1) = -gamma(3) = +pi or -pi

 		    elseif ( Rh(2) == 0.0_dp ) then ! if the Projection of the collocation point ipts(:,i) is at vertex y2
 		    	  cr33 = qs(3)*rh3s - p33s*ets; cr31 = qs(3)*rh1s - p31*p31*ets
 		    	  zn3 = qetx2(3)*(p31rh1*cr33 - p33rh3*cr31); zd3 = cr31*cr33 + qetx2(3)*qetx2(3)*p31rh1*p33rh3
 		    	  gam = gammai(p33,p31,qetx2(3),cr33,cr31,zn3,zd3) ! gam = gamma(3); gamma(1) = -gamma(2) = +pi or -pi

 		    elseif ( Rh(3) == 0.0_dp ) then ! if the Projection of the collocation point ipts(:,i) is at vertex y3
 		    	  cr11 = qs(1)*rh1s - p11s*ets; cr12 = qs(1)*rh2s - p12s*ets
 		    	  zn1 = qetx2(1)*(p12rh2*cr11 - p11rh1*cr12); zd1 = cr11*cr12 + qetx2(1)*qetx2(1)*p11rh1*p12rh2
 		    	  gam = gammai(p11,p12,qetx2(1),cr11,cr12,zn1,zd1) ! gam = gamma(1); gamma(2) = -gamma(3) = +pi or -pi

 		    elseif ( q(1) == 0.0_dp ) then ! if the Projection of the collocation point ipts(:,i) is on the line parallel to edge [y1,y2]
 		    	  cr22 = qs(2)*rh2s-p22*p22*ets; cr23 = qs(2)*rh3s-p23*p23*ets
 		    	  zn2 = qetx2(2)*(p23rh3*cr22 - p22rh2*cr23); zd2 = cr22*cr23 + qetx2(2)*qetx2(2)*p22rh2*p23rh3

 		    	  cr33 = qs(3)*rh3s - p33s*ets; cr31 = qs(3)*rh1s - p31*p31*ets
 		    	  zn3 = qetx2(3)*(p31rh1*cr33 - p33rh3*cr31); zd3 = cr31*cr33 + qetx2(3)*qetx2(3)*p31rh1*p33rh3
 
 		    	  gamma(2) = gammai(p22,p23,qetx2(2),cr22,cr23,zn2,zd2)
 		    	  gamma(3) = gammai(p33,p31,qetx2(3),cr33,cr31,zn3,zd3)
 		    	  gam = gamma(2)+gamma(3)

 		    elseif ( q(2) == 0.0_dp ) then ! if the Projection of the collocation point ipts(:,i) is on the line parallel to edge [y2,y3]
 		    	  cr11 = qs(1)*rh1s - p11s*ets; cr12 = qs(1)*rh2s - p12s*ets
 		    	  zn1 = qetx2(1)*(p12rh2*cr11 - p11rh1*cr12); zd1 = cr11*cr12 + qetx2(1)*qetx2(1)*p11rh1*p12rh2

 		    	  cr33 = qs(3)*rh3s - p33s*ets; cr31 = qs(3)*rh1s - p31*p31*ets
 		    	  zn3 = qetx2(3)*(p31rh1*cr33 - p33rh3*cr31); zd3 = cr31*cr33 + qetx2(3)*qetx2(3)*p31rh1*p33rh3
 
 		    	  gamma(1) = gammai(p11,p12,qetx2(1),cr11,cr12,zn1,zd1)
 		    	  gamma(3) = gammai(p33,p31,qetx2(3),cr33,cr31,zn3,zd3)
 		    	  gam = gamma(1)+gamma(3)

 		    elseif ( q(3) == 0.0_dp ) then ! if the Projection of the collocation point ipts(:,i) is on the line parallel to edge [y3,y1]
 		    	  cr11 = qs(1)*rh1s - p11s*ets; cr12 = qs(1)*rh2s - p12s*ets
 		    	  zn1 = qetx2(1)*(p12rh2*cr11 - p11rh1*cr12); zd1 = cr11*cr12 + qetx2(1)*qetx2(1)*p11rh1*p12rh2

 		    	  cr22 = qs(2)*rh2s-p22*p22*ets; cr23 = qs(2)*rh3s-p23*p23*ets
 		    	  zn2 = qetx2(2)*(p23rh3*cr22 - p22rh2*cr23); zd2 = cr22*cr23 + qetx2(2)*qetx2(2)*p22rh2*p23rh3
 
 		    	  gamma(1) = gammai(p11,p12,qetx2(1),cr11,cr12,zn1,zd1)
 		    	  gamma(2) = gammai(p22,p23,qetx2(2),cr22,cr23,zn2,zd2)
 		    	  gam = gamma(1)+gamma(2)

 		    else
 		    	  cr11 = qs(1)*rh1s - p11s*ets; cr12 = qs(1)*rh2s - p12s*ets
 		    	  zn1 = qetx2(1)*(p12rh2*cr11 - p11rh1*cr12); zd1 = cr11*cr12 + qetx2(1)*qetx2(1)*p11rh1*p12rh2

 		    	  cr22 = qs(2)*rh2s-p22*p22*ets; cr23 = qs(2)*rh3s-p23*p23*ets
 		    	  zn2 = qetx2(2)*(p23rh3*cr22 - p22rh2*cr23); zd2 = cr22*cr23 + qetx2(2)*qetx2(2)*p22rh2*p23rh3

 		    	  cr33 = qs(3)*rh3s - p33s*ets; cr31 = qs(3)*rh1s - p31*p31*ets
 		    	  zn3 = qetx2(3)*(p31rh1*cr33 - p33rh3*cr31); zd3 = cr31*cr33 + qetx2(3)*qetx2(3)*p31rh1*p33rh3
 
 		    	  gamma(1) = gammai(p11,p12,qetx2(1),cr11,cr12,zn1,zd1)
 		    	  gamma(2) = gammai(p22,p23,qetx2(2),cr22,cr23,zn2,zd2)
 		    	  gamma(3) = gammai(p33,p31,qetx2(3),cr33,cr31,zn3,zd3)
 		    	  gam = gamma(1)+gamma(2)+gamma(3)

 		    endif

        	    rhowv(1) = rho(1)-rho(2); rhowv(2) = rho(2)-rho(3); rhowv(3) = rho(3)-rho(1)

        	    d(1) = qs(1) + ets; d(2) = qs(2) + ets; d(3) = qs(3) + ets

        	    ch11 = p11+rho(1); ch12 = p12+rho(2)
        	    ch22 = p22+rho(2); ch23 = p23+rho(3)
        	    ch31 = p31+rho(1); ch33 = p33+rho(3)

 		    if ( (ch11 >= f_eps) .and. (ch12 >= f_eps) ) then
 		       chi(1) = dlog(ch11/ch12)
 		    else
 		       chi(1) = asym_chi(p11,p12,d(1))
 		    endif

 		    if ( (ch22 >= f_eps) .and. (ch23 >= f_eps) ) then
 		       chi(2) = dlog(ch22/ch23)
 		    else
 		       chi(2) = asym_chi(p22,p23,d(2))
 		    endif

 		    if ( (ch33 >= f_eps) .and. (ch31 >= f_eps) ) then
 		       chi(3) = dlog(ch33/ch31)
 		    else
 		       chi(3) = asym_chi(p33,p31,d(3))
 		    endif

 		    omega = q(1)*chi(1) + q(2)*chi(2) + q(3)*chi(3)

 		    loop7: do k=1,mx_nd_elt
 		       dchi(k) = d(k)*chi(k); qrhowv(k) = q(k)*rhowv(k); etchi(k) = et*chi(k)
 		    enddo loop7
 
 		     if ( et >= 0.0_dp ) then
 		    	ThetGam = 0.5_dp*gam + theta0
 		     else
 		    	ThetGam = 0.5_dp*gam - theta0
 		     endif

 		    loop8a: do k=1,mx_nd_elt ! Loop over all nodes on element Q
 		       int_f(k) = 0.0_dp; int_p(k) = 0.0_dp
 		       loop8b: do i=1,3 ! Loop over all components
 		    	  int_f(k) = int_f(k) + qrhowv(i)*ah(i,k) - dchi(i)*bh(i,k)
 		    	  int_p(k) = int_p(k) - etchi(i)*bh(i,k)
 		       enddo loop8b
 		       int_f(k) = 0.5_dp*int_f(k) + (omega - et*ThetGam)*shc(k)
 		       int_p(k) = int_p(k) - ThetGam*shc(k)
 		    enddo loop8a
 
             endif ! if The collocation point ipts(:,i) is at vertex y1, i.e., ipts(:,i) = y1

           loop9: do k=1,mx_nd_elt
              int_G(qq(k)) = int_G(qq(k)) + int_f(k); int_H(qq(k)) = int_H(qq(k)) + int_p(k)
           enddo loop9
 
       enddo loop3 ! Loop over all boundary elements

       loop10: do k=1,nbnd ! Loop over all boundary nodes
          fldvl(j) = fldvl(j) + int_G(k)*flx(k) - int_H(k)*phi(k) ! fldvl(j) = dot_product(int_G,flx) - dot_product(int_H,phi)
       enddo loop10

    enddo loop1 ! Loop over all interior points    

    loop11: do k=1,nip ! Loop over all interior points
       fldvl(k) = fac*fldvl(k) ! Correct the potential at all interior points by the factor fac
    enddo loop11
    
    deallocate(int_G,int_H)

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_lap_fld_eval
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
PROGRAM gbem3d_lapeq
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!*******************************************************  Example routine  ********************************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


USE KINDS
USE SRF_GEOM, ONLY: nbnd,bnd ! nbnd == Total number of boundary nodes
			     ! bnd(:,i) == Cartesian coordinates of the i-th boundary node
USE POTFLUX,  ONLY: phi,flx  ! phi == Vector containing boundary potentials, flx == Vector containing boundary fluxes


IMPLICIT NONE

 character(len=72) :: InputFileData, InputFileParams
 integer(kind=k9)  :: i,k,l,alloc_st,nintpts ! nintpts == Number of interior points
 real   (kind=dp)  :: tm0, tm1 ! time variables
 real   (kind=dp)  :: Perr,Ferr
 real   (kind=dp), pointer :: extsol(:)   ! Exact solution
 real   (kind=dp), pointer :: intpts(:,:) ! intpts(:,i) == Cartesian coordinates of the i-th interior (or field) point
 real   (kind=dp), pointer :: pot_ip(:)   ! pot_ip(i) == Potential at the i-th interior point



    call cpu_time(tm0) ! Initial time

    InputFileData = 'bndata.dat'; InputFileParams = 'gbem_lap_par.dat'

    call gbem_lap_srf_eval(InputFileParams,InputFileData,tm0) ! Solve the Singular BIE for the Laplace equation

    call cpu_time(tm1) ! Current time
    write(*,*)'Time == ',tm1-tm0,'s'

    write(*,100)' >>>  Write the boundary potential and flux at Discrete boundary nodes  <<<'

    allocate(extsol(nbnd),STAT=alloc_st)
    if ( alloc_st /= 0 ) then ! If extsol is not successfully allocated 
       write(*,*)'lap_ex: Allocate array "extsol" failed with Status=',alloc_st
       stop
    endif
    
    open (unit=54, file='potl.dat', action='write')
       write(54,*) ' phi '
       write(54,1000)'Nodes','x','y','z','GBEM','Exact','Error'
       loop12: do i=1,nbnd ! Loop over all boundary nodes
	 extsol(i) = dexp(bnd(1,i))*dsin(bnd(3,i)) + dexp(bnd(3,i))*dcos(bnd(2,i)) ! Exact solution
        write(54,999) i, bnd(:,i), phi(i), extsol(i), dabs(extsol(i)-phi(i))
       enddo loop12
    close(unit=54, status='keep')
    Perr = dsqrt(dot_product(phi-extsol,phi-extsol)/dot_product(extsol,extsol))
    write(*,*)'Relative Error on Potential == ',Perr

    open (unit=55, file='flux.dat', action='write')
        write(55,*) ' flux '
	write(55,1000)'Nodes','x','y','z','GBEM','Exact','Error'
       
	l=int(nbnd/6) ! l==Number of boundary nodes per face of the cube
       loop13a: do i=1,6 ! loop over all faces
          loop13b: do k=(i-1)*l+1,i*l ! Loop over all boundary nodes on the i-th face
	     if (i==1) then    ! face: x=0
	        extsol(k) = -dexp(bnd(1,k))*dsin(bnd(3,k))
	     elseif(i==2) then ! face: x=1
	        extsol(k) =  dexp(bnd(1,k))*dsin(bnd(3,k))
	     elseif(i==3) then ! face: y=0
	        extsol(k) =  dexp(bnd(3,k))*dsin(bnd(2,k))
	     elseif(i==4) then ! face: y=1
	        extsol(k) = -dexp(bnd(3,k))*dsin(bnd(2,k))
	     elseif(i==5) then ! face: z=0
	        extsol(k) = -dexp(bnd(1,k))*dcos(bnd(3,k)) - dexp(bnd(3,k))*dcos(bnd(2,k))
	     elseif(i==6) then ! face: z=1
	        extsol(k) =  dexp(bnd(1,k))*dcos(bnd(3,k)) + dexp(bnd(3,k))*dcos(bnd(2,k))
	     endif

	     write(55,999) k, bnd(:,k), flx(k), extsol(k), dabs(extsol(k)-flx(k)) ! absolute error
          enddo loop13b
       enddo loop13a
    close(unit=55, status='keep')
    Ferr = dsqrt(dot_product(flx-extsol,flx-extsol)/dot_product(extsol,extsol))
    write(*,*)'Relative Error on Flux == ',Ferr
    write(*,*)'Relative Error on Potential & Flux == ',0.5_dp*(Perr+Ferr)

    deallocate(extsol)

!*** Evaluation at interior point
    write(*,*)'****Evaluation at interior points****'
    nintpts = 3
    allocate(intpts(3,nintpts),pot_ip(nintpts),STAT=alloc_st)
    if ( alloc_st /= 0 ) then  ! If intpts, pot_ip are not successfully allocated 
       write(*,*)'lap_ex.f90: Allocate arrays "intpts, pot_ip" failed with Status=',alloc_st
       stop
    endif
    
    intpts(1,1) = 0.000001_dp; intpts(2,1) = 0.0001_dp; intpts(3,1) = 0.999_dp
    intpts(1,2) = 0.100_dp;    intpts(2,2) = 0.300_dp;  intpts(3,2) = 0.700_dp
    intpts(1,3) = 0.500_dp;    intpts(2,3) = 0.500_dp;  intpts(3,3) = 0.500_dp
    
    call gbem_lap_fld_eval(nintpts,intpts,pot_ip) ! Compute the potential at interior points

    write(*,*)'        GBEM   ','                Exact'
    do i=1,nintpts
       write(*,*)pot_ip(i),dexp(intpts(1,i))*dsin(intpts(3,i)) + dexp(intpts(3,i))*dcos(intpts(2,i))
    enddo

    deallocate(intpts,pot_ip)

!*** Deallocate remaining Global arrays
    call gbem_lap_del ! Deallocate remaining global arrays associated with the GALERKIN BEM
!*** End Deallocate remaining Global arrays
    
    call cpu_time(tm1) ! Current time
    write(*,*)'Time == ',tm1-tm0,'s'


100 format (1x, a)
 1640  format(' r/c ', 2I5, 'symm ', 3E18.6)
  999  format(I4, 1x, 5F16.8,1x,2E16.8)
 6781  format(' error ')
  993  format(I3, 2x, 2F16.8)
  991  format(I3, 2x, 2F16.8)
  989   format('row ',I6,' sum = ',F12.6)
 1000 format(1x,a,t16,a,t32,a,t48,a,t63,a,t79,a,t93,a) 

!----------------------------------------------------------------------------------------------------------------------------------!
END PROGRAM gbem3d_lapeq
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_lap_iex_int_v(elP,elQ)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!*******************************  EXact Inner integral with linear distribution on a flat triangle  *******************************!
!*************************************************  Vertex-adjacent integration  **************************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012

 
USE KINDS
USE PARAMS,   ONLY: pi           ! pi = 3.1415926535897932
USE SRF_GEOM, ONLY: mx_nd_elt    ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: belt         ! belt(:,i) == Global indices of boundary nodes on the i-th element
USE SRF_GEOM, ONLY: bnd          ! bnd(:,i) == Cartesian coordinates of the i-th boundary node
USE SRF_GEOM, ONLY: xeP,xeQ      ! xeP(:,k) == Cartesian coordinates of the k-th node of element P
			         ! xeQ(:,k) == Cartesian coordinates of the k-th node of element Q
USE SRF_GEOM, ONLY: PQmLocId     ! PQmLocId(1) == Local index of the vertex of element P that is adjacent to element Q
			         ! PQmLocId(2) == Local index of the vertex of element Q that is adjacent to element P
USE SRF_GEOM, ONLY: LocCBasisElt ! LocCBasisElt(1:9,k) == Local Companion Basis associated with the k-th boundary element
USE SRF_GEOM, ONLY: thetaElt     ! thetaElt(i,k) == Angle at the i-th vertex of the k-th boundary element
USE SRF_GEOM, ONLY: pp,qq        ! pp(k) == Global index of the k-th node of the boundary element P
				 ! qq(k) == Global index of the k-th node of the boundary element Q
USE DISCR_BIE,ONLY: int_p,int_f  ! int_p == Local contribution for potential influence matrix
				 ! int_f == Local contribution for flux influence matrix
USE DISCR_BIE,ONLY: int_r        ! int_r == Local contribution for potential/flux influence matrix
USE DISCR_BIE,ONLY: h,g          ! h == Potential influence matrix, g == Flux influence matrix


IMPLICIT NONE

 integer(kind=k9), intent(in) :: elP ! elP == Global index of the outer boundary element P
 integer(kind=k9), intent(in) :: elQ ! elQ == Global index of the inner boundary element Q

 integer(kind=k9) :: k,i,row,col
 integer(kind=k9) :: PcoincidentVertex,QcoincidentVertex
 real   (kind=dp) :: e1P(3),e2P(3),e3P(3) ! Orthonormal companion basis associated with element P
 real   (kind=dp) :: e1Q(3),e2Q(3),e3Q(3) ! Orthonormal companion basis associated with element Q
 real   (kind=dp) :: e1(3),e2(3) ! Orthonormal local basis
 real   (kind=dp) :: aP,bP,cP ! Geometric parameters of element P: bP = base, aP = height, 
 			      ! cP = relative position of the 3rd vertex of element P in the local basis {e1P,e2P,e3P}
 real   (kind=dp) :: aQ,bQ,cQ ! Geometric parameters of element Q: bQ = base, aQ = height,
 			      ! cQ = relative position of the 3rd vertex of element Q in the local basis {e1Q,e2Q,e3Q}
 real   (kind=dp) :: QPTransitionMtrx(3,3)
 real   (kind=dp) :: vij(3,2),theta(3),alpha(3),alphaEltP(3),calpk,salpk,x



    PcoincidentVertex = PQmLocId(1); QcoincidentVertex = PQmLocId(2) ! Vertex "PcoincidentVertex" of element P coincides
								     ! with Vertex "QcoincidentVertex" of element Q


!*** Geometry of the inner element Q
    loop0a: do k=1,mx_nd_elt ! Loop over the nodes of element Q
       qq(k) = belt(k,elQ) ! qq(k) == Global index of the k-th node of the inner boundary element Q
       loop0b: do i=1,3 ! Loop over all components
          xeQ(i,k) = bnd(i,qq(k)) ! xeQ(:,k) == Cartesian coordinates of the k-th node of element Q
       enddo loop0b
    enddo loop0a

     e1(1) = LocCBasisElt(1,elQ);  e1(2) = LocCBasisElt(2,elQ);  e1(3) = LocCBasisElt(3,elQ)
     e2(1) = LocCBasisElt(4,elQ);  e2(2) = LocCBasisElt(5,elQ);  e2(3) = LocCBasisElt(6,elQ)
    e3Q(1) = LocCBasisElt(7,elQ); e3Q(2) = LocCBasisElt(8,elQ); e3Q(3) = LocCBasisElt(9,elQ)

    theta(1) = thetaElt(1,elQ); theta(2) = thetaElt(2,elQ); theta(3) = thetaElt(3,elQ)

    alpha(1) = 0.0_dp; alpha(2) = pi-theta(2); alpha(3) = pi+theta(1)
    
!*** Reorder the node numbers of element Q so that the node with local index 1 coincides with the node of element Q
!*** that is adjacent to element P, i.e., consider the permutation of node numbers of the inner element Q
     if (QcoincidentVertex == 1) then ! (/1,2,3/) ==> (/1,2,3/)

	  loop1: do k=1,3 ! Loop over all components
	     e1Q(k) = e1(k); e2Q(k) = e2(k)
	  enddo loop1

     elseif(QcoincidentVertex == 2) then ! (/1,2,3/) ==> (/2,3,1/)

	  loop2: do k=1,3 ! Loop over all components
	     x = xeQ(k,1)
	     xeQ(k,1) = xeQ(k,2)
	     xeQ(k,2) = xeQ(k,3)
	     xeQ(k,3) = x
	  enddo loop2
	  k = qq(1);     x = theta(1)
	  qq(1) = qq(2); theta(1) = theta(2)
	  qq(2) = qq(3); theta(2) = theta(3)
	  qq(3) = k;     theta(3) = x

	calpk = dcos(alpha(2)); salpk = dsin(alpha(2))

        loop3: do k=1,3 ! loop over all components
           e1Q(k) = calpk*e1(k) + salpk*e2(k)
           e2Q(k) = calpk*e2(k) - salpk*e1(k)
        enddo loop3

     else ! QcoincidentVertex == 3: (/1,2,3/) ==> (/3,1,2/)

	  loop4: do k=1,3 ! Loop over all components
	     x = xeQ(k,1)
	     xeQ(k,1) = xeQ(k,3)
	     xeQ(k,3) = xeQ(k,2)
	     xeQ(k,2) = x
	  enddo loop4
	  k = qq(1);     x = theta(1)
	  qq(1) = qq(3); theta(1) = theta(3)
	  qq(3) = qq(2); theta(3) = theta(2)
	  qq(2) = k;     theta(2) = x

	calpk = dcos(alpha(3)); salpk = dsin(alpha(3))

        loop5: do k=1,3 ! loop over all components
           e1Q(k) = calpk*e1(k) + salpk*e2(k)
           e2Q(k) = calpk*e2(k) - salpk*e1(k)
        enddo loop5

     endif

    loop6: do k=1,3 ! Loop over all components
       vij(k,1) = xeQ(k,2) - xeQ(k,1) ! y2-y1 <== Side 1 of element Q
       vij(k,2) = xeQ(k,3) - xeQ(k,1) ! y3-y1 <== Side 3 of element Q
    enddo loop6

    bQ = vij(1,1)*e1Q(1) + vij(2,1)*e1Q(2) + vij(3,1)*e1Q(3) ! bQ>0.0_dp always
    aQ = vij(1,2)*e2Q(1) + vij(2,2)*e2Q(2) + vij(3,2)*e2Q(3) ! aQ>0.0_dp always
    cQ = vij(1,2)*e1Q(1) + vij(2,2)*e1Q(2) + vij(3,2)*e1Q(3)


!*** Geometry of the outer element P
    loop7a: do k=1,mx_nd_elt ! Loop over the nodes of element P
       pp(k) = belt(k,elP) ! pp(k) == Global index of the k-th node of the outer boundary element P
       loop7b: do i=1,3 ! Loop over all components
	  xeP(i,k) = bnd(i,pp(k)) ! xeP(:,k) == Cartesian coordinates of the k-th node of element P
       enddo loop7b   
    enddo loop7a
    
     e1(1) = LocCBasisElt(1,elP);  e1(2) = LocCBasisElt(2,elP);  e1(3) = LocCBasisElt(3,elP)
     e2(1) = LocCBasisElt(4,elP);  e2(2) = LocCBasisElt(5,elP);  e2(3) = LocCBasisElt(6,elP)
    e3P(1) = LocCBasisElt(7,elP); e3P(2) = LocCBasisElt(8,elP); e3P(3) = LocCBasisElt(9,elP)

    alphaEltP(1) = 0.0_dp; alphaEltP(2) = pi-thetaElt(2,elP); alphaEltP(3) = pi+thetaElt(1,elP)

!*** Reorder the node numbers of element P so that the node with local index 1 coincides with the node of element P
!*** that is adjacent to element Q, i.e., consider the permutation of node numbers of the outer element P
     if (PcoincidentVertex == 1) then ! (/1,2,3/) ==> (/1,2,3/)

	  loop8: do k=1,3 ! Loop over all components
	     e1P(k) = e1(k); e2P(k) = e2(k)
	  enddo loop8

     elseif(PcoincidentVertex == 2) then ! (/1,2,3/) ==> (/2,3,1/)

	  loop9: do k=1,3 ! Loop over all components
	     x = xeP(k,1)
	     xeP(k,1) = xeP(k,2)
	     xeP(k,2) = xeP(k,3)
	     xeP(k,3) = x
	  enddo loop9
	  k = pp(1)
	  pp(1) = pp(2)
	  pp(2) = pp(3)
	  pp(3) = k

        calpk = dcos(alphaEltP(2)); salpk = dsin(alphaEltP(2))

        loop10: do k=1,3 ! loop over all components
           e1P(k) = calpk*e1(k) + salpk*e2(k)
           e2P(k) = calpk*e2(k) - salpk*e1(k)
        enddo loop10

     else ! PcoincidentVertex == 3: (/1,2,3/) ==> (/3,1,2/)

	  loop11: do k=1,3 ! Loop over all components
	     x = xeP(k,1)
	     xeP(k,1) = xeP(k,3)
	     xeP(k,3) = xeP(k,2)
	     xeP(k,2) = x
	  enddo loop11
	  k = pp(1)
	  pp(1) = pp(3)
	  pp(3) = pp(2)
	  pp(2) = k

        calpk = dcos(alphaEltP(3)); salpk = dsin(alphaEltP(3))

        loop12: do k=1,3 ! loop over all components
           e1P(k) = calpk*e1(k) + salpk*e2(k)
           e2P(k) = calpk*e2(k) - salpk*e1(k)
        enddo loop12

     endif

    loop13: do k=1,3 ! Loop over all components
       vij(k,1) = xeP(k,2) - xeP(k,1) ! x2-x1 <== Side 1 of element P
       vij(k,2) = xeP(k,3) - xeP(k,1) ! x3-x1 <== Side 3 of element P
    enddo loop13

    bP = vij(1,1)*e1P(1) + vij(2,1)*e1P(2) + vij(3,1)*e1P(3) ! bP>0.0_dp always
    aP = vij(1,2)*e2P(1) + vij(2,2)*e2P(2) + vij(3,2)*e2P(3) ! aP>0.0_dp always
    cP = vij(1,2)*e1P(1) + vij(2,2)*e1P(2) + vij(3,2)*e1P(3)
    

!*** C_ij == Transition matrix from {e1Q,e2Q,e3Q} to {e1P,e2P,e3P}
!*** Projection (Transformation) of e1P to coordinate system {e1Q,e2Q,e3Q} local to elQ
          QPTransitionMtrx(1,1) = e1P(1)*e1Q(1) + e1P(2)*e1Q(2) + e1P(3)*e1Q(3) ! C_11
          QPTransitionMtrx(2,1) = e1P(1)*e2Q(1) + e1P(2)*e2Q(2) + e1P(3)*e2Q(3) ! C_21
	  QPTransitionMtrx(3,1) = e1P(1)*e3Q(1) + e1P(2)*e3Q(2) + e1P(3)*e3Q(3) ! C_31

!*** Projection (Transformation) of e2P to coordinate system {e1Q,e2Q,e3Q} local to elQ
          QPTransitionMtrx(1,2) = e2P(1)*e1Q(1) + e2P(2)*e1Q(2) + e2P(3)*e1Q(3) ! C_12
          QPTransitionMtrx(2,2) = e2P(1)*e2Q(1) + e2P(2)*e2Q(2) + e2P(3)*e2Q(3) ! C_22
	  QPTransitionMtrx(3,2) = e2P(1)*e3Q(1) + e2P(2)*e3Q(2) + e2P(3)*e3Q(3) ! C_32

!*** Projection (Transformation) of e3P to coordinate system {e1Q,e2Q,e3Q} local to elQ
          QPTransitionMtrx(1,3) = e3P(1)*e1Q(1) + e3P(2)*e1Q(2) + e3P(3)*e1Q(3) ! C_13
          QPTransitionMtrx(2,3) = e3P(1)*e2Q(1) + e3P(2)*e2Q(2) + e3P(3)*e2Q(3) ! C_23
	  QPTransitionMtrx(3,3) = e3P(1)*e3Q(1) + e3P(2)*e3Q(2) + e3P(3)*e3Q(3) ! C_33

     call sing_vtx(aP,bP,cP,aQ,bQ,cQ,theta,QPTransitionMtrx,int_p,int_f,int_r) ! Integration for vertex-adjacent elements

     loop15a: do col=1,mx_nd_elt ! Loop over the nodes of element Q
        loop15b: do row=1,mx_nd_elt ! Loop over the nodes of element P
           h(pp(row),qq(col)) = h(pp(row),qq(col)) + int_p(row,col)
	   g(pp(row),qq(col)) = g(pp(row),qq(col)) + int_f(row,col)

!*** Reverse Kernel
           h(qq(col),pp(row)) = h(qq(col),pp(row)) + int_r(row,col)
	   g(qq(col),pp(row)) = g(qq(col),pp(row)) + int_f(row,col)
        enddo loop15b
     enddo loop15a

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_lap_iex_int_v
!----------------------------------------------------------------------------------------------------------------------------------!


!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE sing_vtx(a,b,c,aQ,bQ,cQ,theta,QPTM,int_p,int_f,int_r)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!*******************************  EXact Inner integral with linear distribution on a flat triangle  *******************************!
!**************************************  Singular integration for vertex-adjacent elements  ***************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012

 
USE KINDS
USE PARAMS,   ONLY: pi,gm_eps ! pi = 3.1415926535897932, gm_eps == Tolerance on the geometry
USE SRF_GEOM, ONLY: mx_nd_elt ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: shfv      ! shfv(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for vertex-adjacent case
USE GAUSS1D,  ONLY: ng1,xi1   ! ng1 == Number of Gauss-Legendre points over a segment [0,1] for Singular integrations
			      ! xi1 == Gauss-Legendre points over a segment [0,1] for Singular integrations
USE GAUSS1D,  ONLY: wwg1      ! wwg1(k,i) = wg1(i)*wg1(k), where wg1(k) is the k-th Gauss-Legendre weight factor corresponding to xi1(k)


IMPLICIT NONE

 real   (kind=dp), intent(in ) :: a,b,c    ! Geometric parameters of element P: b = base, a = height,
                                           ! c = relative position of the 3rd vertex of element P
 real   (kind=dp), intent(in ) :: aQ,bQ,cQ ! Geometric parameters of element Q: bQ = base, aQ = height, 
                                           ! cQ = relative position of the 3rd vertex of element Q
 real   (kind=dp), intent(in ) :: theta(3) ! theta(i) == Angle at the i-th vertex of element Q
 real   (kind=dp), intent(in ) :: QPTM(3,3) ! Transition matrix from element Q to element P
 real   (kind=dp), intent(out) :: int_p(mx_nd_elt,mx_nd_elt) ! int_p == Singular contribution to potential influence matrix H
 real   (kind=dp), intent(out) :: int_f(mx_nd_elt,mx_nd_elt) ! int_f == Singular contribution to flux influence matrix G
 real   (kind=dp), intent(out) :: int_r(mx_nd_elt,mx_nd_elt) ! int_r == Singular contribution to potential influence matrix H: Reverse kernel

 integer(kind=k9) :: k,kk,i,j,th_id
 real   (kind=dp) :: kQ2,kQ3 ! kQ2 == Slope of Edge2 of element Q, kQ3 == Slope of Edge3 of element Q
 real   (kind=dp) :: c11,c21,c31,c12,c22,c32,c13,c23,c33,p11,p11h,q1h,p12,p22,p23,p31,p33,x3,z3,rh1s,rh2s,rh3s,p12s,p33s,chis,chic
 real   (kind=dp) :: cmb,xh,zh,q1hs,et,eth,eths,ets,p31h,q3h,q3hs,c13cf,c23cf,d(3),q(3),qs(3),rho(3),rhowv(3),chi(3),gamma(3)
 real   (kind=dp) :: dlt,alpha2,alpha3,x,y,xww,xwpc,rho1h,rho1hs,q1heth,q3heth,q2et,p11hrho1h,p31hrho1h,hh1,hh3,omega,ethx2,ethx2s
 real   (kind=dp) :: cr11,cr12,zn1,zd1,cr22,cr23,zn2,zd2,cr31,cr33,zn3,zd3,p12rh2,p22rh2,p23rh3,p33rh3,theta0,ThetGam,etThetGam
 real   (kind=dp) :: vecA(3),vecB(3),sncf(2:3),cscf(2:3),ah(3,3),bh(3,3),qchi(3),etchi(3),dchi(3),qrhowv(3)
 real   (kind=dp) :: psi(mx_nd_elt),shc(mx_nd_elt),xwp(mx_nd_elt),intGamwv(mx_nd_elt),intclN(mx_nd_elt,3),intclM(mx_nd_elt,3)
 real   (kind=dp) :: intA(mx_nd_elt,3),intD(mx_nd_elt,3),intR(mx_nd_elt,2:3),intGN3tmp(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intOme(mx_nd_elt,mx_nd_elt),intGam(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intGK1(mx_nd_elt,mx_nd_elt),intGN1(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intGK2(mx_nd_elt,mx_nd_elt),intGN2(mx_nd_elt,mx_nd_elt)
 real   (kind=dp) :: intGK3(mx_nd_elt,mx_nd_elt),intGN3(mx_nd_elt,mx_nd_elt)

 real(kind=dp), external :: pt_tria_tst,gammai ! External functions (see gbem_util.f90)



     c11 = QPTM(1,1); c21 = QPTM(2,1); c31 = QPTM(3,1)
     c12 = QPTM(1,2); c22 = QPTM(2,2); c32 = QPTM(3,2)
     c13 = QPTM(1,3); c23 = QPTM(2,3); c33 = QPTM(3,3)

     if ( ((dabs(c13) < gm_eps) .and. (dabs(c23) < gm_eps)) .or. ((dabs(c31) < gm_eps) .and. (dabs(c32) < gm_eps)) ) then
          call svesp(a,b,c,aQ,bQ,cQ,theta,QPTM,int_p,int_f,int_r) ! Integration for vertex-adjacent elements on the same plane
	  return
     endif

     dlt = a*b; cmb = c-b
     kQ2 = (cQ-bQ)/aQ; kQ3 = cQ/aQ

     alpha2 = pi-theta(2); alpha3 = pi+theta(1) ! alpha1 = 0.0_dp
     
     cscf(2) = dcos(alpha2); sncf(2) = dsin(alpha2)
     cscf(3) = dcos(alpha3); sncf(3) = dsin(alpha3)

     vecA(1) = -1.0_dp/bQ; vecA(2) =  1.0_dp/bQ; vecA(3) = 0.0_dp
     vecB(1) =  kQ2/bQ   ; vecB(2) = -kQ3/bQ   ; vecB(3) = 1.0_dp/aQ
     
     ah(1,1) = vecA(1); ah(2,1) = (kQ2*sncf(2) - cscf(2))/bQ; ah(3,1) = (kQ2*sncf(3) - cscf(3))/bQ
     ah(1,2) = vecA(2); ah(2,2) = (cscf(2) - kQ3*sncf(2))/bQ; ah(3,2) = (cscf(3) - kQ3*sncf(3))/bQ
     ah(1,3) =  0.0_dp; ah(2,3) = sncf(2)/aQ                ; ah(3,3) = sncf(3)/aQ

     bh(1,1) = -vecB(1); bh(2,1) = -(sncf(2) + kQ2*cscf(2))/bQ; bh(3,1) = -(sncf(3) + kQ2*cscf(3))/bQ
     bh(1,2) = -vecB(2); bh(2,2) =  (sncf(2) + kQ3*cscf(2))/bQ; bh(3,2) =  (sncf(3) + kQ3*cscf(3))/bQ
     bh(1,3) = -vecB(3); bh(2,3) = -cscf(2)/aQ                ; bh(3,3) = -cscf(3)/aQ
    
     loop0a: do k=1,mx_nd_elt
	intGamwv(k) = 0.0_dp
        loop0b: do j=1,mx_nd_elt
           intclN(j,k) = 0.0_dp; intclM(j,k) = 0.0_dp; intGN3tmp(j,k) = 0.0_dp; intA(j,k) = 0.0_dp
	   intOme(j,k) = 0.0_dp; intGam(j,k) = 0.0_dp
	   intGK1(j,k) = 0.0_dp; intGK2(j,k) = 0.0_dp;    intGK3(j,k) = 0.0_dp
	enddo loop0b
     enddo loop0a

     loop1a: do k=2,3
        loop1b: do j=1,mx_nd_elt
           intR(j,k) = 0.0_dp
	enddo loop1b
     enddo loop1a

     loop2a: do i=1,ng1 ! Loop over y
        y = xi1(i)
        xh = b+cmb*y; zh = a*y
	p11h = -(c11*xh + c12*zh); q1h = -(c21*xh + c22*zh); eth = -(c31*xh + c32*zh)
	p31h = p11h*cscf(3) + q1h*sncf(3); q3h = q1h*cscf(3) - p11h*sncf(3)

        rho1hs = xh*xh + zh*zh
        rho1h = dsqrt(rho1hs)

	if (dabs(q1h) < gm_eps) q1h = 0.0_dp
	if (dabs(q3h) < gm_eps) q3h = 0.0_dp

	q1hs = q1h*q1h; eths = eth*eth; q3hs = q3h*q3h
	
	ethx2 = 2.0_dp*eth
	ethx2s = ethx2*ethx2

	p11hrho1h = p11h*rho1h; p31hrho1h = p31h*rho1h
	hh1 = p11hrho1h*q1hs*ethx2s; hh3 = p31hrho1h*q3hs*ethx2s
	cr11 = q1hs*rho1hs - p11h*p11h*eths; cr31 = q3hs*rho1hs - p31h*p31h*eths
	
	q1heth = q1h*ethx2; q3heth = q3h*ethx2

        loop2b: do k=1,ng1 ! Loop over x
           x = xi1(k)
	   xww = x*wwg1(k,i)
	   
	   p11 = x*p11h; q(1) = x*q1h; p31 = x*p31h; et = x*eth; q(3) = x*q3h
	   p12 = bQ+p11; x3 = cQ+p11; z3 = aQ+q(1)
	   p22 = p12*cscf(2) + q(1)*sncf(2); q(2) = q(1)*cscf(2) - p12*sncf(2)
	   p23 = x3*cscf(2) + z3*sncf(2); p33 = x3*cscf(3) + z3*sncf(3)
	   
	   ets = et*et; p12s = p12*p12; p33s = p33*p33; qs(1) = q(1)*q(1); qs(2) = q(2)*q(2); qs(3) = q(3)*q(3)
	   
	   rh1s = p11*p11 + qs(1) + ets; rh2s = p12s + qs(1) + ets; rh3s = p33s + qs(3) + ets
	   rho(1) = dsqrt(rh1s); rho(2) = dsqrt(rh2s); rho(3) = dsqrt(rh3s)

	   rhowv(1) = rho(1)-rho(2); rhowv(2) = rho(2)-rho(3); rhowv(3) = rho(3)-rho(1)

	   psi(1) = shfv(1,k,i); psi(2) = shfv(2,k,i); psi(3) = shfv(3,k,i) ! psi(1) = 1.0_dp-x; psi(2) = x*(1.0_dp-y); psi(3) = x*y

           shc(2) = (kQ3*q(1) - p11)/bQ; shc(3) = -q(1)/aQ
	   shc(1) = 1.0_dp - (shc(2)+shc(3)) ! shc(1) = 1.0_dp + (p11 - kQ2*q(1))/bQ
	   
	   if ( dabs(shc(1)) < gm_eps ) then
	      shc(1) = 0.0_dp; q(2) = 0.0_dp
	   endif
	   
	   if ( dabs(shc(2)) < gm_eps ) then
	      shc(2) = 0.0_dp
	   elseif ( dabs(shc(2)-1.0_dp) < gm_eps ) then
	      shc(2) = 1.0_dp
	   endif
	   
	   if ( dabs(shc(3)) < gm_eps ) then
	      shc(3) = 0.0_dp
	   elseif ( dabs(shc(3)-1.0_dp) < gm_eps ) then
	      shc(3) = 1.0_dp
	   endif
	   
	   theta0 = pt_tria_tst(shc(1),shc(2),shc(3),theta,th_id) ! Point in triangle test

	   chi(1) = dlog( (p11+rho(1))/(p12+rho(2)) ); chi(2) = dlog( (p22+rho(2))/(p23+rho(3)) ) 
	   chi(3) = -dlog( (p31+rho(1))/(p33+rho(3)) )
	   
	   d(1) = qs(1) + ets; d(2) = qs(2) + ets; d(3) = qs(3) + ets; q2et = 2.0_dp*q(2)*et

	   p12rh2 = p12*rho(2); p22rh2 = p22*rho(2); p23rh3 = p23*rho(3); p33rh3 = p33*rho(3)
	   
	   cr12 = q1hs*rh2s-p12s*eths
	   zn1 = q1heth*(p12rh2*cr11 - p11hrho1h*cr12)
	   zd1 = cr11*cr12 + p12rh2*hh1

	   cr22 = qs(2)*rh2s-p22*p22*ets; cr23 = qs(2)*rh3s-p23*p23*ets
	   zn2 = q2et*( p23rh3*cr22 - p22rh2*cr23 )
	   zd2 = cr22*cr23 + q2et*q2et*p22rh2*p23rh3

	   cr33 = q3hs*rh3s-p33s*eths
	   zn3 = q3heth*(p31hrho1h*cr33 - p33rh3*cr31)
	   zd3 = cr31*cr33 + p33rh3*hh3

           gamma(1) = gammai(p11,p12,q1heth,cr11,cr12,zn1,zd1)
	   gamma(2) = gammai(p22,p23,q2et  ,cr22,cr23,zn2,zd2)
	   gamma(3) = gammai(p33,p31,q3heth,cr33,cr31,zn3,zd3)
	   
	   if ( et > 0.0_dp ) then
	      ThetGam = 0.5_dp*(gamma(1)+gamma(2)+gamma(3)) + theta0
	   else
	      ThetGam = 0.5_dp*(gamma(1)+gamma(2)+gamma(3)) - theta0
	   endif

	   etThetGam = et*ThetGam
	   chis =          sncf(2)*chi(2) + sncf(3)*chi(3)
	   chic = chi(1) + cscf(2)*chi(2) + cscf(3)*chi(3)

	   loop3: do j=1,mx_nd_elt
	      xwp(j) = xww*psi(j); dchi(j) = d(j)*chi(j); qrhowv(j) = q(j)*rhowv(j); qchi(j) = q(j)*chi(j)
	      etchi(j) = et*chi(j)
           enddo loop3

	   omega = qchi(1) + qchi(2) + qchi(3)
           
           loop4a: do kk=1,mx_nd_elt
	      intGamwv(kk) = intGamwv(kk) + xwp(kk)*etThetGam
              loop4b: do j=1,mx_nd_elt
                 intclN(j,kk) = intclN(j,kk) + xwp(j)*qrhowv(kk)
		 intclM(j,kk) = intclM(j,kk) + xwp(j)*dchi(kk)

		 intGN3tmp(j,kk) = intGN3tmp(j,kk) + xwp(j)*etchi(kk)
		      intA(j,kk) =      intA(j,kk) + xwp(j)*qchi(kk)
		  
		 xwpc = xwp(j)*shc(kk)
		 intOme(j,kk) = intOme(j,kk) + xwpc*omega
		 intGam(j,kk) = intGam(j,kk) + xwpc*etThetGam
		  
		 intGK1(j,kk) = intGK1(j,kk) + xwpc*chis
		 intGK2(j,kk) = intGK2(j,kk) - xwpc*chic
		 intGK3(j,kk) = intGK3(j,kk) + xwpc*ThetGam
	      enddo loop4b
           enddo loop4a
	   
           loop5a: do kk=2,3
              loop5b: do j=1,mx_nd_elt
		 intR(j,kk) =  intR(j,kk) + xwp(j)*rhowv(kk)
	      enddo loop5b
           enddo loop5a

        enddo loop2b ! End Loop over x
     enddo loop2a ! End Loop over y

     intD(1,1) = intA(1,1); intD(2,1) = intA(2,1); intD(3,1) = intA(3,1)
     loop6a: do k=2,3
        loop6b: do i=1,mx_nd_elt
	   intR(i,k) = sncf(k)*intR(i,k)
	   intD(i,k) = intR(i,k) + cscf(k)*intA(i,k)
	   intA(i,k) = sncf(k)*intA(i,k)
        enddo loop6b
     enddo loop6a

    call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intD,mx_nd_elt,ah,3,0.0_dp,intGN1,mx_nd_elt) ! intGN1 = matmul(intD,ah)

    intGN2(1,1) = intR(1,2)*bh(2,1) + intR(1,3)*bh(3,1) + intA(1,2)*ah(2,1) + intA(1,3)*ah(3,1)
    intGN2(2,1) = intR(2,2)*bh(2,1) + intR(2,3)*bh(3,1) + intA(2,2)*ah(2,1) + intA(2,3)*ah(3,1)
    intGN2(3,1) = intR(3,2)*bh(2,1) + intR(3,3)*bh(3,1) + intA(3,2)*ah(2,1) + intA(3,3)*ah(3,1)
    
    intGN2(1,2) = intR(1,2)*bh(2,2) + intR(1,3)*bh(3,2) + intA(1,2)*ah(2,2) + intA(1,3)*ah(3,2)
    intGN2(2,2) = intR(2,2)*bh(2,2) + intR(2,3)*bh(3,2) + intA(2,2)*ah(2,2) + intA(2,3)*ah(3,2)
    intGN2(3,2) = intR(3,2)*bh(2,2) + intR(3,3)*bh(3,2) + intA(3,2)*ah(2,2) + intA(3,3)*ah(3,2)
    
    intGN2(1,3) = intR(1,2)*bh(2,3) + intR(1,3)*bh(3,3) + intA(1,2)*ah(2,3) + intA(1,3)*ah(3,3)
    intGN2(2,3) = intR(2,2)*bh(2,3) + intR(2,3)*bh(3,3) + intA(2,2)*ah(2,3) + intA(2,3)*ah(3,3)
    intGN2(3,3) = intR(3,2)*bh(2,3) + intR(3,3)*bh(3,3) + intA(3,2)*ah(2,3) + intA(3,3)*ah(3,3)

    call dgemm('N','N',mx_nd_elt,3,mx_nd_elt,1.0_dp,intGN3tmp,mx_nd_elt,bh,3,0.0_dp,intGN3,mx_nd_elt) ! intGN3 = matmul(intGN3tmp,bh)

!*** int_f = matmul(intclN,ah) - matmul(intclM,bh)
     call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intclM,mx_nd_elt,bh,3, 0.0_dp,int_f,mx_nd_elt) ! int_f = matmul(intclM,bh)
     call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intclN,mx_nd_elt,ah,3,-1.0_dp,int_f,mx_nd_elt) ! int_f = matmul(intclN,ah) - int_f

     loop7a: do j=1,mx_nd_elt
	loop7b: do i=1,mx_nd_elt
	   int_f(i,j) = 0.5_dp*int_f(i,j) + intOme(i,j) - intGam(i,j)
	   intGN1(i,j) = intGN1(i,j) - intGamwv(i)*vecA(j)
	   intGN2(i,j) = intGN2(i,j) - intGamwv(i)*vecB(j)
	enddo loop7b
     enddo loop7a
     
     c13cf = c13*dlt; c23cf = c23*dlt
     
     loop8a: do i=1,mx_nd_elt
        loop8b: do k=1,mx_nd_elt
           int_f(k,i) =   dlt*int_f(k,i)
           int_p(k,i) =  -dlt*(intGN3(k,i)+intGK3(k,i))
	   int_r(k,i) = c13cf*(intGN1(k,i)+intGK1(k,i)) + c23cf*(intGN2(k,i)+intGK2(k,i)) - c33*int_p(k,i)
        enddo loop8b
     enddo loop8a

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE sing_vtx
!----------------------------------------------------------------------------------------------------------------------------------!


!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE svesp(a,b,c,aQ,bQ,cQ,theta,QPTM,int_p,int_f,int_r)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!*******************************  EXact Inner integral with linear distribution on a flat triangle  *******************************!
!*****************************  Singular integration for vertex-adjacent elements on the same plane  ******************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012

 
USE KINDS
USE PARAMS,   ONLY: pi,f_eps  ! pi = 3.1415926535897932, f_eps == Tolerance on the argument of a function
USE SRF_GEOM, ONLY: mx_nd_elt ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: shfv      ! shfv(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for vertex-adjacent case
USE GAUSS1D,  ONLY: ng1,xi1   ! ng1 == Number of Gauss-Legendre points over a segment [0,1] for Singular integrations 
			      ! xi1 == Gauss-Legendre points over a segment [0,1] for Singular integrations
USE GAUSS1D,  ONLY: wwg1      ! wwg1(k,i) = wg1(i)*wg1(k), where wg1(k) is the k-th Gauss-Legendre weight factor corresponding to xi1(k)


IMPLICIT NONE

 real   (kind=dp), intent(in ) :: a,b,c    ! Geometric parameters of element P: b = base, a = height,
                                           ! c = relative position of the 3rd vertex of element P
 real   (kind=dp), intent(in ) :: aQ,bQ,cQ ! Geometric parameters of element Q: bQ = base, aQ = height, 
                                           ! cQ = relative position of the 3rd vertex of element Q
 real   (kind=dp), intent(in ) :: theta(3) ! theta(i) == Angle at the i-th vertex of element Q
 real   (kind=dp), intent(in ) :: QPTM(3,3) ! Transition matrix from element Q to element P
 real   (kind=dp), intent(out) :: int_p(mx_nd_elt,mx_nd_elt) ! int_p == Singular contribution to potential influence matrix H
 real   (kind=dp), intent(out) :: int_f(mx_nd_elt,mx_nd_elt) ! int_f == Singular contribution to flux influence matrix G
 real   (kind=dp), intent(out) :: int_r(mx_nd_elt,mx_nd_elt) ! int_r == Singular contribution to potential influence matrix H: Reverse kernel

 integer(kind=k9) :: k,kk,i,j
 real   (kind=dp) :: kQ2,kQ3 ! kQ2 == Slope of Edge2 of element Q, kQ3 == Slope of Edge3 of element Q
 real   (kind=dp) :: c11,c21,c12,c22,p11,p11h,q1h,p12,p22,p23,p31,p33,x3,z3,cmb,xh,zh,p31h,q3h
 real   (kind=dp) :: dlt,alpha2,alpha3,x,y,xww,omega,z1,z1s,z2,z2s,ch33,ch31,chi(3),rhowv(3),qrhowv(3)
 real   (kind=dp) :: vecA(3),vecB(3),sncf(2:3),cscf(2:3),ah(3,3),bh(3,3),dchi(3),q(3),qs(3),rho(3)
 real   (kind=dp) :: psi(mx_nd_elt),shc(mx_nd_elt),xwp(mx_nd_elt)
 real   (kind=dp) :: intclN(mx_nd_elt,3),intclM(mx_nd_elt,3),intOme(mx_nd_elt,mx_nd_elt)



     dlt = a*b; cmb = c-b
     kQ2 = (cQ-bQ)/aQ; kQ3 = cQ/aQ

     c11 = QPTM(1,1); c21 = QPTM(2,1)
     c12 = QPTM(1,2); c22 = QPTM(2,2)

     alpha2 = pi-theta(2); alpha3 = pi+theta(1) ! alpha1 = 0.0_dp
     
     cscf(2) = dcos(alpha2); sncf(2) = dsin(alpha2)
     cscf(3) = dcos(alpha3); sncf(3) = dsin(alpha3)

     vecA(1) = -1.0_dp/bQ; vecA(2) =  1.0_dp/bQ; vecA(3) = 0.0_dp
     vecB(1) =  kQ2/bQ   ; vecB(2) = -kQ3/bQ   ; vecB(3) = 1.0_dp/aQ
     
     ah(1,1) = vecA(1); ah(2,1) = (kQ2*sncf(2) - cscf(2))/bQ; ah(3,1) = (kQ2*sncf(3) - cscf(3))/bQ
     ah(1,2) = vecA(2); ah(2,2) = (cscf(2) - kQ3*sncf(2))/bQ; ah(3,2) = (cscf(3) - kQ3*sncf(3))/bQ
     ah(1,3) =  0.0_dp; ah(2,3) = sncf(2)/aQ                ; ah(3,3) = sncf(3)/aQ

     bh(1,1) = -vecB(1); bh(2,1) = -(sncf(2) + kQ2*cscf(2))/bQ; bh(3,1) = -(sncf(3) + kQ2*cscf(3))/bQ
     bh(1,2) = -vecB(2); bh(2,2) =  (sncf(2) + kQ3*cscf(2))/bQ; bh(3,2) =  (sncf(3) + kQ3*cscf(3))/bQ
     bh(1,3) = -vecB(3); bh(2,3) = -cscf(2)/aQ                ; bh(3,3) = -cscf(3)/aQ
    
     loop0a: do k=1,mx_nd_elt
        loop0b: do j=1,mx_nd_elt
           intclN(j,k) = 0.0_dp; intclM(j,k) = 0.0_dp; intOme(j,k) = 0.0_dp
	enddo loop0b
     enddo loop0a

     loop1a: do i=1,ng1 ! Loop over y
        y = xi1(i)
        xh = b+cmb*y; zh = a*y
	p11h = -(c11*xh + c12*zh); q1h = -(c21*xh + c22*zh)
	p31h = p11h*cscf(3) + q1h*sncf(3); q3h = q1h*cscf(3) - p11h*sncf(3)

        loop1b: do k=1,ng1 ! Loop over x
           x = xi1(k)
	   xww = x*wwg1(k,i)
	   
	   p11 = x*p11h; q(1) = x*q1h; p31 = x*p31h; q(3) = x*q3h
	   p12 = bQ+p11; x3 = cQ+p11; z3 = aQ+q(1)
	   p22 = p12*cscf(2) + q(1)*sncf(2); q(2) = q(1)*cscf(2) - p12*sncf(2)
	   p23 = x3*cscf(2) + z3*sncf(2); p33 = x3*cscf(3) + z3*sncf(3)
	   
	   qs(1) = q(1)*q(1); qs(2) = q(2)*q(2); qs(3) = q(3)*q(3)
	   
	   rho(1) = dsqrt(p11*p11 + qs(1)); rho(2) = dsqrt(p12*p12 + qs(1)); rho(3) = dsqrt(p33*p33 + qs(3))
	   
	   rhowv(1) = rho(1)-rho(2); rhowv(2) = rho(2)-rho(3); rhowv(3) = rho(3)-rho(1)

	   psi(1) = shfv(1,k,i); psi(2) = shfv(2,k,i); psi(3) = shfv(3,k,i) ! psi(1) = 1.0_dp-x; psi(2) = x*(1.0_dp-y); psi(3) = x*y

           shc(2) = (kQ3*q(1) - p11)/bQ; shc(3) = -q(1)/aQ
	   shc(1) = 1.0_dp - (shc(2)+shc(3)) ! shc(1) = 1.0_dp + (p11 - kQ2*q(1))/bQ

	   chi(1) = dlog( (p11+rho(1))/(p12+rho(2)) ); chi(2) = dlog( (p22+rho(2))/(p23+rho(3)) ) 
	   ch31 = p31+rho(1); ch33 = p33+rho(3)
	   if ( (ch31 >= f_eps) .and. (ch33 >= f_eps) ) then
		chi(3) = -dlog(ch31/ch33)
	   else
		z1 = q3h/p31h; z2 = q(3)/p33
		z1s = z1*z1; z2s = z2*z2
		chi(3) = -dlog( (p33/p31)*( (1.0_dp-0.25_dp*z1s*(1.0_dp-0.5_dp*z1s))/(1.0_dp-0.25_dp*z2s*(1.0_dp-0.5_dp*z2s)) ) )
	   endif

	   loop2: do j=1,mx_nd_elt
	      xwp(j) = xww*psi(j); dchi(j) = qs(j)*chi(j); qrhowv(j) = q(j)*rhowv(j)
           enddo loop2

	   omega = q(1)*chi(1) + q(2)*chi(2) + q(3)*chi(3)
           
           loop3a: do kk=1,mx_nd_elt
              loop3b: do j=1,mx_nd_elt
                 intclN(j,kk) = intclN(j,kk) + xwp(j)*qrhowv(kk)
		 intclM(j,kk) = intclM(j,kk) + xwp(j)*dchi(kk)
		 intOme(j,kk) = intOme(j,kk) + xwp(j)*shc(kk)*omega
	      enddo loop3b
           enddo loop3a

         enddo loop1b ! End Loop over x
     enddo loop1a ! End Loop over y

!*** int_f = matmul(intclN,ah) - matmul(intclM,bh)
     call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intclM,mx_nd_elt,bh,3, 0.0_dp,int_f,mx_nd_elt) ! int_f = matmul(intclM,bh)
     call dgemm('N','N',mx_nd_elt,3,3,1.0_dp,intclN,mx_nd_elt,ah,3,-1.0_dp,int_f,mx_nd_elt) ! int_f = matmul(intclN,ah) - int_f

     loop4a: do i=1,mx_nd_elt
        loop4b: do k=1,mx_nd_elt
           int_f(k,i) = dlt*(0.5_dp*int_f(k,i) + intOme(k,i))
           int_p(k,i) = 0.0_dp
	   int_r(k,i) = 0.0_dp
        enddo loop4b
     enddo loop4a

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE svesp
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_lap_lrhs
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!**********************************  Form the left- and right-hand sides of the discretized BIE  **********************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


USE KINDS
USE SRF_GEOM,  ONLY: nmltplnd ! nmltplnd == Number of Multiple nodes (or Number of class of Multiple Nodes) on the boundary mesh
USE SRF_GEOM,  ONLY: mltplnd  ! mltplnd(k) == Structure containing information about the k-th class of multiple nodes
USE SRF_GEOM,  ONLY: nbnd     ! nbnd == Total number of boundary nodes
USE SRF_COND,  ONLY: ndbc     ! ndbc(i) = {0,1} ==> {Dirichlet,Neunamm} boundary condition is prescribed at the i-th boundary node
USE DISCR_BIE, ONLY: h,g      ! h == Potential influence matrix, g == Flux influence matrix
USE DISCR_BIE, ONLY: rhs      ! rhs == Right-hand side of the Discretized BIE
USE POTFLUX,   ONLY: phi,flx  ! phi == Vector containing boundary potentials, flx == Vector containing boundary fluxes
USE POTFLUX,   ONLY: pbv      ! pbv == Vector containing Prescribed Boundary Values


IMPLICIT NONE

 integer(kind=k9) :: i,j,k,l,n,alloc_st



!*** Initialization: Prescribed boundary conditions ==> flux and potential vectors
    allocate(phi(nbnd),flx(nbnd),STAT=alloc_st) 
    if (alloc_st == 0) then ! If phi,flx are successfully allocated
       loop0: do k=1,nbnd ! Loop over all boundary nodes
         if (ndbc(k) == 0) then ! ndbc(k) = 0 ==> Dirichlet data is prescribed at the k-th boundary node
           phi(k) = pbv(k); flx(k) = 0.0_dp
         else ! ndbc(k) = 1 ==> Neumann data is prescribed at the k-th boundary node
           phi(k) = 0.0_dp; flx(k) = pbv(k)
         endif
       enddo loop0
    else
          write(*,*)'gbem_lap_lrhs: Allocate arrays "phi,flx" failed with Status=',alloc_st
	  stop
    endif
       
    deallocate(pbv)

    call mltpl_nd ! Find Multiple nodes on the boundary mesh
    call mnd_ptl  ! Find a boundary node in every class of multiple nodes at which the potential is prescribed

    if (nmltplnd /= 0) then ! If there are multiple nodes on the boundary mesh
      loop1a: do k=1,nmltplnd ! Loop over all class of multiple nodes
	 if (mltplnd(k)%pnd /= -1) then ! if there exist in the k-th class a node with Global index mltplnd(k)%pnd at
				        ! which the potential is prescribed
	    loop1b: do j=1,mltplnd(k)%nn ! Loop over all multiple nodes in the k-th class
	       phi(mltplnd(k)%id(j)) = phi(mltplnd(k)%pnd) ! Assign potential by continuity
	    enddo loop1b
	 endif
      enddo loop1a
    endif 

    allocate(rhs(nbnd),STAT=alloc_st)
    if (alloc_st == 0) then ! If rhs is successfully allocated
       ! rhs = matmul(h,phi) - matmul(g,flx)
       call dgemv('N',nbnd,nbnd,1.0_dp,g,nbnd,flx,1, 0.0_dp,rhs,1) ! rhs = matmul(g,flx)
       call dgemv('N',nbnd,nbnd,1.0_dp,h,nbnd,phi,1,-1.0_dp,rhs,1) ! rhs = matmul(h,phi) - rhs
    else
       write(*,*)'gbem_lap_lrhs: Allocate array "rhs" failed with Status=',alloc_st
       stop
    endif

!*** Rearrange columns: Form the Left-hand side coefficient matrix in g
    loop2a: do k=1,nbnd ! Loop over all boundary nodes
       if(ndbc(k) == 1) then ! if Neumann data is prescribed at the k-th boundary node
          loop2b: do i=1,nbnd ! Loop over all boundary nodes
	     g(i,k) = -h(i,k)
	  enddo loop2b
       endif
    enddo loop2a

    deallocate(h)


!*** Enforcing continuity of potentials in g
    if (nmltplnd /= 0) then ! if the surface mesh has Multiple nodes
       loop3a: do k=1,nmltplnd ! Loop over all class of multiple nodes
	  if (mltplnd(k)%pnd /= -1) then ! if there exist in the k-th class a node with Global index mltplnd(k)%pnd at
				         ! which the potential is prescribed
	     loop3b: do j=1,mltplnd(k)%nn ! Loop over all multiple nodes in the k-th class
	        i = mltplnd(k)%id(j) ! i = Global index of the j-th node in the k-th class of multiple nodes
	        if (ndbc(i) == 1) then ! if the flux is prescribed at the i-th boundary node
		   loop3c: do l=1,nbnd ! Loop over all boundary nodes
		      g(l,i) = 0.0_dp;  g(i,l) = 0.0_dp
		   enddo loop3c 
		   g(i,i) = 1.0_dp; rhs(i) = phi(mltplnd(k)%pnd)
		endif
	     enddo loop3b
	  else ! there is no potential node in the k-th class of multiple nodes ==> ONLY flux nodes in the k-th class
	     i = mltplnd(k)%id(1) ! i = Global index of the 1st node in the k-th class of multiple nodes
	     loop3d: do j=2,mltplnd(k)%nn ! Loop over the remaining nodes in the k-th class of multiple nodes
	        l = mltplnd(k)%id(j) ! l = Global index of the j-th node in the k-th class of multiple nodes
		  loop3e: do n=1,nbnd ! Loop over all boundary nodes
		     g(n,i) = g(n,i) + g(n,l) ! add columns
		     g(n,l) = 0.0_dp
		  enddo loop3e

		  loop3f: do n=1,nbnd ! Loop over all boundary nodes
		     g(i,n) = g(i,n) + g(l,n) ! add rows
		     g(l,n) = 0.0_dp
		  enddo loop3f
		  g(l,l) = 1.0_dp; rhs(i) = rhs(i) + rhs(l); rhs(l) = 0.0_dp
	     enddo loop3d
	  endif
       enddo loop3a
    endif

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_lap_lrhs
!----------------------------------------------------------------------------------------------------------------------------------!


!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE mnd_ptl
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!*********************************************  GALERKIN BEM for 3D LAPLACE EQUATION  *********************************************!
!******************  Find a boundary node in every class of multiple nodes at which the potential is prescribed  ******************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


USE KINDS
USE SRF_GEOM, ONLY: nmltplnd ! nmltplnd == Number of Multiple nodes (or Number of class of Multiple Nodes) on the boundary mesh
USE SRF_GEOM, ONLY: mltplnd  ! mltplnd(k) == Structure containing information about the k-th class of multiple nodes
USE SRF_COND, ONLY: ndbc     ! ndbc(i) = {0,1} ==> {Dirichlet,Neunamm} boundary condition is prescribed at the i-th boundary node


IMPLICIT NONE

 integer(kind=k9) :: i,j



    if (nmltplnd /= 0) then ! if the surface mesh has Multiple nodes
 	 loop0a: do i=nmltplnd,1,-1 ! Loop over all multiple nodes
!*** Find a boundary node in the i-th class of multiple nodes at which the potential is prescribed
	     j=1
	     loop0b: do
	 	if (ndbc(mltplnd(i)%id(j)) == 0) then
	 	  mltplnd(i)%pnd = mltplnd(i)%id(j) ! There is in the i-th class a node with global index mltplnd(i)%pnd
	 					    ! at which the potential is prescribed
	 	  exit
	 	elseif (j == mltplnd(i)%nn) then
	 	  mltplnd(i)%pnd = -1 ! There is no potential node in the i-th class of multiple nodes
	 	  exit
	 	else
	 	  j = j+1
	 	endif
	     enddo loop0b
!*** End Find a boundary node in the i-th class of multiple nodes at which the potential is prescribed
 	 enddo loop0a
    endif

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE mnd_ptl
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_lap_solv
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!***************************************************  Solve the Discretized BIE  **************************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


USE KINDS
USE SRF_GEOM, ONLY: nmltplnd   ! nmltplnd == Number of Multiple nodes (or Number of class of Multiple Nodes) on the boundary mesh
USE SRF_GEOM, ONLY: mltplnd    ! mltplnd(k) == Structure containing information about the k-th class of multiple nodes
USE SRF_GEOM, ONLY: nbnd       ! nbnd == Total number of boundary nodes
USE SRF_COND, ONLY: ndbc       ! ndbc(i) = {0,1} ==> {Dirichlet,Neunamm} boundary condition is prescribed at boundary node bnd(:,i)
USE DISCR_BIE,ONLY: g,rhs      ! g == Discretized BIE matrix or Left-hand side of the BEM equation
                               ! rhs == Right-hand side of the Discretized BIE
USE POTFLUX,  ONLY: phi,flx    ! phi == Vector containing boundary potentials, flx == Vector containing boundary fluxes
USE ITER_SOLV,ONLY: ldim       ! ldim == Dimension of the iterative solver BiCGSTAB(ldim)
USE ITER_SOLV,ONLY: mxmatvec   ! mxmatvec == Maximum number of matrix-vector mutiplications in the iterative solver BiCGSTAB(ldim)
USE ITER_SOLV,ONLY: slv_eps    ! slv_eps == Tolerance on the BiCGSTAB(ldim) iterative solver
USE CELL_ARP, ONLY: ncwnd      ! ncwnd == Number of computional Cells containing boundary nodes <==> number of non-empty cells
USE CELL_ARP, ONLY: cwnd,cell  ! cwnd(k) == Global index of the k-th non-empty cell
			       ! cell(k) == Structure containing information about the k-th cell
USE PRECOND,  ONLY: sparseflg  ! sparseflg == Parameter that determines the sparsity pattern of the preconditoner
			       ! sparseflg = 0 ==> no preconditoner
			       ! sparseflg = 1 ==> the sparsity pattern of the preconditoner is given by cell self-interactions
			       ! sparseflg = 1+n ==> the sparsity pattern of the preconditoner is given by cell + n Neighboring interactions
USE PRECOND, ONLY: gcsr        ! gcsr == Preconditioner <==> Sparse approximation of g in Compressed Sparse Row (CSR) format
USE PRECOND, ONLY: igcsr,jgcsr ! igcsr == Pointers in gcsr of the beginning of each row of g
                               ! jgcsr == Column indices of the entries of gcsr as stored in the Discretized BIE matrix g


IMPLICIT NONE

 logical          :: pcond_flg ! pcond_flg = .true. ==> there is a preconditioner; pcond_flg = .false. ==> there is no preconditioner
 integer(kind=k9) :: i,ii,k,kk,l,j,jj,nk,nj,info,alloc_st
 integer(kind=k9) :: nmatvec ! nmatvec == Number of matrix-vector mutiplications performed until convergence in BiCGSTAB(ldim)
 integer(kind=k9) :: nnz_gcsr ! nnz_gcsr == Number of non-zero entries in the Sparse approximation of the Discretized BIE matrix g
 real   (kind=dp) :: tol ! tol == Residual achieved at the solution
 real   (kind=dp), pointer :: solvec(:) ! solvec == Solution vector

!----------------------------------------------------------------------------------------------------------------------------------!
INTERFACE
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
  SUBROUTINE mat_vec(m,x,y)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!******************************************  Compute the Matrix vector product: y:=A*x ********************************************!
!**********************************************************************************************************************************!

   USE KINDS

   IMPLICIT NONE
   
    integer(kind=k9), intent(in ) :: m    ! m == Dimension of vectors "x" and "y"
    real   (kind=dp), intent(in ) :: x(m)
    real   (kind=dp), intent(out) :: y(m) ! y = A*x

!----------------------------------------------------------------------------------------------------------------------------------!    
  END SUBROUTINE mat_vec
!----------------------------------------------------------------------------------------------------------------------------------!  


!----------------------------------------------------------------------------------------------------------------------------------!
  SUBROUTINE ilu0_l_pcond(m,x)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!****************************************** Compute the Matrix vector product: y=M^{-1}*x *****************************************!
!************************************************** i.e. solve the system: M*y=x **************************************************!
!**********************************************************************************************************************************!

!---note---= M is a left preconditioner
!---note---= The solution y is written in x on ouput

   USE KINDS

   IMPLICIT NONE
   
    integer(kind=k9), intent(in)    :: m ! m == Dimension of the vector "x"
    real   (kind=dp), intent(inout) :: x(m)

!----------------------------------------------------------------------------------------------------------------------------------!    
  END SUBROUTINE ilu0_l_pcond
!----------------------------------------------------------------------------------------------------------------------------------!  

!----------------------------------------------------------------------------------------------------------------------------------!
END INTERFACE
!----------------------------------------------------------------------------------------------------------------------------------!



    allocate(solvec(nbnd),STAT=alloc_st) 
    if (alloc_st == 0) then ! If solvec is successfully allocated
          loop0: do k=1,nbnd
             solvec(k) = 0.0_dp
          enddo loop0
    else
          write(*,*)'gbem_lap_solv: Allocate array "solvec" failed with Status=',alloc_st
	  stop
    endif

    nmatvec = mxmatvec; tol = slv_eps

    if (sparseflg == 0) then ! sparseflg=0 ==> no sparse approximation of the Discretized BIE matrix g <==> no preconditioner
          pcond_flg = .false. ! pcond_flg = .false. <==> no preconditioner
    elseif (sparseflg > 0) then ! sparseflg > 0 <==> use a preconditioner
          pcond_flg = .true. ! pcond_flg = .true. <==> use a preconditioner
	  write(*,100)'           >>>  Preconditioning <<<'    
	  write(*,100)'           >>>  Cell Initialization <<<'    
          call gbem_cell_init ! Construct the computational box and distribute without repetition boundary nodes into cells,
	                      ! i.e, Initialize non-empty cells in arrays cell and cwnd, define the parameter ncwnd
	  if (sparseflg == 1) then ! sparseflg=1 ==> the sparsity pattern of the preconditoner is given by cell self-interactions

                nnz_gcsr = 0
	        loop1: do k=1,ncwnd ! Loop over all non-empty cells
	           nk = cell(cwnd(k))%nnc ! nk = Number of boundary nodes in the k-th cell
	           nnz_gcsr = nnz_gcsr + nk*nk
                enddo loop1
	  
!*** gcsr == Sparse approximation of the Discretized BIE matrix g
		allocate(igcsr(nnz_gcsr),jgcsr(nnz_gcsr),gcsr(nnz_gcsr),STAT=alloc_st)
		if (alloc_st == 0) then  ! If igcsr,jgcsr,gcsr are successfully allocated
		      ii = 1
		      loop2a: do k=1,ncwnd ! Loop over all non-empty cells
			 kk = cwnd(k) ! kk == Global index of the k-th cell
			 nk = cell(kk)%nnc ! nk = Number of boundary nodes in the k-th cell
			 loop2b: do l=1,nk ! Loop over all boundary nodes in the k-th cell
			    loop2c: do i=1,nk ! Loop over all boundary nodes in the k-th cell
				gcsr(ii) = g(cell(kk)%nd_id(i),cell(kk)%nd_id(l)) ! Here gcsr is stored in COOrdinate (COO) format
			       igcsr(ii) = cell(kk)%nd_id(i) ! igcsr(ii) =    Row index in g of the ii entry of gcsr
			       jgcsr(ii) = cell(kk)%nd_id(l) ! jgcsr(ii) = Column index in g of the ii entry of gcsr
			       ii = ii+1
			    enddo loop2c
			 enddo loop2b
 		      enddo loop2a
		else
		      write(*,*)'gbem_lap_solv: C1: Allocate arrays "igcsr,jgcsr,gcsr" failed with Status =',alloc_st
		      stop
		endif

	  else ! sparseflg > 1
		call gbem_cell_neighbor ! For all cell, find near-neighbors
                nnz_gcsr = 0
	        loop3a: do k=1,ncwnd ! Loop over all non-empty cells
	           nk = cell(cwnd(k))%nnc ! nk = Number of boundary nodes in the k-th cell
		   if ( cell(cwnd(k))%nnnc .ge. sparseflg ) then
		         cell(cwnd(k))%nnbsprs = sparseflg    
		   else ! cell(cwnd(k))%nnnc == Number of Near-neighboring cells to the k-th cell including the k-th cell itself
		        cell(cwnd(k))%nnbsprs = cell(cwnd(k))%nnnc ! cell(cwnd(k))%nnbsprs == Number of Near-Neighboring cells to 
			                                           !                           the k-th cell used to define gcsr
		   endif
		   
		   loop3b: do j=1,cell(cwnd(k))%nnbsprs ! Loop over the near-neighboring cells to the k-th cell
                                          ! cell(cwnd(k))%nbor(j) == Global index of the j-th near-neighboring cell to the k-th cell
 		       nj = cell(cell(cwnd(k))%nbor(j))%nnc ! nj == Number of boundary nodes in the j-th cell
	               nnz_gcsr = nnz_gcsr + nk*nj ! nnz_gcsr = Number of non-zero entries in gcsr
 		   enddo loop3b
                enddo loop3a


!*** gcsr == Sparse approximation of the Discretized BIE matrix g
		allocate(igcsr(nnz_gcsr),jgcsr(nnz_gcsr),gcsr(nnz_gcsr),STAT=alloc_st)
		if (alloc_st == 0) then ! If igcsr,jgcsr,gcsr are successfully allocated
		      ii = 1
		      loop4a: do k=1,ncwnd ! Loop over all non-empty cells
			 kk = cwnd(k) ! kk == Global index of the k-th cell
			 nk = cell(kk)%nnc ! nk = Number of boundary nodes in the k-th cell
			 loop4b: do j=1,cell(kk)%nnbsprs ! Loop over the near-neighboring cells to the k-th cell
                            jj = cell(kk)%nbor(j) ! jj == Global index of the j-th near-neighboring cell to the k-th cell
 		            nj = cell(jj)%nnc ! nj == Number of boundary nodes in the j-th cell

			    loop4c: do l=1,nj ! Loop over all boundary nodes in the j-th cell
			       loop4d: do i=1,nk ! Loop over all boundary nodes in the k-th cell
				   gcsr(ii) = g(cell(kk)%nd_id(i),cell(jj)%nd_id(l)) ! Here gcsr is stored in COOrdinate (COO) format
			          igcsr(ii) = cell(kk)%nd_id(i) ! igcsr(ii) =    Row index in g of the ii entry of gcsr
			          jgcsr(ii) = cell(jj)%nd_id(l) ! jgcsr(ii) = Column index in g of the ii entry of gcsr
			          ii = ii+1
			       enddo loop4d
			    enddo loop4c
			 enddo loop4b
 		      enddo loop4a
		else
		      write(*,*)'gbem_lap_solv: C2: Allocate arrays "igcsr,jgcsr,gcsr" failed with Status =',alloc_st
		      stop
		endif
	  endif ! sparseflg > 1
	  
	call coo2csr(nbnd,nnz_gcsr,gcsr,igcsr,jgcsr) ! Convert gcsr from COO to Compressed Sparse Row (CSR) format
	write(*,100)'           >>>  Zero Fill-in Incomplete LU: ILU(0) <<<'
	call csr_ilu0(nbnd,gcsr,igcsr(1:nbnd+1),jgcsr) ! Generate the left preconditioner: Zero Fill-in Incomplete LU Factorization

    else ! sparseflg < 0
       write(*,*)'Warning: Incorrect value for sparseflg ==> sparseflg set to 0'
       sparseflg = 0; pcond_flg = .false. ! pcond_flg = .false. ==> there is no preconditioner
    endif

    write(*,100)'           >>>  BICGSTABL Iterative Solver <<<'    
    call bicgstabl(ldim,nbnd,solvec,.false.,rhs,mat_vec,ilu0_l_pcond, &
                   pcond_flg,tol,nmatvec,info) ! Iterative solution of the Discretized BIE
    deallocate(g,rhs)

    if (pcond_flg) then
          deallocate(igcsr,jgcsr,gcsr)
    endif

    write(*,*) 'nmatvec ==', nmatvec
    write(*,*) 'Residual ==', tol
    write(*,*) 'err ==', info

       
    loop5: do k=1,nbnd
       if (ndbc(k) == 0) then ! ndbc(k) = 0 ==> Dirichlet data is prescribed at the k-th boundary node
          flx(k) = solvec(k)
       else ! ndbc(k) = 1 ==> Neumann data is prescribed at the k-th boundary node
          phi(k) = solvec(k)
       endif
    enddo loop5
    
    deallocate(solvec,ndbc)

    if (sparseflg /= 0) then
       loop6: do k=1,ncwnd ! Loop over all non-empty Cells
          deallocate(cell(cwnd(k))%nd_id) ! cwnd(k) = Global index of the k-th cell with boundary nodes
	  if (sparseflg > 1) deallocate(cell(cwnd(k))%nbor)
       enddo loop6
       deallocate(cell,cwnd)
    endif


    if (nmltplnd /= 0) then
         loop7a: do k=1,nmltplnd ! Loop over all class of multiple nodes
	    if (mltplnd(k)%pnd /= -1) then ! if there exist in the k-th class a boundary node with Global
	                                   ! index mltplnd(k)%pnd at which the potential is prescribed
	       loop7b: do j=1,mltplnd(k)%nn ! Loop over all multiple nodes in the k-th class
		  phi(mltplnd(k)%id(j)) = phi(mltplnd(k)%pnd) ! Retrieve prescribed potential from the boundary node mltplnd(k)%pnd
	       enddo loop7b
	    else ! there is no potential node in the k-th class of equivalence: ONLY flux nodes in the k-th class
	       loop7c: do j=2,mltplnd(k)%nn ! Loop over the remaining nodes in the k-th class of multiple nodes
		  phi(mltplnd(k)%id(j)) = phi(mltplnd(k)%id(1)) ! Assign potential by continuity
	       enddo loop7c
	    endif
	    deallocate(mltplnd(k)%id)
         enddo loop7a
        deallocate(mltplnd)
    endif

  100 format (1x, a)

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_lap_solv
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_lap_init
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!***********************************************  Initialize arrays and parameters  ***********************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012


!*** Typical triangular element with vertices {y1,y2,y3}

!           y3
!	    *
!	   / \
!	  /   \
!	 /     \
!       /       \
!      /	 \
!     /		  \
!    *-------------*
!  y1               y2

! Oriented edge L1 = [y1,y2] <== Edge1
! Oriented edge L2 = [y2,y3] <== Edge2
! Oriented edge L3 = [y3,y1] <== Edge3

 
USE KINDS
USE PARAMS,   ONLY: pi,pix2,fac  ! pi = 3.1415926535897932, pix2 = 2*pi, fac == Factor of the Green's function: fac = 1/(4*pi)
USE SRF_GEOM, ONLY: mx_nd_elt    ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: nbelt        ! nbelt == Total number of boundary elements
USE SRF_GEOM, ONLY: belt         ! belt(:,i) == Global indices of boundary nodes on the i-th element
USE SRF_GEOM, ONLY: qq           ! qq(k) == Global index of the k-th node of the boundary element Q
USE SRF_GEOM, ONLY: bnd          ! bnd(:,i) == Cartesian coordinates of the i-th boundary node
USE SRF_GEOM, ONLY: LocCBasisElt ! LocCBasisElt(1:9,k) == Local Companion Basis associated with the k-th boundary element
USE SRF_GEOM, ONLY: xvElt,zvElt  ! xvElt(1,k) == Base of the k-th boundary element
				 ! xvElt(2,k) == Geometric parameter associated with the k-th boundary element
				 ! zvElt(k) == Height of the k-th boundary element
USE SRF_GEOM, ONLY: thetaElt     ! thetaElt(i,k) == Angle at the i-th vertex of the k-th boundary element
USE SRF_GEOM, ONLY: EltDiam      ! EltDiam(k) == Diameter of the k-th boundary element
USE SRF_GEOM, ONLY: EltAreax2    ! EltAreax2(k) = 2*Area of the k-th boundary element
USE SRF_GEOM, ONLY: shfe1,shfe2  ! shfe1(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for edge-adjacent case: E'
				 ! shfe2(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for edge-adjacent case: E"
USE SRF_GEOM, ONLY: shfv	 ! shfv(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for vertex-adjacent case
USE GAUSS1D,  ONLY: ng1,xi1      ! ng1 == Number of Gauss-Legendre points over a segment [0,1] for Singular integrations
				 ! xi1 == Gauss-Legendre points over a segment [0,1] for Singular integrations
USE GAUSS1D,  ONLY: ng2,xi2      ! ng2 == Number of Gauss-Legendre points over a segment [0,1] for Quasi-singular integration
				 ! xi2 == Gauss-Legendre points over a segment [0,1] for Quasi-singular integration
USE GAUSS1D,  ONLY: ng3,xi3      ! ng3 == Number of Gauss-Legendre points over a segment [0,1] for Non-singular integration
				 ! xi3 == Gauss-Legendre points over a segment [0,1] for Non-singular integration
USE GAUSS1D,  ONLY: wwg1 ! wwg1(k,i) = wg1(i)*wg1(k), where wg1(k) is the k-th Gauss-Legendre weight factor corresponding to xi1(k)
USE GAUSS1D,  ONLY: wwg2 ! wwg2(k,i) = wg2(i)*wg2(k), where wg2(k) is the k-th Gauss-Legendre weight factor corresponding to xi2(k)
USE GAUSS1D,  ONLY: wwg3 ! wwg3(k,i) = wg3(i)*wg3(k), where wg3(k) is the k-th Gauss-Legendre weight factor corresponding to xi3(k)


IMPLICIT NONE

 integer(kind=k9) :: i,k,elQ ! elQ == Global index of the boundary element Q
 integer(kind=k9) :: alloc_st,alloc_st1,alloc_st2
 real   (kind=dp) :: d12,d13,d23
 real   (kind=dp) :: aQ,bQ,cQ ! Geometric parameters of element Q: bQ = base, aQ = height,
 			      ! cQ = relative position of the 3rd vertex of element Q in the local basis {e1,e2,e3}
 real   (kind=dp) :: x,y,xy,xyhlf,aQs,bmc
 real   (kind=dp) :: vij(3,3),ym1hlf,yp1hlf,xm1,ym1
 real   (kind=dp) :: e1(3),e2(3),e3(3) ! Orthonormal local basis
 real   (kind=dp), pointer :: wg1(:) ! Gauss-Legendre weight factors for Singular (Edge-adjacent and Vertex-adjacent) integrations
 real   (kind=dp), pointer :: wg2(:) ! Gauss-Legendre weight factors for Quasi-singular integration
 real   (kind=dp), pointer :: wg3(:) ! Gauss-Legendre weight factors for Non-singular integration



    pi = 4.0_dp*datan(1.0_dp) ! pi = 3.1415926535897932
    pix2 = 2.0_dp*pi; fac = 1.0_dp/(4.0_dp*pi) ! fac == Factor of the Green's function

    allocate(EltDiam(nbelt),EltAreax2(nbelt),STAT=alloc_st)
    allocate(xvElt(2,nbelt),zvElt(nbelt),thetaElt(3,nbelt),STAT=alloc_st1)
    allocate(LocCBasisElt(9,nbelt),STAT=alloc_st2)


    if ( (alloc_st == 0) .and. (alloc_st1 == 0) .and. (alloc_st2 == 0) ) then ! If EltDiam, EltAreax2, xvElt, zvElt, thetaElt, 
    									      ! LocCBasisElt are successfully allocated

!** Find Diameter, Companion Basis and Area of each boundary element ******************************!
 	  loop0a: do elQ=1,nbelt ! loop over all boundary elements
 	     loop0b: do i=1,mx_nd_elt ! Loop over the nodes of element Q
 	  	qq(i) = belt(i,elQ) ! p(i) == Global index of the i-th node (vertex) of the boundary element Q
 	     enddo loop0b

	      loop0c: do k=1,3 ! Loop over all components
	  	 vij(k,1) = bnd(k,qq(2))-bnd(k,qq(1)) ! y2-y1 <== Side 1 of element Q
	  	 vij(k,2) = bnd(k,qq(3))-bnd(k,qq(2)) ! y3-y2 <== Side 2 of element Q
	  	 vij(k,3) = bnd(k,qq(3))-bnd(k,qq(1)) ! y3-y1 <== Side 3 of element Q
	      enddo loop0c

	  	d12 = vij(1,1)*vij(1,1) + vij(2,1)*vij(2,1) + vij(3,1)*vij(3,1)
	  	d23 = vij(1,2)*vij(1,2) + vij(2,2)*vij(2,2) + vij(3,2)*vij(3,2)
	  	d13 = vij(1,3)*vij(1,3) + vij(2,3)*vij(2,3) + vij(3,3)*vij(3,3)

	  	EltDiam(elQ) = dsqrt(max(d12,d13,d23)) ! EltDiam(elQ) == Diameter of the boundary element Q

!*** LocCBasisElt(:,elQ) = {e1,e2,e3} == Local orthonormal companion basis associated with the boundary element Q
!*** {e1,e2} = Orthonormal System in the plane of the boundary element Q
!*** e3 = vector characterizing the unit "outward" normal to element Q
		call ortho_comp_basis(vij(:,1),vij(:,3),e1,e2,e3) ! Deternime the orthonormal companion basis associated with element Q
 	  	LocCBasisElt(1,elQ) = e1(1); LocCBasisElt(2,elQ) = e1(2); LocCBasisElt(3,elQ) = e1(3)
 	  	LocCBasisElt(4,elQ) = e2(1); LocCBasisElt(5,elQ) = e2(2); LocCBasisElt(6,elQ) = e2(3)
 	  	LocCBasisElt(7,elQ) = e3(1); LocCBasisElt(8,elQ) = e3(2); LocCBasisElt(9,elQ) = e3(3)

 	  	bQ = vij(1,1)*e1(1) + vij(2,1)*e1(2) + vij(3,1)*e1(3) ! bQ>0.0 always
	        aQ = vij(1,3)*e2(1) + vij(2,3)*e2(2) + vij(3,3)*e2(3) ! aQ>0.0 always
		cQ = vij(1,3)*e1(1) + vij(2,3)*e1(2) + vij(3,3)*e1(3)

	  	xvElt(1,elQ) = bQ; xvElt(2,elQ) = cQ; zvElt(elQ) = aQ
		
 	      EltAreax2(elQ) = bQ*aQ ! EltAreax2(elQ) = 2*Area of element Q

!*** thetaElt(i,elQ) == Angle at the i-th vertex of element Q
	      bmc = bQ-cQ; aQs = aQ*aQ
	      thetaElt(1,elQ) = dacos(cQ/dsqrt(cQ*cQ + aQs))
	      thetaElt(2,elQ) = dacos(bmc/dsqrt(bmc*bmc + aQs))
	      thetaElt(3,elQ) = pi - (thetaElt(1,elQ)+thetaElt(2,elQ))
 	  enddo loop0a
!** End Find Diameter, Companion Basis and Area of each boundary element **************************!

    else
          if ( alloc_st /= 0 ) then  ! If EltDiam, EltAreax2 are not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate arrays "EltDiam, EltAreax2" failed with Status=',alloc_st
	        stop
          endif

          if ( alloc_st1 /= 0 ) then  ! If xvElt, zvElt, thetaElt are not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate arrays "xvElt, zvElt, thetaElt" failed with Status=',alloc_st1
	        stop
          endif

          if ( alloc_st2 /= 0 ) then  ! If LocCBasisElt is not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate array "LocCBasisElt" failed with Status=',alloc_st2
	        stop
          endif
    endif

!** Set Gauss-Legendre quadrature ********************************************************************************!
    allocate(xi1(ng1),wg1(ng1),STAT=alloc_st)  ! Gauss-Legendre points and weights for Singular integrations
    allocate(xi2(ng2),wg2(ng2),STAT=alloc_st1) ! Gauss-Legendre points and weights for Quasi-singular integration
    allocate(xi3(ng3),wg3(ng3),STAT=alloc_st2) ! Gauss-Legendre points and weights for Non-singular integration

    if ( (alloc_st == 0) .and. (alloc_st1 == 0) .and. (alloc_st2 == 0) ) then ! If xi1,wg1, xi2,wg2, xi3,wg3 are successfully allocated
          call rgauleg(0.0_dp,1.0_dp,xi1,wg1,ng1) ! Generate ng1 Gauss-Legendre points and weights for integration over a segment [0,1]
          call rgauleg(0.0_dp,1.0_dp,xi2,wg2,ng2) ! Generate ng2 Gauss-Legendre points and weights for integration over a segment [0,1]
          call rgauleg(0.0_dp,1.0_dp,xi3,wg3,ng3) ! Generate ng3 Gauss-Legendre points and weights for integration over a segment [0,1]
    else
          if ( alloc_st /= 0 ) then  ! If xi1,wg1 are not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate arrays "xi1,wg1" failed with Status=',alloc_st
	        stop
          endif

          if ( alloc_st1 /= 0 ) then  ! If xi2,wg2 are not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate arrays "xi2,wg2" failed with Status=',alloc_st1
	        stop
          endif

          if ( alloc_st2 /= 0 ) then  ! If xi3,wg3 are not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate arrays "xi3,wg3" failed with Status=',alloc_st2
	        stop
          endif
    endif
!** END Set Gauss-Legendre quadrature ****************************************************************************!


!** Initialize Gauss weights for Non-singular (i.e. Well-separated element pair) integration ************************!
    allocate(wwg3(ng3,ng3),STAT=alloc_st)

    if ( alloc_st == 0 ) then ! If wwg3 is successfully allocated
 	  loop1a: do i = 1,ng3 ! Loop over all Gauss points
	     loop1b: do k = 1,ng3 ! Loop over all Gauss points
	  	wwg3(k,i) = wg3(i)*wg3(k)
 	     enddo loop1b
 	  enddo loop1a
 	  deallocate(wg3)
    else
          if ( alloc_st /= 0 ) then ! If wwg3 is not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate array "wwg3" failed with Status=',alloc_st
	        stop
          endif
    endif
!** End Initialize Gauss weights for Non-singular (i.e. Well-separated element pair) integration ********************!


!** Initialize Gauss weights for Quasi-singular integration ***************************************!
    allocate(wwg2(ng2,ng2),STAT=alloc_st)

    if ( alloc_st == 0 ) then ! If wwg2 is successfully allocated
 	  loop2a: do i = 1,ng2 ! Loop over all Gauss points
	     loop2b: do k = 1,ng2 ! Loop over all Gauss points
	  	wwg2(k,i) = wg2(i)*wg2(k)
 	     enddo loop2b
 	  enddo loop2a
 	  deallocate(wg2)
    else
          if ( alloc_st /= 0 ) then ! If wwg2 is not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate array "wwg2" failed with Status=',alloc_st
	        stop
          endif
    endif
!** End Initialize Gauss weights for Quasi-singular integration ***********************************!


!** Initialize Gauss weights and shape functions for Singular integrations ************************!
    allocate(wwg1(ng1,ng1),STAT=alloc_st)
    allocate(shfv(mx_nd_elt,ng1,ng1),shfe1(mx_nd_elt,ng1,ng1),shfe2(mx_nd_elt,ng1,ng1),STAT=alloc_st1)

    if ( (alloc_st == 0) .and. (alloc_st1 == 0) ) then ! If wwg1,shfv,shfe1,shfe2 are successfully allocated
 	  loop3a: do i = 1,ng1 ! Loop over all Gauss points
	     loop3b: do k = 1,ng1 ! Loop over all Gauss points
	  	wwg1(k,i) = wg1(i)*wg1(k)
	  	x = xi1(k); y = xi1(i)
	  	ym1 = 1.0_dp-y; xm1 = 1.0_dp-x; xy = x*y
	  	xyhlf = 0.5_dp*xy; ym1hlf = 0.5_dp*ym1; yp1hlf = 0.5_dp*(1.0_dp+y)

	  	shfv(1,k,i) = xm1; shfv(2,k,i) = x*ym1; shfv(3,k,i) = xy ! shape functions for vertex-adjacent case
	  	shfe1(1,k,i)= xyhlf; shfe1(2,k,i) = xm1 + xyhlf; shfe1(3,k,i) = x*ym1 ! shape functions for edge-adjacent case: E'
	  	shfe2(1,k,i)= 1.0_dp-x*yp1hlf; shfe2(2,k,i) = x*ym1hlf; shfe2(3,k,i) = xy ! shape functions for edge-adjacent case: E"
	
 	     enddo loop3b
 	  enddo loop3a
 	  deallocate(wg1)
    else
          if ( alloc_st /= 0 ) then ! If wwg1 is not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate array "wwg1" failed with Status=',alloc_st
	        stop
          endif

          if ( alloc_st1 /= 0 ) then ! If shfv,shfe1,shfe2 are not successfully allocated 
                write(*,*)'gbem_lap_init: Allocate arrays "shfv,shfe1,shfe2" failed with Status=',alloc_st1
	        stop
          endif
    endif 
!** End Initialize Gauss weights and shape functions for Singular integrations ********************!

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_lap_init
!----------------------------------------------------------------------------------------------------------------------------------!

!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_lap_assem
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!*********************************************  Assemble h and g influence matrices  **********************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012

 
USE KINDS
USE SRF_GEOM, ONLY: nbnd,nbelt  ! nbnd == Total number of boundary nodes
                                ! nbelt == Total number of boundary elements
USE DISCR_BIE,ONLY: h,g         ! h == Potential influence matrix <==> Coefficient matrix acting on the vector of boundary potentials
                                ! g == Flux influence matrix <==> Coefficient matrix acting on the vector of boundary fluxes
USE SRF_GEOM, ONLY: EltDiam     ! EltDiam(k) == Diameter of the k-th boundary element
USE SRF_GEOM, ONLY: EltAreax2   ! EltAreax2(k) = 2*Area of the k-th boundary element
USE SRF_GEOM, ONLY: shfe1,shfe2 ! shfe1(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for edge-adjacent integration: E'
				! shfe2(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for edge-adjacent integration: E"
USE SRF_GEOM, ONLY: shfv	! shfv(l,k,i) == l-th shape function evaluated at Gauss point (k,i) for vertex-adjacent integration
USE GAUSS1D,  ONLY: xi1,xi2,xi3 ! xi1,xi2,xi3 == Arrays to store Gauss-Legendre points for integration over a segment [0,1]
USE GAUSS1D,  ONLY: wwg1 ! wwg1(k,i) = wg1(i)*wg1(k), where wg1(k) is the k-th Gauss-Legendre weight factor corresponding to xi1(k)
USE GAUSS1D,  ONLY: wwg2 ! wwg2(k,i) = wg2(i)*wg2(k), where wg2(k) is the k-th Gauss-Legendre weight factor corresponding to xi2(k)
USE GAUSS1D,  ONLY: wwg3 ! wwg3(k,i) = wg3(i)*wg3(k), where wg3(k) is the k-th Gauss-Legendre weight factor corresponding to xi3(k)


IMPLICIT NONE

 character(len=1) :: flag='U' ! flag='U' <==> Integration type is Undefined
 integer(kind=k9) :: i,k,elP,elQ,alloc_st



    allocate(h(nbnd,nbnd),g(nbnd,nbnd),STAT=alloc_st)
    if ( alloc_st == 0 ) then ! If h,g are successfully allocated
          loop0a: do k=1,nbnd ! loop over all boundary nodes
             loop0b: do i=1,nbnd ! loop over all boundary nodes
                h(i,k) = 0.0_dp; g(i,k) = 0.0_dp
             enddo loop0b
          enddo loop0a  

!*** Assemble h and g influence matrices **********************************************************!
 	  loop1a: do elP=1,nbelt ! Loop over all boundary elements

 	     call gbem_lap_iex_int_c(elP) ! Element P and element Q coincide ==> Coincident integration

 	     loop1b: do elQ=elP+1,nbelt ! Loop over the remaining boundary elements

 	  	if (EltAreax2(elQ) >= EltAreax2(elP)) then ! EltAreax2(elQ) = 2*area(elQ)

 	  	  call int_type(elP,elQ,flag) ! Determine integration type ==> get flag

 	  	    if ( flag == 'E' ) then	         ! If element P and element Q share a common edge
 	  		call gbem_lap_iex_int_e(elP,elQ) ! Edge-adjacent integration

 	  	    elseif( flag == 'V' ) then           ! If element P and element Q share a common vertex
 	  		call gbem_lap_iex_int_v(elP,elQ) ! Vertex-adjacent integration
 
 	  	    else			         ! Element P and element Q are not adjoining
 	  		call gbem_lap_iex_int(elP,elQ)   ! Non-Singular integration
 	  	    endif
 	  	else ! EltAreax2(elQ) < EltAreax2(elP)

 	  	  call int_type(elQ,elP,flag) ! Determine integration type ==> get flag

 	  	    if ( flag == 'E' ) then	         ! If element Q and element P share a common edge
 	  		call gbem_lap_iex_int_e(elQ,elP) ! Edge-adjacent integration
 
 	  	    elseif( flag == 'V' ) then           ! If element Q and element P share a common vertex
 	  		call gbem_lap_iex_int_v(elQ,elP) ! Vertex-adjacent integration
 
 	  	    else			         ! Element Q and element P are not adjoining
 	  		call gbem_lap_iex_int(elQ,elP)   ! Non-Singular integration
 	  	    endif
 	  	endif
 	     enddo loop1b
 	  enddo loop1a
!*** End Assemble h and g influence matrices ******************************************************!
    else
          write(*,*)'gbem_lap_assem: Allocate arrays "h,g" failed with Status=',alloc_st
          stop
    endif

    deallocate(shfv,shfe1,shfe2)
    deallocate(wwg1,wwg2,wwg3)
    deallocate(xi1,xi2,xi3)
    deallocate(EltAreax2,EltDiam)

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_lap_assem
!----------------------------------------------------------------------------------------------------------------------------------!

!**********************************************************************************************************************************!
!*****************************  Useful routines for generating and initializing computational cells  ******************************!
!**********************************************************************************************************************************!


!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_cell_init
!----------------------------------------------------------------------------------------------------------------------------------!	

!===purpose===! 

!**********************************************************************************************************************************!
!*************************************  Initialization of the computational parallelepiped  ***************************************!
!************************  Determine computational cells containing boundary nodes, i.e., non-empty cells  ************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012

 
USE KINDS
USE LNLST,    ONLY: ilst         ! ilst == derived type: Singly Linked List Structure
USE SRF_GEOM, ONLY: nbnd         ! nbnd == Total number of boundary nodes
USE SRF_GEOM, ONLY: bnd          ! bnd(:,k) == Cartesian coordinates of the k-th boundary node
USE CELL_ARP, ONLY: ncx,ncy,ncz  ! ncx,ncy,ncz == Total number of cells in the computational box in the x,y,z-coordinate
				 ! directions respectively
USE CELL_ARP, ONLY: ncell,ncwnd  ! ncell == Total number of cells in the homogeneous computational box: ncell = ncx*ncy*ncz
				 ! ncwnd == Number of computional Cells containing boundary nodes <==> number of non-empty cells
USE CELL_ARP, ONLY: cwnd,cell    ! cwnd(k) == Global index of the k-th non-empty cell
			         ! cell(k) == Structure containing information about the k-th cell


IMPLICIT NONE

 integer(kind=k9) :: i1,i2,i3,j,k,l1,l2,l3,cell_count,mxy,alloc_st
 type(ilst), pointer :: ptr ! ptr == temporary pointer to an element of the list referenced to by ptr_list
 real(kind=dp), parameter :: tol = 1.0E-14_dp
 real(kind=dp) :: xmin,xmax,ymin,ymax,zmin,zmax
 real(kind=dp) :: diam_box ! diam_box == Diameter of the computational box
 real(kind=dp) :: cell_length_x,cell_length_y,cell_length_z
 real(kind=dp) :: cell_side_l(3) ! cell_side_l(i) == Left-end of the current cell segment in the i-th coordinate direction
 real(kind=dp) :: cell_side_r(3) ! cell_side_r(i) == Right-end of the current cell segment in the i-th coordinate direction
 real(kind=dp) :: epsbx,epsby,epsbz ! epsbx,epsby,epsbz = Small pertubations of the computational Box in x-,y-,and z-coordinate directions
 real(kind=dp), external :: sqr_dist_pt_box ! sqr_dist_pt_box == SQUARE DISTANCE between a POINT and an AXIS-PARALLEL BOX in 3D space



    xmin = minval(bnd(1,:)); xmax = maxval(bnd(1,:))
    ymin = minval(bnd(2,:)); ymax = maxval(bnd(2,:))
    zmin = minval(bnd(3,:)); zmax = maxval(bnd(3,:))

    epsbx = xmax-xmin; epsby = ymax-ymin; epsbz = zmax-zmin
    diam_box = dsqrt(epsbx*epsbx + epsby*epsby + epsbz*epsbz) ! diam_box == Diameter of the computational box
    diam_box = 1000.0_dp*diam_box ! diam_box == 1000 times the actual diameter of the computational box
    epsbx = epsbx/diam_box; epsby = epsby/diam_box; epsbz = epsbz/diam_box
    
    xmin = xmin - epsbx; xmax = xmax + epsbx
    ymin = ymin - epsby; ymax = ymax + epsby
    zmin = zmin - epsbz; zmax = zmax + epsbz

    cell_length_x = (xmax-xmin)/real(ncx,dp) ! cell_length_x == Length of a single cell in the x-coordinate direction
    cell_length_y = (ymax-ymin)/real(ncy,dp) ! cell_length_y == Length of a single cell in the y-coordinate direction
    cell_length_z = (zmax-zmin)/real(ncz,dp) ! cell_length_z == Length of a single cell in the z-coordinate direction
    
    mxy = ncx*ncy
    ncell = mxy*ncz ! ncell == Total number of cells in the homogeneous computational box: ncell = ncx*ncy*ncz
    
    allocate(cell(ncell),STAT=alloc_st)
    if ( alloc_st /= 0 ) then  ! If cell is not successfully allocated
       write(*,*)'gbem_cell_init: Allocate array "cell" failed with Status=',alloc_st
       stop
    endif

    loop0: do k=1,ncell
       cell(k)%nnc = 0 ! cell(k)%nnc == Number of boundary nodes in the k-th cell
       nullify(cell(k)%ptr_list) ! Empty list
    enddo loop0
    
    cell_side_r(1) = xmin; cell_side_r(2) = ymin; cell_side_r(3) = zmin ! Collapsing cell
    loop1a: do i3=1,ncz ! Loop over all cells in the 3-rd coordinate direction (z-direction)
       cell_side_l(3) = cell_side_r(3)
       cell_side_r(3) = cell_side_l(3) + cell_length_z
       l3 = mxy*(i3-1)
       loop1b: do i2=1,ncy ! Loop over all cells in the 2-nd coordinate direction (y-direction)
     	  cell_side_l(2) = cell_side_r(2)
	  cell_side_r(2) = cell_side_l(2) + cell_length_y
	  l2 = ncx*(i2-1)
          loop1c: do i1=1,ncx ! Loop over all cells in the 1-st coordinate direction (x-direction)
	     cell_side_l(1) = cell_side_r(1)
	     cell_side_r(1) = cell_side_l(1) + cell_length_x
	     l1 = l3+l2+i1 ! l1 == Linear index of the current computational cell
	      ! cell(l1)%bbox == Bounding Box of the current cell
	      cell(l1)%bbox(1,1) = cell_side_l(1); cell(l1)%bbox(2,1) = cell_side_r(1) ! Bounding box in the x-direction
	      cell(l1)%bbox(1,2) = cell_side_l(2); cell(l1)%bbox(2,2) = cell_side_r(2) ! Bounding box in the y-direction
	      cell(l1)%bbox(1,3) = cell_side_l(3); cell(l1)%bbox(2,3) = cell_side_r(3) ! Bounding box in the z-direction

   	      if (i1 == ncx) then
	         cell_side_r(1) = xmin ! Collapsing cell in the 1-st coordinate direction
	         if (i2 == ncy) cell_side_r(2) = ymin ! Collapsing cell in the 2-nd coordinate direction
	      endif
          enddo loop1c
       enddo loop1b
    enddo loop1a

    loop2a: do k=1,nbnd ! Loop over all boundary nodes: k == Global index of the k-th boundary node
       loop2b: do l1=1,ncell ! Loop over all cells in the computational parallelepiped
       ! bnd(:,k) == Cartesian coordinates of the k-th boundary node
	  if (sqr_dist_pt_box(bnd(:,k),cell(l1)%bbox) < tol) then ! If bnd(:,k) falls in the current cell, then
	  							  ! sqr_dist_pt_box(bnd(:,k),cell(l1)%bbox) = 0.0
								  ! Tolerance "tol" is used to resolve the situation
	     call add_elt_in_cell(l1,k)                           ! when bnd(:,k) falls on a corner, edge or side of
	     exit						  ! the current cell. This call add_elt_in_cell(l1,k)
								  ! adds boundary node k into a cell with index l1
	  endif
       enddo loop2b
    enddo loop2a

!*** Initialization of non-empty cells
    cell_count = 0 ! cell_count == Number of cell with boundary nodes, i.e., non-empty cells
    loop5: do k=1,ncell ! Loop over all cells in the computational parallelepiped
       if (cell(k)%nnc /= 0) then ! if the k-th cell is not empty
          cell_count = cell_count + 1
          allocate(cell(k)%nd_id(cell(k)%nnc),STAT=alloc_st)
	  if ( alloc_st /= 0 ) then ! If cell(k)%nd_id is not successfully allocated
	     write(*,*)'gbem_cell_init: Allocate array "cell(k)%nd_id" failed k=',k,'with Status=',alloc_st
	     stop
	  endif
	  
	   loop6: do j=cell(k)%nnc,1,-1 ! Loop over all boundary nodes in the k-th non-empty cell
              ptr => cell(k)%ptr_list
               cell(k)%nd_id(j) = ptr%id
               cell(k)%ptr_list => ptr%next  
              deallocate(ptr)
           enddo loop6
       endif ! if the k-th cell is not empty
    enddo loop5
!*** End Initialization of non-empty cells
    
    ncwnd = cell_count ! ncwnd == Number of cells with boundary nodes, i.e., non-empty cells

    allocate(cwnd(ncwnd),STAT=alloc_st)
    if ( alloc_st /= 0 ) then  ! If cwnd is not successfully allocated
       write(*,*)'gbem_cell_init: Allocate array "cwnd" failed with Status=',alloc_st
       stop
    endif
   
    cell_count = 0
    loop7: do k=1,ncell
       if (cell(k)%nnc /= 0) then ! if the k-th cell is not empty
          cell_count = cell_count + 1
          cwnd(cell_count) = k
       endif ! if the k-th cell is not empty
    enddo loop7

!----------------------------------------------------------------------------------------------------------------------------------! 
END SUBROUTINE gbem_cell_init
!----------------------------------------------------------------------------------------------------------------------------------!	


!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_cell_neighbor
!----------------------------------------------------------------------------------------------------------------------------------!	

!===purpose===! 

!**********************************************************************************************************************************!
!************************************************  Find "Near-neighboring" cells  *************************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012

 
USE KINDS
USE LNLST,    ONLY: ilst       ! ilst == derived type: Singly Linked List Structure
USE CELL_ARP, ONLY: ncwnd      ! ncwnd == Number of computional Cells containing boundary nodes <==> number of non-empty cells
USE CELL_ARP, ONLY: nbfac      ! nbfac == Factor characterizing the near-neighboring region of a giving cell
USE CELL_ARP, ONLY: cwnd,cell  ! cwnd(k) == Global index of the k-th non-empty cell
			       ! cell(k) == Structure containing information about the k-th cell


IMPLICIT NONE

 integer(kind=k9) :: i,j,ii,alloc_st
 real   (kind=dp) :: cnt_cl(3),z(3),dist,z_c(3)
 real   (kind=dp) :: hlf_cl_len(3) ! hlf_cl_len(i) == Half-Length of a cell in the i-th axis direction
 real   (kind=dp) :: r_nbor ! r_nbor == nbfac*(D/2), D = diameter of a cell

 type pt_ilst 
  type(ilst), pointer :: p
 end type pt_ilst
 type(pt_ilst), pointer :: ptr_list(:) ! ptr_list(k)%p == pointer to the list of near-neighboring cells to the k-th cell
 type(ilst), pointer :: ptr1, ptr2 ! ptr1, ptr2 == temporary pointers to an element of the list referenced to by ptr_list



    allocate(ptr_list(ncwnd),STAT=alloc_st)
    if ( alloc_st /= 0 ) then  ! If ptr_list is not successfully allocated
       write(*,*)'gbem_cell_neighbor: Allocate array "ptr_list" failed with Status=',alloc_st
       stop
    endif

    loop0: do i=1,ncwnd ! Loop over all non-empty cells
       nullify(ptr_list(i)%p) ! Empty list for every non-empty cell
       cell(cwnd(i))%nnnc = 1 ! cell(cwnd(i))%nnnc == Number of near-neighboring cells to the i-th cell 
                              ! A cell is a near-neighbor to itself
    enddo loop0

    ! hlf_cl_len(1) == Half-Length of the 1st non-empty cell in the x-coordinate (or 1st-axis) direction
    hlf_cl_len(1) = 0.5_dp*(cell(cwnd(1))%bbox(2,1)-cell(cwnd(1))%bbox(1,1))
    
    ! hlf_cl_len(2) == Half-Length of the 1st non-empty cell in the y-coordinate (or 2nd-axis) direction
    hlf_cl_len(2) = 0.5_dp*(cell(cwnd(1))%bbox(2,2)-cell(cwnd(1))%bbox(1,2))
    
    ! hlf_cl_len(3) == Half-Length of the 1st non-empty cell in the z-coordinate (or 3rd-axis) direction
    hlf_cl_len(3) = 0.5_dp*(cell(cwnd(1))%bbox(2,3)-cell(cwnd(1))%bbox(1,3))
    
    r_nbor = nbfac*dsqrt(hlf_cl_len(1)*hlf_cl_len(1) + hlf_cl_len(2)*hlf_cl_len(2) + hlf_cl_len(3)*hlf_cl_len(3))

    loop1a: do i=1,ncwnd-1 ! Loop over all non-empty cells
       loop1b: do ii=1,3 ! Loop over the coordinate directions
	  cnt_cl(ii) = cell(cwnd(i))%bbox(1,ii) + hlf_cl_len(ii) ! cnt_cl == Center of the i-th cell
       enddo loop1b

         loop1c: do j=i+1,ncwnd ! Loop over the remaining non-empty cells
	       loop1d: do ii=1,3 ! Loop over the coordinate directions
	            z(ii) = cell(cwnd(j))%bbox(1,ii) + hlf_cl_len(ii) ! z == Center of the j-th cell
		    z_c(ii) = z(ii)-cnt_cl(ii)
	       enddo loop1d
	       dist = dsqrt(z_c(1)*z_c(1) + z_c(2)*z_c(2) + z_c(3)*z_c(3)) ! dist == Distance between the centers

!*** Near-neighboring region of the i-th cell is characterized by a Ball centered at cnt_cl with radius r_nbor
	       if ( dist < r_nbor) then ! If the Center of the j-th cell is in the Near-neighboring region of the i-th cell
	          cell(cwnd(i))%nnnc = cell(cwnd(i))%nnnc + 1; cell(cwnd(j))%nnnc = cell(cwnd(j))%nnnc + 1
                   allocate(ptr1,ptr2,STAT=alloc_st)
                    if(alloc_st /=0) then
		       write(*,*)'gbem_cell_neighbor: Allocate nodes for the list of near-neighbors failed with Status=',alloc_st
		       stop
		    endif
                      ptr1%id = cwnd(j) ! Adding an element to a linked list of the i-th cell
                      ptr1%next => ptr_list(i)%p; ptr_list(i)%p => ptr1
                      ptr2%id = cwnd(i) ! Adding an element to a linked list of the j-th cell
                      ptr2%next => ptr_list(j)%p; ptr_list(j)%p => ptr2
	       endif
         enddo loop1c
    enddo loop1a

!*** Read (to a usual dynamic array) and delete a linked list associated to a cell
    loop2a: do i=1,ncwnd ! Loop over all non-empty cells
      allocate(cell(cwnd(i))%nbor(cell(cwnd(i))%nnnc),STAT=alloc_st)
      if ( alloc_st /= 0 ) then  ! If cell(cwnd(i))%nbor is not successfully allocated
         write(*,*)'cell_neighbor: Allocate array "cell(cwnd(i))%nbor" failed with Status=',alloc_st
         stop
      endif
        ! cell(i)%nbor(k) == Global index of the k-th near-neighbor to the i-th cell

        loop2b: do j=cell(cwnd(i))%nnnc,2,-1 ! Loop over the near-neighboring cells to the i-th cell
           ptr1 => ptr_list(i)%p
           cell(cwnd(i))%nbor(j) = ptr1%id
           ptr_list(i)%p => ptr1%next  
           deallocate(ptr1)
        enddo loop2b
      cell(cwnd(i))%nbor(1) = cwnd(i) ! Adding the i-th cell to the array of its neighbor, since a cell is near-neighbor to itself
    enddo loop2a
    deallocate(ptr_list)

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_cell_neighbor
!----------------------------------------------------------------------------------------------------------------------------------!	


!----------------------------------------------------------------------------------------------------------------------------------! 
FUNCTION sqr_dist_pt_box(x,box)
!----------------------------------------------------------------------------------------------------------------------------------!	

!===purpose===! 


!**********************************************************************************************************************************!
!*****************************  Return the SQUARE DISTANCE between a POINT and an AXIS-PARALLEL BOX  ******************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata, Oak Ridge National Laboratory
!*** Version:   V.1.0
!*** Released:  Apr 21, 2011


USE KINDS


IMPLICIT NONE

 real   (kind=dp), intent(in) :: x(3) ! x == Arbitrary Point in 3D space
 real   (kind=dp), intent(in) :: box(2,3) ! box == Axis-parallel box
                                          ! [box(1,i),box(2,i)] = Segment forming the box in the i-th axis direction
 real   (kind=dp)             :: sqr_dist_pt_box ! sqr_dist_pt_box == SQUARE DISTANCE between a POINT and an AXIS-PARALLEL BOX
 real   (kind=dp)             :: dx,dy,dz ! dx = Distance in the x-coordinate direction
 					  ! dy = Distance in the y-coordinate direction
					  ! dz = Distance in the z-coordinate direction



    dx = max(box(1,1) - x(1), x(1) - box(2,1), 0.0_dp)
    dy = max(box(1,2) - x(2), x(2) - box(2,2), 0.0_dp)
    dz = max(box(1,3) - x(3), x(3) - box(2,3), 0.0_dp)
    sqr_dist_pt_box = dx*dx + dy*dy + dz*dz

!----------------------------------------------------------------------------------------------------------------------------------! 
END FUNCTION sqr_dist_pt_box
!----------------------------------------------------------------------------------------------------------------------------------!	


!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE add_elt_in_cell(Cell_id, elt_id)
!----------------------------------------------------------------------------------------------------------------------------------!	

!===purpose===! 

!**********************************************************************************************************************************!
!***************  Add a single element with global index elt_id in a computational cell with global index Cell_id  ****************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata, Oak Ridge National Laboratory
!*** Version:   V.1.0
!*** Released:  Apr 21, 2011

 
USE KINDS
USE LNLST,    ONLY: ilst ! ilst == derived type: Singly Linked List Structure
USE CELL_ARP, ONLY: cell ! cell(k) == Structure containing information about the k-th cell


IMPLICIT NONE

 integer(kind=k9), intent(in) :: Cell_id
 integer(kind=k9), intent(in) :: elt_id

 type(ilst), pointer :: ptr ! ptr == temporary pointer to an element of the list referenced to by cell(Cell_id)%ptr_list
 integer(kind=k9) :: alloc_st


    cell(Cell_id)%nnc = cell(Cell_id)%nnc + 1
    allocate(ptr,STAT=alloc_st)
    if(alloc_st /=0) then
       write(*,*)'add_elt_in_cell: Allocate a node for the cell list failed with Status=',alloc_st
       stop
    endif
    ptr%id = elt_id ! Adding an element to a linked list
    ptr%next => cell(Cell_id)%ptr_list; cell(Cell_id)%ptr_list => ptr

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE add_elt_in_cell
!----------------------------------------------------------------------------------------------------------------------------------!	

!----------------------------------------------------------------------------------------------------------------------------------!
SUBROUTINE gbem_lap_input(InfParams,InfData)
!----------------------------------------------------------------------------------------------------------------------------------!

!===purpose===! 

!**********************************************************************************************************************************!
!**********************************  GALERKIN BEM for 3D LAPLACE EQUATION: SINGULAR FORMULATION  **********************************!
!************************************  3-NODED TRIANGULAR ELEMENT: SEMI-ANALYTIC INTEGRATION  *************************************!
!************************************************  PIECEWISE LINEAR APPROXIMATION  ************************************************!
!**********************************************  Data input for 3D Laplace Equation  **********************************************!
!**********************************************************************************************************************************!

!*** Developer: Sylvain Nintcheu Fata
!*** Version:   V.1.1
!*** Released:  Jun 14, 2012

 
USE KINDS
USE PARAMS,   ONLY: gm_eps,f_eps ! gm_eps == Tolerance on the geometry, f_eps == Tolerance on the argument of a function
USE SRF_GEOM, ONLY: mx_nd_elt    ! mx_nd_elt == Maximum number of nodes per element
USE SRF_GEOM, ONLY: nbnd,nbelt   ! nbnd == Total number of boundary nodes, nbelt == Total number of boundary elements
USE SRF_GEOM, ONLY: belt         ! belt(:,i) == Global indices of boundary nodes on the i-th element
USE SRF_GEOM, ONLY: bnd          ! bnd(:,i) == Cartesian coordinates of the i-th boundary node
USE SRF_COND, ONLY: ndbc	 ! ndbc(i) = {0,1} ==> {Dirichlet,Neunamm} boundary condition is prescribed at bnd(:,i)
USE POTFLUX,  ONLY: pbv          ! pbv(i) == Prescribed Boundary Value at the i-th boundary node
USE GAUSS1D,  ONLY: ng1,ng2,ng3  ! ng1 == Number of Gauss-Legendre points over a segment [0,1] for Singular integrations
				 ! ng2 == Number of Gauss-Legendre points over a segment [0,1] for Quasi-singular integration
				 ! ng3 == Number of Gauss-Legendre points over a segment [0,1] for Non-singular integration
USE ITER_SOLV,ONLY: ldim         ! ldim == Dimension of the iterative solver BiCGSTAB(ldim)
USE ITER_SOLV,ONLY: mxmatvec     ! mxmatvec == Maximum number of matrix-vector mutiplications in the iterative solver BiCGSTAB(ldim)
USE ITER_SOLV,ONLY: slv_eps      ! slv_eps == Tolerance on the BiCGSTAB(ldim) iterative solver
USE CELL_ARP, ONLY: ncx,ncy,ncz  ! ncx,ncy,ncz == Total number of cells in the computational box in the x,y,z-coordinate
				 ! directions respectively
USE CELL_ARP, ONLY: nbfac        ! nbfac == Parameter characterizing the near-neighboring region of a given cell
USE PRECOND,  ONLY: sparseflg    ! sparseflg == Parameter that determines the sparsity pattern of the preconditoner
				 ! sparseflg = 0 ==> no preconditoner
				 ! sparseflg = 1 ==> the sparsity pattern of the preconditoner is given by Cell self-interactions
				 ! sparseflg = 1+n ==> the sparsity pattern of the preconditoner is given by Cell + n Neighbors interactions


IMPLICIT NONE

 character(len=72) :: InfParams,InfData 
 integer(kind=k9) :: i,alloc_st,alloc_st1,alloc_st2



    open (unit=54, file=InfParams, action='read')

!*** Read parameters
     read(54,*)ng1         ! ng1 == Number of Gauss-Legendre points over a segment [0,1] for Singular integrations
     read(54,*)ng2         ! ng2 == Number of Gauss-Legendre points over a segment [0,1] for Quasi-singular integration
     read(54,*)ng3         ! ng3 == Number of Gauss-Legendre points over a segment [0,1] for Non-singular integration
     read(54,*)gm_eps      ! gm_eps == Tolerance on the geometry
     read(54,*)f_eps       ! f_eps == Tolerance on the argument of a function
     read(54,*)ldim        ! ldim == Dimension of the BiCGSTAB(ldim)
     read(54,*)mxmatvec    ! mxmatvec == Maximum number of matrix-vector mutiplication in the iterative solver BiCGSTAB(ldim)
     read(54,*)slv_eps     ! slv_eps == Tolerance on the BiCGSTAB(ldim) iterative solver 
     read(54,*)ncx,ncy,ncz ! Parameters of the computational box containing the boundary mesh
     read(54,*)nbfac       ! nbfac == Neighbor Factor
     read(54,*)sparseflg   ! sparseflg == Parameter that determines the sparsity pattern of the preconditoner
    close(54)

    open (unit=55, file=InfData, action='read')

    read(55,*) nbnd  ! nbnd == Total number of boundary nodes
    read(55,*) nbelt ! nbelt == Total number of boundary elements

    allocate(bnd(3,nbnd),STAT=alloc_st) ! (bnd(1,i),bnd(2,i),bnd(3,i)) == Cartesian coordinates of the i-th boundary node
    allocate(pbv(nbnd),  STAT=alloc_st1)
    allocate(ndbc(nbnd), STAT=alloc_st2)
     if ( (alloc_st == 0) .and. (alloc_st1 == 0) .and. (alloc_st2 == 0) ) then ! If bnd, pbv, ndbc are successfully allocated
!*** Read the Cartesian coordinates, Prescribed Boundary Value and characteristics of each boundary node
          loop0: do i=1,nbnd ! Loop over all boundary nodes
             read(55,*)  bnd(1,i), bnd(2,i), bnd(3,i), pbv(i), ndbc(i)
          enddo loop0
     else
          if ( alloc_st /= 0 ) then ! If bnd is not successfully allocated 
                write(*,*)'gbem_lap_input: Allocate array "bnd" failed with Status=',alloc_st
	        stop
          endif

          if ( alloc_st1 /= 0 ) then ! If pbv is not successfully allocated 
                write(*,*)'gbem_lap_input: Allocate array "pbv" failed with Status=',alloc_st1
	        stop
          endif

          if ( alloc_st2 /= 0 ) then ! If ndbc is not successfully allocated 
                write(*,*)'gbem_lap_input: Allocate array "ndbc" failed with Status=',alloc_st2
	        stop
          endif
     endif


    allocate(belt(mx_nd_elt,nbelt),STAT=alloc_st)
     if ( alloc_st == 0 ) then ! If belt is successfully allocated 
!*** Read the connectivity of each boundary element
          loop1: do i=1,nbelt ! Loop over boundary elements
             read(55,*) belt(1,i),belt(2,i),belt(3,i) ! element connectivity of the i-th boundary element
          enddo loop1
     else
          write(*,*)'gbem_lap_input: Allocate array "belt" failed with Status=',alloc_st
	  stop
     endif

close (unit=55, status='keep')

!----------------------------------------------------------------------------------------------------------------------------------!
END SUBROUTINE gbem_lap_input
!----------------------------------------------------------------------------------------------------------------------------------!
